
 { to form two full matrixes
   one to change from the TRS to CRS 
   the other to change from CRS to TRS }

 UNIT Un2000tc ;

 INTERFACE

 Uses
   UnConTyp ; { TMatr33 }

 Procedure TerraSimpleMatr ( JulDat  : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;

 Procedure TerraSelestMatr ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             deltax , deltay   : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;

 Procedure TerraSelestMats ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             deltax , deltay   : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;

 Procedure TerraSelestMapp ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             deltax , deltay   : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;

 Procedure TerraIntEquMatr ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             Var  TerEquT , TruEquT  : TMatr33 ) ;

 IMPLEMENTATION

 Uses
   UnWM2000 , { for WMatr2000 }
   Un2000_r , { for RMatr2000 }
   UnQM2000 , { for QMatr2000 }
   UnForFun ; { for ToMultMatr }

 { simple procedure for matrixes
   only with the Earth rotation angle theta }

 Procedure TerraSimpleMatr ( JulDat  : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;
 Var
   i,j  : Byte ;
 Begin
   RMatr2000(JulDat,TerSelM); { R(t) = R_3(-theta(UT1)) from Un2000_r }
   For i:=1 To 3 Do
     For j:=1 To 3 Do
       SelTerM[j,i]:=TerSelM[i,j]; { inversion as transponier }
 End;

 { JulDat is Terrestrial Time TT in julian day
   JulUT1 is Universal Time UT1 = UTC+DelatUT1 in julian day
   xpolec , ypolec are current IERS value for pole motion in arcsec
   deltax , deltay are current IERS value deltaX , deltaY in arcsec
   more complex procedure with theoretical values xpole ypole in WMatr }

 Procedure TerraSelestMatr ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             deltax , deltay   : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;
 Var
   i,j  : Byte ;
   q,r,w,qr  : TMatr33 ;
 Begin
   WMatr2000(JulDat,xpolec,ypolec,w); { W(t) with s' y_p x_p }
   RMatr2000(JulUT1,r); { R(t) = R_3(-theta(UT1)) }
   QMatr2000(JulDat,deltax,deltay,q); { Q(t) with X+dx Y+dy s(t) }
   ToMultMatr(q,r,qr); { full Q(t)*R(-theta) matrix }
   ToMultMatr(qr,w,TerSelM);
   For i:=1 To 3 Do
     For j:=1 To 3 Do
       SelTerM[j,i]:=TerSelM[i,j]; { inversion as transponier }
 End;

 { JulDat is Terrestrial Time TT in julian day
   JulUT1 is Universal Time UT1 = UTC+DelatUT1 in julian day
   xpolec , ypolec are current IERS value for pole motion in arcsec
   deltax , deltay are current IERS value deltaX , deltaY in arcsec
   more simple procedure without theoretical values xpole ypole in WMats }

 Procedure TerraSelestMats ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             deltax , deltay   : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;
 Var
   i,j  : Byte ;
   q,r,w,qr  : TMatr33 ;
 Begin
   WMats2000(JulDat,xpolec,ypolec,w); { W(t) with s' y_p x_p }
   RMatr2000(JulUT1,r); { R(t) = R_3(-theta(UT1)) }
   QMatr2000(JulDat,deltax,deltay,q); { Q(t) with X+dx Y+dy s(t) }
   ToMultMatr(q,r,qr); { full Q(t)*R(-theta) matrix }
   ToMultMatr(qr,w,TerSelM);
   For i:=1 To 3 Do
     For j:=1 To 3 Do
       SelTerM[j,i]:=TerSelM[i,j]; { inversion as transponier }
 End;

 { JulDat is Terrestrial Time TT in julian day
   JulUT1 is Universal Time UT1 = UTC+DelatUT1 in julian day
   xpolec , ypolec are current IERS value for pole motion in arcsec
   deltax , deltay are current IERS value deltaX , deltaY in arcsec
   more complex procedure with theoretical values xpole ypole in WMatr
   Earth Orientation Parameters  X Y s(t) in binary file  parmaps.pat
   as coefficients of the Chebyshev approximation }

 Procedure TerraSelestMapp ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             deltax , deltay   : Extended ;
                             Var  TerSelM , SelTerM  : TMatr33 ) ;
 Var
   i,j  : Byte ;
   w,q  : TMatr33 ;
 Begin
   WMatr2000(JulDat,xpolec,ypolec,w); { W(t) with s' y_p x_p }
   QRMapp2000(JulDat,JulUT1,deltax,deltay,q); { Q(t)*R(-theta) UnQM2000 }
   ToMultMatr(q,w,TerSelM);
   For i:=1 To 3 Do
     For j:=1 To 3 Do
       SelTerM[j,i]:=TerSelM[i,j]; { inversion as transponier }
 End;

 { to change from terrestrial system
      to the intermediate equator system }

 Procedure TerraIntEquMatr ( JulDat , JulUT1   : Extended ;
                             xpolec , ypolec   : Extended ;
                             Var  TerEquT , TruEquT  : TMatr33 ) ;
 Var
   i,j  : Byte ;    { counts }
   w,r  : TMatr33 ; { matrix W(t) R(-\theta) }
 Begin
   WMatr2000(JulDat,xpolec,ypolec,w); { W(t) with s' y_p x_p }
   RMatr2000(JulUT1,r);     { R(t) = R_3(-theta(UT1)) }
   ToMultMatr(r,w,TerEquT); { R(t)*W(t) from terra to intermediate equa }
   For i:=1 To 3 Do
     For j:=1 To 3 Do
       TruEquT[j,i]:=TerEquT[i,j]; { inversion as transponier }
 End;

 END.
