
 { in units
   UnConTyp  are types , constants
   Un2000_C  are simple procedures for arguments
   Un2000_L  is procedure to calculate the Luni-Solar nutation
   Un2000_P  is procedure to calculate the planetary terms
   UnPN2000  are the procedures to obtain matrixes.
   a try to calculate with MHB2000A precession/nutation theory
   Resolution B1.6
   of General Assembly of the International Astronomical Union 
   from  IERS Conventions 2000 , web site
   http:\\maia.usno.navy.mil\conv2000.html }

 UNIT Un2000_L ;

 INTERFACE

 Type
   TOneAmp   = Record
                 n  : Word ;
                 a  : Single ;
               End;

 Procedure NutParmLuSo  ( DateJulian  : Extended ;
                          Var   DPsi  : Extended ;
                          Var   DEps  : Extended ) ;

 IMPLEMENTATION

 Uses
   UnConTyp , { for type TFundArg }
   Un2000_C ; { for FundArgLuSo }

 { to use the numbers from memory but with big memory needing
   nutation in longitude DPsi in ArcSec
   nutation in obliquity DEps in ArcSec }

 Procedure NutParmLuSo  ( DateJulian  : Extended ;
                          Var   DPsi  : Extended ;
                          Var   DEps  : Extended ) ;
 Const
   NArgLuSo  : Array [1..678,1..5] of ShortInt =
 ( ( 0, 0, 0, 0, 1), ( 0, 0, 2,-2, 2), ( 0, 0, 2, 0, 2), ( 0, 0, 0, 0, 2),
   ( 0, 1, 0, 0, 0), ( 0, 1, 2,-2, 2), ( 1, 0, 0, 0, 0), ( 0, 0, 2, 0, 1),
   ( 1, 0, 2, 0, 2), ( 0,-1, 2,-2, 2), ( 0, 0, 2,-2, 1), (-1, 0, 2, 0, 2),
   (-1, 0, 0, 2, 0), ( 1, 0, 0, 0, 1), (-1, 0, 0, 0, 1), (-1, 0, 2, 2, 2),
   ( 1, 0, 2, 0, 1), (-2, 0, 2, 0, 1), ( 0, 0, 0, 2, 0), ( 0, 0, 2, 2, 2),
   ( 0,-2, 2,-2, 2), (-2, 0, 0, 2, 0), ( 2, 0, 2, 0, 2), ( 1, 0, 2,-2, 2),
   (-1, 0, 2, 0, 1), ( 2, 0, 0, 0, 0), ( 0, 0, 2, 0, 0), ( 0, 1, 0, 0, 1),
   (-1, 0, 0, 2, 1), ( 0, 2, 2,-2, 2), ( 0, 0,-2, 2, 0), ( 1, 0, 0,-2, 1),
   ( 0,-1, 0, 0, 1), (-1, 0, 2, 2, 1), ( 0, 2, 0, 0, 0), ( 1, 0, 2, 2, 2),
   (-2, 0, 2, 0, 0), ( 0, 1, 2, 0, 2), ( 0, 0, 2, 2, 1), ( 0,-1, 2, 0, 2),
   ( 0, 0, 0, 2, 1), ( 1, 0, 2,-2, 1), ( 2, 0, 2,-2, 2), (-2, 0, 0, 2, 1),
   ( 2, 0, 2, 0, 1), ( 0,-1, 2,-2, 1), ( 0, 0, 0,-2, 1), (-1,-1, 0, 2, 0),
   ( 2, 0, 0,-2, 1), ( 1, 0, 0, 2, 0), ( 0, 1, 2,-2, 1), ( 1,-1, 0, 0, 0),
   (-2, 0, 2, 0, 2), ( 3, 0, 2, 0, 2), ( 0,-1, 0, 2, 0), ( 1,-1, 2, 0, 2),
   ( 0, 0, 0, 1, 0), (-1,-1, 2, 2, 2), (-1, 0, 2, 0, 0), ( 0,-1, 2, 2, 2),
   (-2, 0, 0, 0, 1), ( 1, 1, 2, 0, 2), ( 2, 0, 0, 0, 1), (-1, 1, 0, 1, 0),
   ( 1, 1, 0, 0, 0), ( 1, 0, 2, 0, 0), (-1, 0, 2,-2, 1), ( 1, 0, 0, 0, 2),
   (-1, 0, 0, 1, 0), ( 0, 0, 2, 1, 2), (-1, 0, 2, 4, 2), (-1, 1, 0, 1, 1),
   ( 0,-2, 2,-2, 1), ( 1, 0, 2, 2, 1), (-2, 0, 2, 2, 2), (-1, 0, 0, 0, 2),
   ( 1, 1, 2,-2, 2), (-2, 0, 2, 4, 2), (-1, 0, 4, 0, 2), ( 2, 0, 2,-2, 1),
   ( 2, 0, 2, 2, 2), ( 1, 0, 0, 2, 1), ( 3, 0, 0, 0, 0), ( 3, 0, 2,-2, 2),
   ( 0, 0, 4,-2, 2), ( 0, 1, 2, 0, 1), ( 0, 0,-2, 2, 1), ( 0, 0, 2,-2, 3),
   (-1, 0, 0, 4, 0), ( 2, 0,-2, 0, 1), (-2, 0, 0, 4, 0), (-1,-1, 0, 2, 1),
   (-1, 0, 0, 1, 1), ( 0, 1, 0, 0, 2), ( 0, 0,-2, 0, 1), ( 0,-1, 2, 0, 1),
   ( 0, 0, 2,-1, 2), ( 0, 0, 2, 4, 2), (-2,-1, 0, 2, 0), ( 1, 1, 0,-2, 1),
   (-1, 1, 0, 2, 0), (-1, 1, 0, 1, 2), ( 1,-1, 0, 0, 1), ( 1,-1, 2, 2, 2),
   (-1, 1, 2, 2, 2), ( 3, 0, 2, 0, 1), ( 0, 1,-2, 2, 0), (-1, 0, 0,-2, 1),
   ( 0, 1, 2, 2, 2), (-1,-1, 2, 2, 1), ( 0,-1, 0, 0, 2), ( 1, 0, 2,-4, 1),
   (-1, 0,-2, 2, 0), ( 0,-1, 2, 2, 1), ( 2,-1, 2, 0, 2), ( 0, 0, 0, 2, 2),
   ( 1,-1, 2, 0, 1), (-1, 1, 2, 0, 2), ( 0, 1, 0, 2, 0), ( 0,-1,-2, 2, 0),
   ( 0, 3, 2,-2, 2), ( 0, 0, 0, 1, 1), (-1, 0, 2, 2, 0), ( 2, 1, 2, 0, 2),
   ( 1, 1, 0, 0, 1), ( 1, 1, 2, 0, 1), ( 2, 0, 0, 2, 0), ( 1, 0,-2, 2, 0),
   (-1, 0, 0, 2, 2), ( 0, 1, 0, 1, 0), ( 0, 1, 0,-2, 1), (-1, 0, 2,-2, 2),
   ( 0, 0, 0,-1, 1), (-1, 1, 0, 0, 1), ( 1, 0, 2,-1, 2), ( 1,-1, 0, 2, 0),
   ( 0, 0, 0, 4, 0), ( 1, 0, 2, 1, 2), ( 0, 0, 2, 1, 1), ( 1, 0, 0,-2, 2),
   (-1, 0, 2, 4, 1), ( 1, 0,-2, 0, 1), ( 1, 1, 2,-2, 1), ( 0, 0, 2, 2, 0),
   (-1, 0, 2,-1, 1), (-2, 0, 2, 2, 1), ( 4, 0, 2, 0, 2), ( 2,-1, 0, 0, 0),
   ( 2, 1, 2,-2, 2), ( 0, 1, 2, 1, 2), ( 1, 0, 4,-2, 2), (-1,-1, 0, 0, 1),
   ( 0, 1, 0, 2, 1), (-2, 0, 2, 4, 1), ( 2, 0, 2, 0, 0), ( 1, 0, 0, 1, 0),
   (-1, 0, 0, 4, 1), (-1, 0, 4, 0, 1), ( 2, 0, 2, 2, 1), ( 0, 0, 2,-3, 2),
   (-1,-2, 0, 2, 0), ( 2, 1, 0, 0, 0), ( 0, 0, 4, 0, 2), ( 0, 0, 0, 0, 3),
   ( 0, 3, 0, 0, 0), ( 0, 0, 2,-4, 1), ( 0,-1, 0, 2, 1), ( 0, 0, 0, 4, 1),
   (-1,-1, 2, 4, 2), ( 1, 0, 2, 4, 2), (-2, 2, 0, 2, 0), (-2,-1, 2, 0, 1),
   (-2, 0, 0, 2, 2), (-1,-1, 2, 0, 2), ( 0, 0, 4,-2, 1), ( 3, 0, 2,-2, 1),
   (-2,-1, 0, 2, 1), ( 1, 0, 0,-1, 1), ( 0,-2, 0, 2, 0), (-2, 0, 0, 4, 1),
   (-3, 0, 0, 0, 1), ( 1, 1, 2, 2, 2), ( 0, 0, 2, 4, 1), ( 3, 0, 2, 2, 2),
   (-1, 1, 2,-2, 1), ( 2, 0, 0,-4, 1), ( 0, 0, 0,-2, 2), ( 2, 0, 2,-4, 1),
   (-1, 1, 0, 2, 1), ( 0, 0, 2,-1, 1), ( 0,-2, 2, 2, 2), ( 2, 0, 0, 2, 1),
   ( 4, 0, 2,-2, 2), ( 2, 0, 0,-2, 2), ( 0, 2, 0, 0, 1), ( 1, 0, 0,-4, 1),
   ( 0, 2, 2,-2, 1), (-3, 0, 0, 4, 0), (-1, 1, 2, 0, 1), (-1,-1, 0, 4, 0),
   (-1,-2, 2, 2, 2), (-2,-1, 2, 4, 2), ( 1,-1, 2, 2, 1), (-2, 1, 0, 2, 0),
   (-2, 1, 2, 0, 1), ( 2, 1, 0,-2, 1), (-3, 0, 2, 0, 1), (-2, 0, 2,-2, 1),
   (-1, 1, 0, 2, 2), ( 0,-1, 2,-1, 2), (-1, 0, 4,-2, 2), ( 0,-2, 2, 0, 2),
   (-1, 0, 2, 1, 2), ( 2, 0, 0, 0, 2), ( 0, 0, 2, 0, 3), (-2, 0, 4, 0, 2),
   (-1, 0,-2, 0, 1), (-1, 1, 2, 2, 1), ( 3, 0, 0, 0, 1), (-1, 0, 2, 3, 2),
   ( 2,-1, 2, 0, 1), ( 0, 1, 2, 2, 1), ( 0,-1, 2, 4, 2), ( 2,-1, 2, 2, 2),
   ( 0, 2,-2, 2, 0), (-1,-1, 2,-1, 1), ( 0,-2, 0, 0, 1), ( 1, 0, 2,-4, 2),
   ( 1,-1, 0,-2, 1), (-1,-1, 2, 0, 1), ( 1,-1, 2,-2, 2), (-2,-1, 0, 4, 0),
   (-1, 0, 0, 3, 0), (-2,-1, 2, 2, 2), ( 0, 2, 2, 0, 2), ( 1, 1, 0, 2, 0),
   ( 2, 0, 2,-1, 2), ( 1, 0, 2, 1, 1), ( 4, 0, 0, 0, 0), ( 2, 1, 2, 0, 1),
   ( 3,-1, 2, 0, 2), (-2, 2, 0, 2, 1), ( 1, 0, 2,-3, 1), ( 1, 1, 2,-4, 1),
   (-1,-1, 2,-2, 1), ( 0,-1, 0,-1, 1), ( 0,-1, 0,-2, 1), (-2, 0, 0, 0, 2),
   (-2, 0,-2, 2, 0), (-1, 0,-2, 4, 0), ( 1,-2, 0, 0, 0), ( 0, 1, 0, 1, 1),
   (-1, 2, 0, 2, 0), ( 1,-1, 2,-2, 1), ( 1, 2, 2,-2, 2), ( 2,-1, 2,-2, 2),
   ( 1, 0, 2,-1, 1), ( 2, 1, 2,-2, 1), (-2, 0, 0,-2, 1), ( 1,-2, 2, 0, 2),
   ( 0, 1, 2, 1, 1), ( 1, 0, 4,-2, 1), (-2, 0, 4, 2, 2), ( 1, 1, 2, 1, 2),
   ( 1, 0, 0, 4, 0), ( 1, 0, 2, 2, 0), ( 2, 0, 2, 1, 2), ( 3, 1, 2, 0, 2),
   ( 4, 0, 2, 0, 1), (-2,-1, 2, 0, 0), ( 0, 1,-2, 2, 1), ( 1, 0,-2, 1, 0),
   ( 0,-1,-2, 2, 1), ( 2,-1, 0,-2, 1), (-1, 0, 2,-1, 2), ( 1, 0, 2,-3, 2),
   ( 0, 1, 2,-2, 3), ( 0, 0, 2,-3, 1), (-1, 0,-2, 2, 1), ( 0, 0, 2,-4, 2),
   (-2, 1, 0, 0, 1), (-1, 0, 0,-1, 1), ( 2, 0, 2,-4, 2), ( 0, 0, 4,-4, 4),
   ( 0, 0, 4,-4, 2), (-1,-2, 0, 2, 1), (-2, 0, 0, 3, 0), ( 1, 0,-2, 2, 1),
   (-3, 0, 2, 2, 2), (-3, 0, 2, 2, 1), (-2, 0, 2, 2, 0), ( 2,-1, 0, 0, 1),
   (-2, 1, 2, 2, 2), ( 1, 1, 0, 1, 0), ( 0, 1, 4,-2, 2), (-1, 1, 0,-2, 1),
   ( 0, 0, 0,-4, 1), ( 1,-1, 0, 2, 1), ( 1, 1, 0, 2, 1), (-1, 2, 2, 2, 2),
   ( 3, 1, 2,-2, 2), ( 0,-1, 0, 4, 0), ( 2,-1, 0, 2, 0), ( 0, 0, 4, 0, 1),
   ( 2, 0, 4,-2, 2), (-1,-1, 2, 4, 1), ( 1, 0, 0, 4, 1), ( 1,-2, 2, 2, 2),
   ( 0, 0, 2, 3, 2), (-1, 1, 2, 4, 2), ( 3, 0, 0, 2, 0), (-1, 0, 4, 2, 2),
   ( 1, 1, 2, 2, 1), (-2, 0, 2, 6, 2), ( 2, 1, 2, 2, 2), (-1, 0, 2, 6, 2),
   ( 1, 0, 2, 4, 1), ( 2, 0, 2, 4, 2), ( 1, 1,-2, 1, 0), (-3, 1, 2, 1, 2),
   ( 2, 0,-2, 0, 2), (-1, 0, 0, 1, 2), (-4, 0, 2, 2, 1), (-1,-1, 0, 1, 0),
   ( 0, 0,-2, 2, 2), ( 1, 0, 0,-1, 2), ( 0,-1, 2,-2, 3), (-2, 1, 2, 0, 0),
   ( 0, 0, 2,-2, 4), (-2,-2, 0, 2, 0), (-2, 0,-2, 4, 0), ( 0,-2,-2, 2, 0),
   ( 1, 2, 0,-2, 1), ( 3, 0, 0,-4, 1), (-1, 1, 2,-2, 2), ( 1,-1, 2,-4, 1),
   ( 1, 1, 0,-2, 2), (-3, 0, 2, 0, 0), (-3, 0, 2, 0, 2), (-2, 0, 0, 1, 0),
   ( 0, 0,-2, 1, 0), (-3, 0, 0, 2, 1), (-1,-1,-2, 2, 0), ( 0, 1, 2,-4, 1),
   ( 2, 1, 0,-4, 1), ( 0, 2, 0,-2, 1), ( 1, 0, 0,-3, 1), (-2, 0, 2,-2, 2),
   (-2,-1, 0, 0, 1), (-4, 0, 0, 2, 0), ( 1, 1, 0,-4, 1), (-1, 0, 2,-4, 1),
   ( 0, 0, 4,-4, 1), ( 0, 3, 2,-2, 2), (-3,-1, 0, 4, 0), (-3, 0, 0, 4, 1),
   ( 1,-1,-2, 2, 0), (-1,-1, 0, 2, 2), ( 1,-2, 0, 0, 1), ( 1,-1, 0, 0, 2),
   ( 0, 0, 0, 1, 2), (-1,-1, 2, 0, 0), ( 1,-2, 2,-2, 2), ( 0,-1, 2,-1, 1),
   (-1, 0, 2, 0, 3), ( 1, 1, 0, 0, 2), (-1, 1, 2, 0, 0), ( 1, 2, 0, 0, 0),
   (-1, 2, 2, 0, 2), (-1, 0, 4,-2, 1), ( 3, 0, 2,-4, 2), ( 1, 2, 2,-2, 1),
   ( 1, 0, 4,-4, 2), (-2,-1, 0, 4, 1), ( 0,-1, 0, 2, 2), (-2, 1, 0, 4, 0),
   (-2,-1, 2, 2, 1), ( 2, 0,-2, 2, 0), ( 1, 0, 0, 1, 1), ( 0, 1, 0, 2, 2),
   ( 1,-1, 2,-1, 2), (-2, 0, 4, 0, 1), ( 2, 1, 0, 0, 1), ( 0, 1, 2, 0, 0),
   ( 0,-1, 4,-2, 2), ( 0, 0, 4,-2, 4), ( 0, 2, 2, 0, 1), (-3, 0, 0, 6, 0),
   (-1,-1, 0, 4, 1), ( 1,-2, 0, 2, 0), (-1, 0, 0, 4, 2), (-1,-2, 2, 2, 1),
   (-1, 0, 0,-2, 2), ( 1, 0,-2,-2, 1), ( 0, 0,-2,-2, 1), (-2, 0,-2, 0, 1),
   ( 0, 0, 0, 3, 1), ( 0, 0, 0, 3, 0), (-1, 1, 0, 4, 0), (-1,-1, 2, 2, 0),
   (-2, 0, 2, 3, 2), ( 1, 0, 0, 2, 2), ( 0,-1, 2, 1, 2), ( 3,-1, 0, 0, 0),
   ( 2, 0, 0, 1, 0), ( 1,-1, 2, 0, 0), ( 0, 0, 2, 1, 0), ( 1, 0, 2, 0, 3),
   ( 3, 1, 0, 0, 0), ( 3,-1, 2,-2, 2), ( 2, 0, 2,-1, 1), ( 1, 1, 2, 0, 0),
   ( 0, 0, 4,-1, 2), ( 1, 2, 2, 0, 2), (-2, 0, 0, 6, 0), ( 0,-1, 0, 4, 1),
   (-2,-1, 2, 4, 1), ( 0,-2, 2, 2, 1), ( 0,-1, 2, 2, 0), (-1, 0, 2, 3, 1),
   (-2, 1, 2, 4, 2), ( 2, 0, 0, 2, 2), ( 2,-2, 2, 0, 2), (-1, 1, 2, 3, 2),
   ( 3, 0, 2,-1, 2), ( 4, 0, 2,-2, 1), (-1, 0, 0, 6, 0), (-1,-2, 2, 4, 2),
   (-3, 0, 2, 6, 2), (-1, 0, 2, 4, 0), ( 3, 0, 0, 2, 1), ( 3,-1, 2, 0, 1),
   ( 3, 0, 2, 0, 0), ( 1, 0, 4, 0, 2), ( 5, 0, 2,-2, 2), ( 0,-1, 2, 4, 1),
   ( 2,-1, 2, 2, 1), ( 0, 1, 2, 4, 2), ( 1,-1, 2, 4, 2), ( 3,-1, 2, 2, 2),
   ( 3, 0, 2, 2, 1), ( 5, 0, 2, 0, 2), ( 0, 0, 2, 6, 2), ( 4, 0, 2, 2, 2),
   ( 0,-1, 1,-1, 1), (-1, 0, 1, 0, 3), ( 0,-2, 2,-2, 3), ( 1, 0,-1, 0, 1),
   ( 2,-2, 0,-2, 1), (-1, 0, 1, 0, 2), (-1, 0, 1, 0, 1), (-1,-1, 2,-1, 2),
   (-2, 2, 0, 2, 2), (-1, 0, 1, 0, 0), (-4, 1, 2, 2, 2), (-3, 0, 2, 1, 1),
   (-2,-1, 2, 0, 2), ( 1, 0,-2, 1, 1), ( 2,-1,-2, 0, 1), (-4, 0, 2, 2, 0),
   (-3, 1, 0, 3, 0), (-1, 0,-1, 2, 0), ( 0,-2, 0, 0, 2), ( 0,-2, 0, 0, 2),
   (-3, 0, 0, 3, 0), (-2,-1, 0, 2, 2), (-1, 0,-2, 3, 0), (-4, 0, 0, 4, 0),
   ( 2, 1,-2, 0, 1), ( 2,-1, 0,-2, 2), ( 0, 0, 1,-1, 0), (-1, 2, 0, 1, 0),
   (-2, 1, 2, 0, 2), ( 1, 1, 0,-1, 1), ( 1, 0, 1,-2, 1), ( 0, 2, 0, 0, 2),
   ( 1,-1, 2,-3, 1), (-1, 1, 2,-1, 1), (-2, 0, 4,-2, 2), (-2, 0, 4,-2, 1),
   (-2,-2, 0, 2, 1), (-2, 0,-2, 4, 0), ( 1, 2, 2,-4, 1), ( 1, 1, 2,-4, 2),
   (-1, 2, 2,-2, 1), ( 2, 0, 0,-3, 1), (-1, 2, 0, 0, 1), ( 0, 0, 0,-2, 0),
   (-1,-1, 2,-2, 2), (-1, 1, 0, 0, 2), ( 0, 0, 0,-1, 2), (-2, 1, 0, 1, 0),
   ( 1,-2, 0,-2, 1), ( 1, 0,-2, 0, 2), (-3, 1, 0, 2, 0), (-1, 1,-2, 2, 0),
   (-1,-1, 0, 0, 2), (-3, 0, 0, 2, 0), (-3,-1, 0, 2, 0), ( 2, 0, 2,-6, 1),
   ( 0, 1, 2,-4, 2), ( 2, 0, 0,-4, 2), (-2, 1, 2,-2, 1), ( 0,-1, 2,-4, 1),
   ( 0, 1, 0,-2, 2), (-1, 0, 0,-2, 0), ( 2, 0,-2,-2, 1), (-4, 0, 2, 0, 1),
   (-1,-1, 0,-1, 1), ( 0, 0,-2, 0, 2), (-3, 0, 0, 1, 0), (-1, 0,-2, 1, 0),
   (-2, 0,-2, 2, 1), ( 0, 0,-4, 2, 0), (-2,-1,-2, 2, 0), ( 1, 0, 2,-6, 1),
   (-1, 0, 2,-4, 2), ( 1, 0, 0,-4, 2), ( 2, 1, 2,-4, 2), ( 2, 1, 2,-4, 1),
   ( 0, 1, 4,-4, 4), ( 0, 1, 4,-4, 2), (-1,-1,-2, 4, 0), (-1,-3, 0, 2, 0),
   (-1, 0,-2, 4, 1), (-2,-1, 0, 3, 0), ( 0, 0,-2, 3, 0), (-2, 0, 0, 3, 1),
   ( 0,-1, 0, 1, 0), (-3, 0, 2, 2, 0), ( 1, 1,-2, 2, 0), (-1, 1, 0, 2, 2),
   ( 1,-2, 2,-2, 1), ( 0, 0, 1, 0, 2), ( 0, 0, 1, 0, 1), ( 0, 0, 1, 0, 0),
   (-1, 2, 0, 2, 1), ( 0, 0, 2, 0, 2), (-2, 0, 2, 0, 2), ( 2, 0, 0,-1, 1),
   ( 3, 0, 0,-2, 1), ( 1, 0, 2,-2, 3), ( 1, 2, 0, 0, 1), ( 2, 0, 2,-3, 2),
   (-1, 1, 4,-2, 2), (-2,-2, 0, 4, 0), ( 0,-3, 0, 2, 0), ( 0, 0,-2, 4, 0),
   (-1,-1, 0, 3, 0), (-2, 0, 0, 4, 2), (-1, 0, 0, 3, 1), ( 2,-2, 0, 0, 0),
   ( 1,-1, 0, 1, 0), (-1, 0, 0, 2, 0), ( 0,-2, 2, 0, 1), (-1, 0, 1, 2, 1),
   (-1, 1, 0, 3, 0), (-1,-1, 2, 1, 2), ( 0,-1, 2, 0, 0), (-2, 1, 2, 2, 1),
   ( 2,-2, 2,-2, 2), ( 1, 1, 0, 1, 1), ( 1, 0, 1, 0, 1), ( 1, 0, 1, 0, 0),
   ( 0, 2, 0, 2, 0), ( 2,-1, 2,-2, 1), ( 0,-1, 4,-2, 1), ( 0, 0, 4,-2, 3),
   ( 0, 1, 4,-2, 1), ( 4, 0, 2,-4, 2), ( 2, 2, 2,-2, 2), ( 2, 0, 4,-4, 2),
   (-1,-2, 0, 4, 0), (-1,-3, 2, 2, 2), (-3, 0, 2, 4, 2), (-3, 0, 2,-2, 1),
   (-1,-1, 0,-2, 1), (-3, 0, 0, 0, 2), (-3, 0,-2, 2, 0), ( 0, 1, 0,-4, 1),
   (-2, 1, 0,-2, 1), (-4, 0, 0, 0, 1), (-1, 0, 0,-4, 1), (-3, 0, 0,-2, 1),
   ( 0, 0, 0, 3, 2), (-1, 1, 0, 4, 1), ( 1,-2, 2, 0, 1), ( 0, 1, 0, 3, 0),
   (-1, 0, 2, 2, 3), ( 0, 0, 2, 2, 2), (-2, 0, 2, 2, 2), (-1, 1, 2, 2, 0),
   ( 3, 0, 0, 0, 2), ( 2, 1, 0, 1, 0), ( 2,-1, 2,-1, 2), ( 0, 0, 2, 0, 1),
   ( 0, 0, 3, 0, 3), ( 0, 0, 3, 0, 2), (-1, 2, 2, 2, 1), (-1, 0, 4, 0, 0),
   ( 1, 2, 2, 0, 1), ( 3, 1, 2,-2, 1), ( 1, 1, 4,-2, 2), (-2,-1, 0, 6, 0),
   ( 0,-2, 0, 4, 0), (-2, 0, 0, 6, 1), (-2,-2, 2, 4, 2), ( 0,-3, 2, 2, 2),
   ( 0, 0, 0, 4, 2), (-1,-1, 2, 3, 2), (-2, 0, 2, 4, 0), ( 2,-1, 0, 2, 1),
   ( 1, 0, 0, 3, 0), ( 0, 1, 0, 4, 1), ( 0, 1, 0, 4, 0), ( 1,-1, 2, 1, 2),
   ( 0, 0, 2, 2, 3), ( 1, 0, 2, 2, 2), (-1, 0, 2, 2, 2), (-2, 0, 4, 2, 1),
   ( 2, 1, 0, 2, 1), ( 2, 1, 0, 2, 0), ( 2,-1, 2, 0, 0), ( 1, 0, 2, 1, 0),
   ( 0, 1, 2, 2, 0), ( 2, 0, 2, 0, 3), ( 3, 0, 2, 0, 2), ( 1, 0, 2, 0, 2),
   ( 1, 0, 3, 0, 3), ( 1, 1, 2, 1, 1), ( 0, 2, 2, 2, 2), ( 2, 1, 2, 0, 0),
   ( 2, 0, 4,-2, 1), ( 4, 1, 2,-2, 2), (-1,-1, 0, 6, 0), (-3,-1, 2, 6, 2),
   (-1, 0, 0, 6, 1), (-3, 0, 2, 6, 1), ( 1,-1, 0, 4, 1), ( 1,-1, 0, 4, 0),
   (-2, 0, 2, 5, 2), ( 1,-2, 2, 2, 1), ( 3,-1, 0, 2, 0), ( 1,-1, 2, 2, 0),
   ( 0, 0, 2, 3, 1), (-1, 1, 2, 4, 1), ( 0, 1, 2, 3, 2), (-1, 0, 4, 2, 1),
   ( 2, 0, 2, 1, 1), ( 5, 0, 0, 0, 0), ( 2, 1, 2, 1, 2), ( 1, 0, 4, 0, 1),
   ( 3, 1, 2, 0, 1), ( 3, 0, 4,-2, 2), (-2,-1, 2, 6, 2), ( 0, 0, 0, 6, 0),
   ( 0,-2, 2, 4, 2), (-2, 0, 2, 6, 1), ( 2, 0, 0, 4, 1), ( 2, 0, 0, 4, 0),
   ( 2,-2, 2, 2, 2), ( 0, 0, 2, 4, 0), ( 1, 0, 2, 3, 2), ( 4, 0, 0, 2, 0),
   ( 2, 0, 2, 2, 0), ( 0, 0, 4, 2, 2), ( 4,-1, 2, 0, 2), ( 3, 0, 2, 1, 2),
   ( 2, 1, 2, 2, 1), ( 4, 1, 2, 0, 2), (-1,-1, 2, 6, 2), (-1, 0, 2, 6, 1),
   ( 1,-1, 2, 4, 1), ( 1, 1, 2, 4, 2), ( 3, 1, 2, 2, 2), ( 5, 0, 2, 0, 1),
   ( 2,-1, 2, 4, 2), ( 2, 0, 2, 4, 1) ) ;
 Const
   AmpPsi   : Array [1..13] of Double =
   ( -17206.4161 , -1317.0906 ,  -227.6413 ,  207.4554 ,  147.5877 ,
        -51.6821 ,    71.1159 ,   -38.7298 ,  -30.1461 ,   21.5829 ,
         12.8227 ,    12.3457 ,    15.6994 ) ;
   AmpEps   : Array [1..13] of Double =
   (   9205.2331 ,   573.0336 ,    97.8459 ,  -89.7492 ,    7.3871 ,
         22.4386 ,    -0.6750 ,    20.0728 ,   12.9025 ,   -9.5929 ,
         -6.8982 ,    -5.3311 ,    -0.1235 ) ;
   AmpPSin  : Array [1..646] of TOneAmp =
 ( ( n :  14 ; a :   6.3110 ) ,
   ( n :  15 ; a :  -5.7976 ) ,   ( n :  16 ; a :  -5.9641 ) ,
   ( n :  17 ; a :  -5.1613 ) ,   ( n :  18 ; a :   4.5893 ) ,
   ( n :  19 ; a :   6.3384 ) ,   ( n :  20 ; a :  -3.8571 ) ,
   ( n :  21 ; a :   3.2481 ) ,   ( n :  22 ; a :  -4.7722 ) ,
   ( n :  23 ; a :  -3.1046 ) ,   ( n :  24 ; a :   2.8593 ) ,
   ( n :  25 ; a :   2.0441 ) ,   ( n :  26 ; a :   2.9243 ) ,
   ( n :  27 ; a :   2.5887 ) ,   ( n :  28 ; a :  -1.4053 ) ,
   ( n :  29 ; a :   1.5164 ) ,   ( n :  30 ; a :  -1.5794 ) ,
   ( n :  31 ; a :   2.1783 ) ,   ( n :  32 ; a :  -1.2873 ) ,
   ( n :  33 ; a :  -1.2654 ) ,   ( n :  34 ; a :  -1.0204 ) ,
   ( n :  35 ; a :   1.6707 ) ,   ( n :  36 ; a :  -0.7691 ) ,
   ( n :  37 ; a :  -1.1024 ) ,   ( n :  38 ; a :   0.7566 ) ,
   ( n :  39 ; a :  -0.6637 ) ,   ( n :  40 ; a :  -0.7141 ) ,
   ( n :  41 ; a :  -0.6302 ) ,   ( n :  42 ; a :   0.5800 ) ,
   ( n :  43 ; a :   0.6443 ) ,   ( n :  44 ; a :  -0.5774 ) ,
   ( n :  45 ; a :  -0.5350 ) ,   ( n :  46 ; a :  -0.4752 ) ,
   ( n :  47 ; a :  -0.4940 ) ,   ( n :  48 ; a :   0.7350 ) ,
   ( n :  49 ; a :   0.4065 ) ,   ( n :  50 ; a :   0.6579 ) ,
   ( n :  51 ; a :   0.3579 ) ,   ( n :  52 ; a :   0.4725 ) ,
   ( n :  53 ; a :  -0.3075 ) ,   ( n :  54 ; a :  -0.2904 ) ,
   ( n :  55 ; a :   0.4348 ) ,   ( n :  56 ; a :  -0.2878 ) ,
   ( n :  57 ; a :  -0.4230 ) ,   ( n :  58 ; a :  -0.2819 ) ,
   ( n :  59 ; a :  -0.4056 ) ,   ( n :  60 ; a :  -0.2647 ) ,
   ( n :  61 ; a :  -0.2294 ) ,   ( n :  62 ; a :   0.2481 ) ,
   ( n :  63 ; a :   0.2179 ) ,   ( n :  64 ; a :   0.3276 ) ,
   ( n :  65 ; a :  -0.3389 ) ,   ( n :  66 ; a :   0.3339 ) ,
   ( n :  67 ; a :  -0.1987 ) ,   ( n :  68 ; a :  -0.1981 ) ,
   ( n :  69 ; a :   0.4026 ) ,   ( n :  70 ; a :   0.1660 ) ,
   ( n :  71 ; a :  -0.1521 ) ,   ( n :  72 ; a :   0.1314 ) ,
   ( n :  73 ; a :  -0.1283 ) ,   ( n :  74 ; a :  -0.1331 ) ,
   ( n :  75 ; a :   0.1383 ) ,   ( n :  76 ; a :   0.1405 ) ,
   ( n :  77 ; a :   0.1290 ) ,   ( n :  78 ; a :  -0.1214 ) ,
   ( n :  79 ; a :   0.1146 ) ,   ( n :  80 ; a :   0.1019 ) ,
   ( n :  81 ; a :  -0.1100 ) ,   ( n :  82 ; a :  -0.0970 ) ,
   ( n :  83 ; a :   0.1575 ) ,   ( n :  84 ; a :   0.0934 ) ,
   ( n :  85 ; a :   0.0922 ) ,   ( n :  86 ; a :   0.0815 ) ,
   ( n :  87 ; a :   0.0834 ) ,   ( n :  88 ; a :   0.1248 ) ,
   ( n :  89 ; a :   0.1338 ) ,   ( n :  90 ; a :   0.0716 ) ,
   ( n :  91 ; a :   0.1282 ) ,   ( n :  92 ; a :   0.0742 ) ,
   ( n :  93 ; a :   0.1020 ) ,   ( n :  94 ; a :   0.0715 ) ,
   ( n :  95 ; a :  -0.0666 ) ,   ( n :  96 ; a :  -0.0667 ) ,
   ( n :  97 ; a :  -0.0704 ) ,   ( n :  98 ; a :  -0.0694 ) ,
   ( n :  99 ; a :  -0.1014 ) ,   ( n : 100 ; a :  -0.0585 ) ,
   ( n : 101 ; a :  -0.0949 ) ,   ( n : 102 ; a :  -0.0595 ) ,
   ( n : 103 ; a :   0.0528 ) ,   ( n : 104 ; a :  -0.0590 ) ,
   ( n : 105 ; a :   0.0570 ) ,   ( n : 106 ; a :  -0.0502 ) ,
   ( n : 107 ; a :  -0.0875 ) ,   ( n : 108 ; a :  -0.0492 ) ,
   ( n : 109 ; a :   0.0535 ) ,   ( n : 110 ; a :  -0.0467 ) ,
   ( n : 111 ; a :   0.0591 ) ,   ( n : 112 ; a :  -0.0453 ) ,
   ( n : 113 ; a :   0.0766 ) ,   ( n : 114 ; a :  -0.0446 ) ,
   ( n : 115 ; a :  -0.0488 ) ,   ( n : 116 ; a :  -0.0468 ) ,
   ( n : 117 ; a :  -0.0421 ) ,   ( n : 118 ; a :   0.0463 ) ,
   ( n : 119 ; a :  -0.0673 ) ,   ( n : 120 ; a :   0.0658 ) ,
   ( n : 121 ; a :  -0.0438 ) ,   ( n : 122 ; a :  -0.0390 ) ,
   ( n : 123 ; a :   0.0639 ) ,   ( n : 124 ; a :   0.0412 ) ,
   ( n : 125 ; a :  -0.0361 ) ,   ( n : 126 ; a :   0.0360 ) ,
   ( n : 127 ; a :   0.0588 ) ,   ( n : 128 ; a :  -0.0578 ) ,
   ( n : 129 ; a :  -0.0396 ) ,   ( n : 130 ; a :   0.0565 ) ,
   ( n : 131 ; a :  -0.0335 ) ,   ( n : 132 ; a :   0.0357 ) ,
   ( n : 133 ; a :   0.0321 ) ,   ( n : 134 ; a :  -0.0301 ) ,
   ( n : 135 ; a :  -0.0334 ) ,   ( n : 136 ; a :   0.0493 ) ,
   ( n : 137 ; a :   0.0494 ) ,   ( n : 138 ; a :   0.0337 ) ,
   ( n : 139 ; a :   0.0280 ) ,   ( n : 140 ; a :   0.0309 ) ,
   ( n : 141 ; a :  -0.0263 ) ,   ( n : 142 ; a :   0.0253 ) ,
   ( n : 143 ; a :   0.0245 ) ,   ( n : 144 ; a :   0.0416 ) ,
   ( n : 145 ; a :  -0.0229 ) ,   ( n : 146 ; a :   0.0231 ) ,
   ( n : 147 ; a :  -0.0259 ) ,   ( n : 148 ; a :   0.0375 ) ,
   ( n : 149 ; a :   0.0252 ) ,   ( n : 150 ; a :  -0.0245 ) ,
   ( n : 151 ; a :   0.0243 ) ,   ( n : 152 ; a :   0.0208 ) ,
   ( n : 153 ; a :   0.0199 ) ,   ( n : 154 ; a :  -0.0208 ) ,
   ( n : 155 ; a :   0.0335 ) ,   ( n : 156 ; a :  -0.0325 ) ,
   ( n : 157 ; a :  -0.0187 ) ,   ( n : 158 ; a :   0.0197 ) ,
   ( n : 159 ; a :  -0.0192 ) ,   ( n : 160 ; a :  -0.0188 ) ,
   ( n : 161 ; a :   0.0276 ) ,   ( n : 162 ; a :  -0.0286 ) ,
   ( n : 163 ; a :   0.0186 ) ,   ( n : 164 ; a :  -0.0219 ) ,
   ( n : 165 ; a :   0.0276 ) ,   ( n : 166 ; a :  -0.0153 ) ,
   ( n : 167 ; a :  -0.0156 ) ,   ( n : 168 ; a :  -0.0154 ) ,
   ( n : 169 ; a :  -0.0174 ) ,   ( n : 170 ; a :  -0.0163 ) ,
   ( n : 171 ; a :  -0.0228 ) ,   ( n : 172 ; a :   0.0091 ) ,
   ( n : 173 ; a :   0.0175 ) ,   ( n : 174 ; a :  -0.0159 ) ,
   ( n : 175 ; a :   0.0141 ) ,   ( n : 176 ; a :   0.0147 ) ,
   ( n : 177 ; a :  -0.0132 ) ,   ( n : 178 ; a :   0.0159 ) ,
   ( n : 179 ; a :   0.0213 ) ,   ( n : 180 ; a :   0.0123 ) ,
   ( n : 181 ; a :  -0.0118 ) ,   ( n : 182 ; a :   0.0144 ) ,
   ( n : 183 ; a :  -0.0121 ) ,   ( n : 184 ; a :  -0.0134 ) ,
   ( n : 185 ; a :  -0.0105 ) ,   ( n : 186 ; a :  -0.0102 ) ,
   ( n : 187 ; a :   0.0120 ) ,   ( n : 188 ; a :   0.0101 ) ,
   ( n : 189 ; a :  -0.0113 ) ,   ( n : 190 ; a :  -0.0106 ) ,
   ( n : 191 ; a :  -0.0129 ) ,   ( n : 192 ; a :  -0.0114 ) ,
   ( n : 193 ; a :   0.0113 ) ,   ( n : 194 ; a :  -0.0102 ) ,
   ( n : 195 ; a :  -0.0094 ) ,   ( n : 196 ; a :  -0.0100 ) ,
   ( n : 197 ; a :   0.0087 ) ,   ( n : 198 ; a :   0.0161 ) ,
   ( n : 199 ; a :   0.0096 ) ,   ( n : 200 ; a :   0.0151 ) ,
   ( n : 201 ; a :  -0.0104 ) ,   ( n : 202 ; a :  -0.0110 ) ,
   ( n : 203 ; a :  -0.0100 ) ,   ( n : 204 ; a :   0.0092 ) ,
   ( n : 205 ; a :   0.0082 ) ,   ( n : 206 ; a :   0.0082 ) ,
   ( n : 207 ; a :  -0.0078 ) ,   ( n : 208 ; a :  -0.0077 ) ,
   ( n : 209 ; a :   0.0002 ) ,   ( n : 210 ; a :   0.0094 ) ,
   ( n : 211 ; a :  -0.0093 ) ,   ( n : 212 ; a :  -0.0083 ) ,
   ( n : 213 ; a :   0.0083 ) ,   ( n : 214 ; a :  -0.0091 ) ,
   ( n : 215 ; a :   0.0128 ) ,   ( n : 216 ; a :  -0.0079 ) ,
   ( n : 217 ; a :  -0.0083 ) ,   ( n : 218 ; a :   0.0084 ) ,
   ( n : 219 ; a :   0.0083 ) ,   ( n : 220 ; a :   0.0091 ) ,
   ( n : 221 ; a :  -0.0077 ) ,   ( n : 222 ; a :   0.0084 ) ,
   ( n : 223 ; a :  -0.0092 ) ,   ( n : 224 ; a :  -0.0092 ) ,
   ( n : 225 ; a :  -0.0094 ) ,   ( n : 226 ; a :   0.0068 ) ,
   ( n : 227 ; a :  -0.0061 ) ,   ( n : 228 ; a :   0.0071 ) ,
   ( n : 229 ; a :   0.0062 ) ,   ( n : 230 ; a :  -0.0063 ) ,
   ( n : 231 ; a :  -0.0073 ) ,   ( n : 232 ; a :   0.0115 ) ,
   ( n : 233 ; a :  -0.0103 ) ,   ( n : 234 ; a :   0.0063 ) ,
   ( n : 235 ; a :   0.0074 ) ,   ( n : 236 ; a :  -0.0103 ) ,
   ( n : 237 ; a :  -0.0069 ) ,   ( n : 238 ; a :   0.0057 ) ,
   ( n : 239 ; a :   0.0094 ) ,   ( n : 240 ; a :   0.0064 ) ,
   ( n : 241 ; a :  -0.0063 ) ,   ( n : 242 ; a :  -0.0038 ) ,
   ( n : 243 ; a :  -0.0043 ) ,   ( n : 244 ; a :  -0.0045 ) ,
   ( n : 245 ; a :   0.0047 ) ,   ( n : 246 ; a :  -0.0048 ) ,
   ( n : 247 ; a :   0.0045 ) ,   ( n : 248 ; a :   0.0056 ) ,
   ( n : 249 ; a :   0.0088 ) ,   ( n : 250 ; a :  -0.0075 ) ,
   ( n : 251 ; a :   0.0085 ) ,   ( n : 252 ; a :   0.0049 ) ,
   ( n : 253 ; a :  -0.0074 ) ,   ( n : 254 ; a :  -0.0039 ) ,
   ( n : 255 ; a :   0.0045 ) ,   ( n : 256 ; a :   0.0051 ) ,
   ( n : 257 ; a :  -0.0040 ) ,   ( n : 258 ; a :   0.0041 ) ,
   ( n : 259 ; a :  -0.0042 ) ,   ( n : 260 ; a :  -0.0051 ) ,
   ( n : 261 ; a :  -0.0042 ) ,   ( n : 262 ; a :   0.0039 ) ,
   ( n : 263 ; a :   0.0046 ) ,   ( n : 264 ; a :  -0.0053 ) ,
   ( n : 265 ; a :   0.0082 ) ,   ( n : 266 ; a :   0.0081 ) ,
   ( n : 267 ; a :   0.0047 ) ,   ( n : 268 ; a :   0.0053 ) ,
   ( n : 269 ; a :  -0.0045 ) ,   ( n : 270 ; a :  -0.0044 ) ,
   ( n : 271 ; a :  -0.0033 ) ,   ( n : 272 ; a :  -0.0061 ) ,
   ( n : 273 ; a :   0.0028 ) ,   ( n : 274 ; a :  -0.0038 ) ,
   ( n : 275 ; a :  -0.0033 ) ,   ( n : 276 ; a :  -0.0060 ) ,
   ( n : 277 ; a :   0.0048 ) ,   ( n : 278 ; a :   0.0027 ) ,
   ( n : 279 ; a :   0.0038 ) ,   ( n : 280 ; a :   0.0031 ) ,
   ( n : 281 ; a :  -0.0029 ) ,   ( n : 282 ; a :   0.0028 ) ,
   ( n : 283 ; a :  -0.0032 ) ,   ( n : 284 ; a :   0.0045 ) ,
   ( n : 285 ; a :  -0.0044 ) ,   ( n : 286 ; a :   0.0028 ) ,
   ( n : 287 ; a :  -0.0051 ) ,   ( n : 288 ; a :  -0.0036 ) ,
   ( n : 289 ; a :   0.0044 ) ,   ( n : 290 ; a :   0.0026 ) ,
   ( n : 291 ; a :  -0.0060 ) ,   ( n : 292 ; a :   0.0035 ) ,
   ( n : 293 ; a :  -0.0027 ) ,   ( n : 294 ; a :   0.0047 ) ,
   ( n : 295 ; a :   0.0036 ) ,   ( n : 296 ; a :  -0.0036 ) ,
   ( n : 297 ; a :  -0.0035 ) ,   ( n : 298 ; a :  -0.0037 ) ,
   ( n : 299 ; a :   0.0032 ) ,   ( n : 300 ; a :   0.0035 ) ,
   ( n : 301 ; a :   0.0032 ) ,   ( n : 302 ; a :   0.0065 ) ,
   ( n : 303 ; a :   0.0047 ) ,   ( n : 304 ; a :   0.0032 ) ,
   ( n : 305 ; a :   0.0037 ) ,   ( n : 306 ; a :  -0.0030 ) ,
   ( n : 307 ; a :  -0.0032 ) ,   ( n : 308 ; a :  -0.0031 ) ,
   ( n : 309 ; a :   0.0037 ) ,   ( n : 310 ; a :   0.0031 ) ,
   ( n : 311 ; a :   0.0049 ) ,   ( n : 312 ; a :   0.0032 ) ,
   ( n : 313 ; a :   0.0023 ) ,   ( n : 314 ; a :  -0.0043 ) ,
   ( n : 315 ; a :   0.0026 ) ,   ( n : 316 ; a :  -0.0032 ) ,
   ( n : 317 ; a :  -0.0029 ) ,   ( n : 318 ; a :  -0.0027 ) ,
   ( n : 319 ; a :   0.0030 ) ,   ( n : 320 ; a :  -0.0011 ) ,
   ( n : 321 ; a :  -0.0021 ) ,   ( n : 322 ; a :  -0.0034 ) ,
   ( n : 323 ; a :  -0.0010 ) ,   ( n : 324 ; a :  -0.0036 ) ,
   ( n : 325 ; a :  -0.0009 ) ,   ( n : 326 ; a :  -0.0012 ) ,
   ( n : 327 ; a :  -0.0021 ) ,   ( n : 328 ; a :  -0.0029 ) ,
   ( n : 329 ; a :  -0.0015 ) ,   ( n : 330 ; a :  -0.0020 ) ,
   ( n : 331 ; a :   0.0028 ) ,   ( n : 332 ; a :   0.0017 ) ,
   ( n : 333 ; a :  -0.0022 ) ,   ( n : 334 ; a :  -0.0014 ) ,
   ( n : 335 ; a :   0.0024 ) ,   ( n : 336 ; a :   0.0011 ) ,
   ( n : 337 ; a :   0.0014 ) ,   ( n : 338 ; a :   0.0024 ) ,
   ( n : 339 ; a :   0.0018 ) ,   ( n : 340 ; a :  -0.0038 ) ,
   ( n : 341 ; a :  -0.0031 ) ,   ( n : 342 ; a :  -0.0016 ) ,
   ( n : 343 ; a :   0.0029 ) ,   ( n : 344 ; a :  -0.0018 ) ,
   ( n : 345 ; a :  -0.0010 ) ,   ( n : 346 ; a :  -0.0017 ) ,
   ( n : 347 ; a :   0.0009 ) ,   ( n : 348 ; a :   0.0016 ) ,
   ( n : 349 ; a :   0.0022 ) ,   ( n : 350 ; a :   0.0020 ) ,
   ( n : 351 ; a :  -0.0013 ) ,   ( n : 352 ; a :  -0.0017 ) ,
   ( n : 353 ; a :  -0.0014 ) ,   ( n : 355 ; a :   0.0014 ) ,
   ( n : 356 ; a :   0.0019 ) ,   ( n : 357 ; a :  -0.0034 ) ,
   ( n : 358 ; a :  -0.0020 ) ,   ( n : 359 ; a :   0.0009 ) ,
   ( n : 360 ; a :  -0.0018 ) ,   ( n : 361 ; a :   0.0013 ) ,
   ( n : 362 ; a :   0.0017 ) ,   ( n : 363 ; a :  -0.0012 ) ,
   ( n : 364 ; a :   0.0015 ) ,   ( n : 365 ; a :  -0.0011 ) ,
   ( n : 366 ; a :   0.0013 ) ,   ( n : 367 ; a :  -0.0018 ) ,
   ( n : 368 ; a :  -0.0035 ) ,   ( n : 369 ; a :   0.0009 ) ,
   ( n : 370 ; a :  -0.0019 ) ,   ( n : 371 ; a :  -0.0026 ) ,
   ( n : 372 ; a :   0.0008 ) ,   ( n : 373 ; a :  -0.0010 ) ,
   ( n : 374 ; a :   0.0010 ) ,   ( n : 375 ; a :  -0.0021 ) ,
   ( n : 376 ; a :  -0.0015 ) ,   ( n : 377 ; a :   0.0009 ) ,
   ( n : 378 ; a :  -0.0029 ) ,   ( n : 379 ; a :  -0.0019 ) ,
   ( n : 380 ; a :   0.0012 ) ,   ( n : 381 ; a :   0.0022 ) ,
   ( n : 382 ; a :  -0.0010 ) ,   ( n : 383 ; a :  -0.0020 ) ,
   ( n : 384 ; a :  -0.0020 ) ,   ( n : 385 ; a :  -0.0017 ) ,
   ( n : 386 ; a :   0.0015 ) ,   ( n : 387 ; a :   0.0008 ) ,
   ( n : 388 ; a :   0.0014 ) ,   ( n : 389 ; a :  -0.0012 ) ,
   ( n : 390 ; a :   0.0025 ) ,   ( n : 391 ; a :  -0.0013 ) ,
   ( n : 392 ; a :  -0.0014 ) ,   ( n : 393 ; a :   0.0013 ) ,
   ( n : 394 ; a :  -0.0017 ) ,   ( n : 395 ; a :  -0.0012 ) ,
   ( n : 396 ; a :  -0.0010 ) ,   ( n : 397 ; a :   0.0010 ) ,
   ( n : 398 ; a :  -0.0015 ) ,   ( n : 399 ; a :  -0.0022 ) ,
   ( n : 400 ; a :   0.0028 ) ,   ( n : 401 ; a :   0.0015 ) ,
   ( n : 402 ; a :   0.0023 ) ,   ( n : 403 ; a :   0.0012 ) ,
   ( n : 404 ; a :   0.0029 ) ,   ( n : 405 ; a :  -0.0025 ) ,
   ( n : 406 ; a :   0.0022 ) ,   ( n : 407 ; a :  -0.0018 ) ,
   ( n : 408 ; a :   0.0015 ) ,   ( n : 409 ; a :  -0.0023 ) ,
   ( n : 410 ; a :   0.0012 ) ,   ( n : 411 ; a :  -0.0008 ) ,
   ( n : 412 ; a :  -0.0019 ) ,   ( n : 413 ; a :  -0.0010 ) ,
   ( n : 414 ; a :   0.0021 ) ,   ( n : 415 ; a :   0.0023 ) ,
   ( n : 416 ; a :  -0.0016 ) ,   ( n : 417 ; a :  -0.0019 ) ,
   ( n : 418 ; a :  -0.0022 ) ,   ( n : 419 ; a :   0.0027 ) ,
   ( n : 420 ; a :   0.0016 ) ,   ( n : 421 ; a :   0.0019 ) ,
   ( n : 422 ; a :   0.0009 ) ,   ( n : 423 ; a :  -0.0009 ) ,
   ( n : 424 ; a :  -0.0009 ) ,   ( n : 425 ; a :  -0.0008 ) ,
   ( n : 426 ; a :   0.0018 ) ,   ( n : 427 ; a :   0.0016 ) ,
   ( n : 428 ; a :  -0.0010 ) ,   ( n : 429 ; a :  -0.0023 ) ,
   ( n : 430 ; a :   0.0016 ) ,   ( n : 431 ; a :  -0.0012 ) ,
   ( n : 432 ; a :  -0.0008 ) ,   ( n : 433 ; a :   0.0030 ) ,
   ( n : 434 ; a :   0.0024 ) ,   ( n : 435 ; a :   0.0010 ) ,
   ( n : 436 ; a :  -0.0016 ) ,   ( n : 437 ; a :  -0.0016 ) ,
   ( n : 438 ; a :   0.0017 ) ,   ( n : 439 ; a :  -0.0024 ) ,
   ( n : 440 ; a :  -0.0012 ) ,   ( n : 441 ; a :  -0.0024 ) ,
   ( n : 442 ; a :  -0.0023 ) ,   ( n : 443 ; a :  -0.0013 ) ,
   ( n : 444 ; a :  -0.0015 ) ,   ( n : 447 ; a :  -0.0004 ) ,
   ( n : 449 ; a :   0.0005 ) ,   ( n : 452 ; a :  -0.0003 ) ,
   ( n : 453 ; a :   0.0004 ) ,   ( n : 455 ; a :   0.0005 ) ,
   ( n : 456 ; a :   0.0003 ) ,   ( n : 457 ; a :  -0.0003 ) ,
   ( n : 458 ; a :  -0.0005 ) ,   ( n : 459 ; a :   0.0003 ) ,
   ( n : 460 ; a :   0.0003 ) ,   ( n : 461 ; a :   0.0003 ) ,
   ( n : 464 ; a :   0.0004 ) ,   ( n : 465 ; a :   0.0006 ) ,
   ( n : 466 ; a :   0.0005 ) ,   ( n : 467 ; a :  -0.0007 ) ,
   ( n : 468 ; a :  -0.0012 ) ,   ( n : 469 ; a :   0.0005 ) ,
   ( n : 470 ; a :   0.0003 ) ,   ( n : 471 ; a :  -0.0005 ) ,
   ( n : 472 ; a :   0.0003 ) ,   ( n : 473 ; a :  -0.0007 ) ,
   ( n : 474 ; a :   0.0007 ) ,   ( n : 476 ; a :   0.0004 ) ,
   ( n : 477 ; a :   0.0003 ) ,   ( n : 478 ; a :  -0.0003 ) ,
   ( n : 479 ; a :  -0.0007 ) ,   ( n : 480 ; a :  -0.0004 ) ,
   ( n : 481 ; a :  -0.0003 ) ,   ( n : 483 ; a :  -0.0003 ) ,
   ( n : 484 ; a :   0.0007 ) ,   ( n : 485 ; a :  -0.0004 ) ,
   ( n : 486 ; a :   0.0004 ) ,   ( n : 487 ; a :  -0.0005 ) ,
   ( n : 488 ; a :   0.0005 ) ,   ( n : 489 ; a :  -0.0005 ) ,
   ( n : 490 ; a :   0.0005 ) ,   ( n : 491 ; a :  -0.0008 ) ,
   ( n : 492 ; a :   0.0009 ) ,   ( n : 493 ; a :   0.0006 ) ,
   ( n : 494 ; a :  -0.0005 ) ,   ( n : 495 ; a :   0.0003 ) ,
   ( n : 496 ; a :  -0.0007 ) ,   ( n : 497 ; a :  -0.0003 ) ,
   ( n : 498 ; a :   0.0005 ) ,   ( n : 499 ; a :   0.0003 ) ,
   ( n : 500 ; a :  -0.0003 ) ,   ( n : 501 ; a :   0.0004 ) ,
   ( n : 502 ; a :   0.0003 ) ,   ( n : 503 ; a :  -0.0005 ) ,
   ( n : 504 ; a :   0.0004 ) ,   ( n : 505 ; a :   0.0009 ) ,
   ( n : 506 ; a :   0.0004 ) ,   ( n : 507 ; a :   0.0004 ) ,
   ( n : 508 ; a :  -0.0003 ) ,   ( n : 509 ; a :  -0.0004 ) ,
   ( n : 510 ; a :   0.0009 ) ,   ( n : 511 ; a :  -0.0004 ) ,
   ( n : 512 ; a :  -0.0004 ) ,   ( n : 513 ; a :   0.0003 ) ,
   ( n : 514 ; a :   0.0008 ) ,   ( n : 515 ; a :   0.0003 ) ,
   ( n : 516 ; a :  -0.0003 ) ,   ( n : 517 ; a :   0.0003 ) ,
   ( n : 518 ; a :   0.0003 ) ,   ( n : 519 ; a :  -0.0003 ) ,
   ( n : 520 ; a :   0.0006 ) ,   ( n : 521 ; a :   0.0003 ) ,
   ( n : 522 ; a :  -0.0003 ) ,   ( n : 523 ; a :  -0.0007 ) ,
   ( n : 524 ; a :   0.0009 ) ,   ( n : 525 ; a :  -0.0003 ) ,
   ( n : 526 ; a :  -0.0003 ) ,   ( n : 527 ; a :  -0.0004 ) ,
   ( n : 528 ; a :  -0.0005 ) ,   ( n : 529 ; a :  -0.0013 ) ,
   ( n : 530 ; a :  -0.0007 ) ,   ( n : 531 ; a :   0.0010 ) ,
   ( n : 532 ; a :   0.0003 ) ,   ( n : 533 ; a :   0.0010 ) ,
   ( n : 537 ; a :  -0.0007 ) ,   ( n : 538 ; a :  -0.0004 ) ,
   ( n : 539 ; a :   0.0004 ) ,   ( n : 540 ; a :   0.0005 ) ,
   ( n : 541 ; a :   0.0005 ) ,   ( n : 542 ; a :  -0.0003 ) ,
   ( n : 543 ; a :  -0.0003 ) ,   ( n : 544 ; a :  -0.0004 ) ,
   ( n : 545 ; a :  -0.0005 ) ,   ( n : 546 ; a :   0.0006 ) ,
   ( n : 547 ; a :   0.0009 ) ,   ( n : 548 ; a :   0.0005 ) ,
   ( n : 549 ; a :  -0.0007 ) ,   ( n : 550 ; a :  -0.0003 ) ,
   ( n : 551 ; a :  -0.0004 ) ,   ( n : 552 ; a :   0.0007 ) ,
   ( n : 553 ; a :  -0.0004 ) ,   ( n : 554 ; a :   0.0004 ) ,
   ( n : 555 ; a :  -0.0006 ) ,   ( n : 557 ; a :   0.0011 ) ,
   ( n : 558 ; a :   0.0003 ) ,   ( n : 559 ; a :   0.0011 ) ,
   ( n : 560 ; a :  -0.0003 ) ,   ( n : 561 ; a :  -0.0001 ) ,
   ( n : 562 ; a :   0.0004 ) ,   ( n : 564 ; a :   0.0003 ) ,
   ( n : 565 ; a :  -0.0007 ) ,   ( n : 566 ; a :   0.0005 ) ,
   ( n : 567 ; a :  -0.0003 ) ,   ( n : 568 ; a :   0.0003 ) ,
   ( n : 569 ; a :   0.0005 ) ,   ( n : 570 ; a :  -0.0007 ) ,
   ( n : 571 ; a :   0.0008 ) ,   ( n : 572 ; a :  -0.0004 ) ,
   ( n : 573 ; a :   0.0011 ) ,   ( n : 574 ; a :  -0.0003 ) ,
   ( n : 575 ; a :   0.0003 ) ,   ( n : 576 ; a :  -0.0004 ) ,
   ( n : 577 ; a :   0.0008 ) ,   ( n : 578 ; a :   0.0003 ) ,
   ( n : 579 ; a :   0.0011 ) ,   ( n : 580 ; a :  -0.0006 ) ,
   ( n : 581 ; a :  -0.0004 ) ,   ( n : 582 ; a :  -0.0008 ) ,
   ( n : 583 ; a :  -0.0007 ) ,   ( n : 584 ; a :  -0.0004 ) ,
   ( n : 585 ; a :   0.0003 ) ,   ( n : 586 ; a :   0.0006 ) ,
   ( n : 587 ; a :  -0.0006 ) ,   ( n : 588 ; a :   0.0006 ) ,
   ( n : 589 ; a :   0.0006 ) ,   ( n : 590 ; a :   0.0005 ) ,
   ( n : 591 ; a :  -0.0005 ) ,   ( n : 592 ; a :  -0.0004 ) ,
   ( n : 593 ; a :  -0.0004 ) ,   ( n : 594 ; a :   0.0004 ) ,
   ( n : 595 ; a :   0.0006 ) ,   ( n : 596 ; a :  -0.0004 ) ,
   ( n : 599 ; a :   0.0005 ) ,   ( n : 600 ; a :  -0.0013 ) ,
   ( n : 601 ; a :   0.0003 ) ,   ( n : 602 ; a :   0.0004 ) ,
   ( n : 603 ; a :   0.0007 ) ,   ( n : 604 ; a :   0.0004 ) ,
   ( n : 605 ; a :   0.0005 ) ,   ( n : 606 ; a :  -0.0003 ) ,
   ( n : 607 ; a :  -0.0006 ) ,   ( n : 608 ; a :  -0.0005 ) ,
   ( n : 609 ; a :  -0.0007 ) ,   ( n : 610 ; a :   0.0005 ) ,
   ( n : 611 ; a :   0.0013 ) ,   ( n : 612 ; a :  -0.0004 ) ,
   ( n : 613 ; a :  -0.0003 ) ,   ( n : 614 ; a :   0.0005 ) ,
   ( n : 615 ; a :  -0.0011 ) ,   ( n : 616 ; a :   0.0005 ) ,
   ( n : 617 ; a :   0.0004 ) ,   ( n : 618 ; a :   0.0004 ) ,
   ( n : 619 ; a :  -0.0004 ) ,   ( n : 620 ; a :   0.0006 ) ,
   ( n : 621 ; a :   0.0003 ) ,   ( n : 622 ; a :  -0.0012 ) ,
   ( n : 623 ; a :   0.0004 ) ,   ( n : 624 ; a :  -0.0003 ) ,
   ( n : 625 ; a :  -0.0004 ) ,   ( n : 626 ; a :   0.0003 ) ,
   ( n : 627 ; a :   0.0003 ) ,   ( n : 628 ; a :  -0.0003 ) ,
   ( n : 630 ; a :  -0.0007 ) ,   ( n : 631 ; a :   0.0006 ) ,
   ( n : 632 ; a :  -0.0003 ) ,   ( n : 633 ; a :   0.0005 ) ,
   ( n : 634 ; a :   0.0003 ) ,   ( n : 635 ; a :   0.0003 ) ,
   ( n : 636 ; a :  -0.0003 ) ,   ( n : 637 ; a :  -0.0005 ) ,
   ( n : 638 ; a :  -0.0003 ) ,   ( n : 639 ; a :  -0.0003 ) ,
   ( n : 640 ; a :   0.0012 ) ,   ( n : 641 ; a :   0.0003 ) ,
   ( n : 642 ; a :  -0.0004 ) ,   ( n : 643 ; a :   0.0004 ) ,
   ( n : 644 ; a :   0.0006 ) ,   ( n : 645 ; a :   0.0005 ) ,
   ( n : 646 ; a :   0.0004 ) ,   ( n : 647 ; a :  -0.0006 ) ,
   ( n : 648 ; a :   0.0004 ) ,   ( n : 649 ; a :   0.0006 ) ,
   ( n : 650 ; a :   0.0006 ) ,   ( n : 651 ; a :  -0.0006 ) ,
   ( n : 652 ; a :   0.0003 ) ,   ( n : 653 ; a :   0.0007 ) ,
   ( n : 654 ; a :   0.0004 ) ,   ( n : 655 ; a :  -0.0005 ) ,
   ( n : 656 ; a :   0.0005 ) ,   ( n : 657 ; a :  -0.0006 ) ,
   ( n : 658 ; a :  -0.0006 ) ,   ( n : 659 ; a :  -0.0004 ) ,
   ( n : 660 ; a :   0.0010 ) ,   ( n : 661 ; a :  -0.0004 ) ,
   ( n : 662 ; a :   0.0007 ) ,   ( n : 663 ; a :   0.0007 ) ,
   ( n : 664 ; a :   0.0004 ) ,   ( n : 665 ; a :   0.0011 ) ,
   ( n : 666 ; a :   0.0005 ) ,   ( n : 667 ; a :  -0.0006 ) ,
   ( n : 668 ; a :   0.0004 ) ,   ( n : 669 ; a :   0.0003 ) ,
   ( n : 670 ; a :   0.0005 ) ,   ( n : 671 ; a :  -0.0004 ) ,
   ( n : 672 ; a :  -0.0004 ) ,   ( n : 673 ; a :  -0.0003 ) ,
   ( n : 674 ; a :   0.0004 ) ,   ( n : 675 ; a :   0.0003 ) ,
   ( n : 676 ; a :  -0.0003 ) ,   ( n : 677 ; a :  -0.0003 ) ,
   ( n : 678 ; a :  -0.0003 ) ) ;
   AmpECos  : Array [1..549] of TOneAmp =
 ( ( n :  14 ; a :  -3.3228 ) ,
   ( n :  15 ; a :   3.1429 ) ,   ( n :  16 ; a :   2.5543 ) ,
   ( n :  17 ; a :   2.6366 ) ,   ( n :  18 ; a :  -2.4236 ) ,
   ( n :  19 ; a :  -0.1220 ) ,   ( n :  20 ; a :   1.6452 ) ,
   ( n :  21 ; a :  -1.3870 ) ,   ( n :  22 ; a :   0.0477 ) ,
   ( n :  23 ; a :   1.3238 ) ,   ( n :  24 ; a :  -1.2338 ) ,
   ( n :  25 ; a :  -1.0758 ) ,   ( n :  26 ; a :  -0.0609 ) ,
   ( n :  27 ; a :  -0.0550 ) ,   ( n :  28 ; a :   0.8551 ) ,
   ( n :  29 ; a :  -0.8001 ) ,   ( n :  30 ; a :   0.6850 ) ,
   ( n :  31 ; a :  -0.0167 ) ,   ( n :  32 ; a :   0.6953 ) ,
   ( n :  33 ; a :   0.6415 ) ,   ( n :  34 ; a :   0.5222 ) ,
   ( n :  35 ; a :   0.0168 ) ,   ( n :  36 ; a :   0.3268 ) ,
   ( n :  37 ; a :   0.0104 ) ,   ( n :  38 ; a :  -0.3250 ) ,
   ( n :  39 ; a :   0.3353 ) ,   ( n :  40 ; a :   0.3070 ) ,
   ( n :  41 ; a :   0.3272 ) ,   ( n :  42 ; a :  -0.3045 ) ,
   ( n :  43 ; a :  -0.2768 ) ,   ( n :  44 ; a :   0.3041 ) ,
   ( n :  45 ; a :   0.2695 ) ,   ( n :  46 ; a :   0.2719 ) ,
   ( n :  47 ; a :   0.2720 ) ,   ( n :  48 ; a :  -0.0051 ) ,
   ( n :  49 ; a :  -0.2206 ) ,   ( n :  50 ; a :  -0.0199 ) ,
   ( n :  51 ; a :  -0.1900 ) ,   ( n :  52 ; a :  -0.0041 ) ,
   ( n :  53 ; a :   0.1313 ) ,   ( n :  54 ; a :   0.1233 ) ,
   ( n :  55 ; a :  -0.0081 ) ,   ( n :  56 ; a :   0.1232 ) ,
   ( n :  57 ; a :  -0.0020 ) ,   ( n :  58 ; a :   0.1207 ) ,
   ( n :  59 ; a :   0.0040 ) ,   ( n :  60 ; a :   0.1129 ) ,
   ( n :  61 ; a :   0.1266 ) ,   ( n :  62 ; a :  -0.1062 ) ,
   ( n :  63 ; a :  -0.1129 ) ,   ( n :  64 ; a :  -0.0009 ) ,
   ( n :  65 ; a :   0.0035 ) ,   ( n :  66 ; a :  -0.0107 ) ,
   ( n :  67 ; a :   0.1073 ) ,   ( n :  68 ; a :   0.0854 ) ,
   ( n :  69 ; a :  -0.0553 ) ,   ( n :  70 ; a :  -0.0710 ) ,
   ( n :  71 ; a :   0.0647 ) ,   ( n :  72 ; a :  -0.0700 ) ,
   ( n :  73 ; a :   0.0672 ) ,   ( n :  74 ; a :   0.0663 ) ,
   ( n :  75 ; a :  -0.0594 ) ,   ( n :  76 ; a :  -0.0610 ) ,
   ( n :  77 ; a :  -0.0556 ) ,   ( n :  78 ; a :   0.0518 ) ,
   ( n :  79 ; a :  -0.0490 ) ,   ( n :  80 ; a :  -0.0527 ) ,
   ( n :  81 ; a :   0.0465 ) ,   ( n :  82 ; a :   0.0496 ) ,
   ( n :  83 ; a :  -0.0050 ) ,   ( n :  84 ; a :  -0.0399 ) ,
   ( n :  85 ; a :  -0.0395 ) ,   ( n :  86 ; a :  -0.0422 ) ,
   ( n :  87 ; a :  -0.0440 ) ,   ( n :  88 ; a :  -0.0170 ) ,
   ( n :  89 ; a :  -0.0039 ) ,   ( n :  90 ; a :  -0.0389 ) ,
   ( n :  91 ; a :  -0.0023 ) ,   ( n :  92 ; a :  -0.0391 ) ,
   ( n :  93 ; a :  -0.0495 ) ,   ( n :  94 ; a :  -0.0326 ) ,
   ( n :  95 ; a :   0.0369 ) ,   ( n :  96 ; a :   0.0346 ) ,
   ( n :  97 ; a :   0.0304 ) ,   ( n :  98 ; a :   0.0294 ) ,
   ( n :  99 ; a :   0.0004 ) ,   ( n : 100 ; a :   0.0316 ) ,
   ( n : 101 ; a :   0.0008 ) ,   ( n : 102 ; a :   0.0258 ) ,
   ( n : 103 ; a :  -0.0279 ) ,   ( n : 104 ; a :   0.0252 ) ,
   ( n : 105 ; a :  -0.0244 ) ,   ( n : 106 ; a :   0.0250 ) ,
   ( n : 107 ; a :   0.0029 ) ,   ( n : 108 ; a :   0.0275 ) ,
   ( n : 109 ; a :  -0.0228 ) ,   ( n : 110 ; a :   0.0240 ) ,
   ( n : 111 ; a :  -0.0253 ) ,   ( n : 112 ; a :   0.0244 ) ,
   ( n : 113 ; a :   0.0009 ) ,   ( n : 114 ; a :   0.0225 ) ,
   ( n : 115 ; a :   0.0207 ) ,   ( n : 116 ; a :   0.0201 ) ,
   ( n : 117 ; a :   0.0216 ) ,   ( n : 118 ; a :  -0.0200 ) ,
   ( n : 119 ; a :   0.0014 ) ,   ( n : 120 ; a :  -0.0002 ) ,
   ( n : 121 ; a :   0.0188 ) ,   ( n : 122 ; a :   0.0205 ) ,
   ( n : 123 ; a :  -0.0019 ) ,   ( n : 124 ; a :  -0.0176 ) ,
   ( n : 125 ; a :   0.0189 ) ,   ( n : 126 ; a :  -0.0185 ) ,
   ( n : 127 ; a :  -0.0024 ) ,   ( n : 128 ; a :   0.0005 ) ,
   ( n : 129 ; a :   0.0171 ) ,   ( n : 130 ; a :  -0.0006 ) ,
   ( n : 131 ; a :   0.0184 ) ,   ( n : 132 ; a :  -0.0154 ) ,
   ( n : 133 ; a :  -0.0174 ) ,   ( n : 134 ; a :   0.0162 ) ,
   ( n : 135 ; a :   0.0144 ) ,   ( n : 136 ; a :  -0.0015 ) ,
   ( n : 137 ; a :  -0.0019 ) ,   ( n : 138 ; a :  -0.0143 ) ,
   ( n : 139 ; a :  -0.0144 ) ,   ( n : 140 ; a :  -0.0134 ) ,
   ( n : 141 ; a :   0.0131 ) ,   ( n : 142 ; a :  -0.0138 ) ,
   ( n : 143 ; a :  -0.0128 ) ,   ( n : 144 ; a :  -0.0017 ) ,
   ( n : 145 ; a :   0.0128 ) ,   ( n : 146 ; a :  -0.0120 ) ,
   ( n : 147 ; a :   0.0109 ) ,   ( n : 148 ; a :  -0.0008 ) ,
   ( n : 149 ; a :  -0.0108 ) ,   ( n : 150 ; a :   0.0104 ) ,
   ( n : 151 ; a :  -0.0104 ) ,   ( n : 152 ; a :  -0.0112 ) ,
   ( n : 153 ; a :  -0.0102 ) ,   ( n : 154 ; a :   0.0105 ) ,
   ( n : 155 ; a :  -0.0014 ) ,   ( n : 156 ; a :   0.0007 ) ,
   ( n : 157 ; a :   0.0096 ) ,   ( n : 158 ; a :  -0.0100 ) ,
   ( n : 159 ; a :   0.0094 ) ,   ( n : 160 ; a :   0.0083 ) ,
   ( n : 161 ; a :  -0.0002 ) ,   ( n : 162 ; a :   0.0006 ) ,
   ( n : 163 ; a :  -0.0079 ) ,   ( n : 164 ; a :   0.0043 ) ,
   ( n : 165 ; a :   0.0002 ) ,   ( n : 166 ; a :   0.0084 ) ,
   ( n : 167 ; a :   0.0081 ) ,   ( n : 168 ; a :   0.0078 ) ,
   ( n : 169 ; a :   0.0075 ) ,   ( n : 170 ; a :   0.0069 ) ,
   ( n : 171 ; a :   0.0001 ) ,   ( n : 172 ; a :  -0.0054 ) ,
   ( n : 173 ; a :  -0.0075 ) ,   ( n : 174 ; a :   0.0069 ) ,
   ( n : 175 ; a :  -0.0072 ) ,   ( n : 176 ; a :  -0.0075 ) ,
   ( n : 177 ; a :   0.0069 ) ,   ( n : 178 ; a :  -0.0054 ) ,
   ( n : 179 ; a :  -0.0004 ) ,   ( n : 180 ; a :  -0.0064 ) ,
   ( n : 181 ; a :   0.0066 ) ,   ( n : 182 ; a :  -0.0061 ) ,
   ( n : 183 ; a :   0.0060 ) ,   ( n : 184 ; a :   0.0056 ) ,
   ( n : 185 ; a :   0.0057 ) ,   ( n : 186 ; a :   0.0056 ) ,
   ( n : 187 ; a :  -0.0052 ) ,   ( n : 188 ; a :  -0.0054 ) ,
   ( n : 189 ; a :   0.0059 ) ,   ( n : 190 ; a :   0.0061 ) ,
   ( n : 191 ; a :   0.0055 ) ,   ( n : 192 ; a :   0.0057 ) ,
   ( n : 193 ; a :  -0.0049 ) ,   ( n : 194 ; a :   0.0044 ) ,
   ( n : 195 ; a :   0.0051 ) ,   ( n : 196 ; a :   0.0056 ) ,
   ( n : 197 ; a :  -0.0047 ) ,   ( n : 198 ; a :  -0.0001 ) ,
   ( n : 199 ; a :  -0.0050 ) ,   ( n : 200 ; a :  -0.0005 ) ,
   ( n : 201 ; a :   0.0044 ) ,   ( n : 202 ; a :   0.0048 ) ,
   ( n : 203 ; a :   0.0050 ) ,   ( n : 204 ; a :   0.0012 ) ,
   ( n : 205 ; a :  -0.0045 ) ,   ( n : 206 ; a :  -0.0045 ) ,
   ( n : 207 ; a :   0.0041 ) ,   ( n : 208 ; a :   0.0043 ) ,
   ( n : 209 ; a :   0.0054 ) ,   ( n : 210 ; a :  -0.0040 ) ,
   ( n : 211 ; a :   0.0040 ) ,   ( n : 212 ; a :   0.0040 ) ,
   ( n : 213 ; a :  -0.0036 ) ,   ( n : 214 ; a :   0.0039 ) ,
   ( n : 215 ; a :  -0.0001 ) ,   ( n : 216 ; a :   0.0034 ) ,
   ( n : 217 ; a :   0.0047 ) ,   ( n : 218 ; a :  -0.0044 ) ,
   ( n : 219 ; a :  -0.0043 ) ,   ( n : 220 ; a :  -0.0039 ) ,
   ( n : 221 ; a :   0.0039 ) ,   ( n : 222 ; a :  -0.0043 ) ,
   ( n : 223 ; a :   0.0039 ) ,   ( n : 224 ; a :   0.0039 ) ,
   ( n : 226 ; a :  -0.0036 ) ,   ( n : 227 ; a :   0.0032 ) ,
   ( n : 228 ; a :  -0.0031 ) ,   ( n : 229 ; a :  -0.0034 ) ,
   ( n : 230 ; a :   0.0033 ) ,   ( n : 231 ; a :   0.0032 ) ,
   ( n : 232 ; a :  -0.0002 ) ,   ( n : 233 ; a :   0.0002 ) ,
   ( n : 234 ; a :  -0.0028 ) ,   ( n : 235 ; a :  -0.0032 ) ,
   ( n : 236 ; a :   0.0003 ) ,   ( n : 237 ; a :   0.0030 ) ,
   ( n : 238 ; a :  -0.0029 ) ,   ( n : 239 ; a :  -0.0004 ) ,
   ( n : 240 ; a :  -0.0033 ) ,   ( n : 241 ; a :   0.0026 ) ,
   ( n : 242 ; a :   0.0020 ) ,   ( n : 243 ; a :   0.0024 ) ,
   ( n : 244 ; a :   0.0023 ) ,   ( n : 245 ; a :  -0.0024 ) ,
   ( n : 246 ; a :   0.0025 ) ,   ( n : 247 ; a :  -0.0026 ) ,
   ( n : 248 ; a :  -0.0025 ) ,   ( n : 249 ; a :   0.0002 ) ,
   ( n : 252 ; a :  -0.0026 ) ,   ( n : 253 ; a :  -0.0001 ) ,
   ( n : 254 ; a :   0.0021 ) ,   ( n : 255 ; a :  -0.0020 ) ,
   ( n : 256 ; a :  -0.0022 ) ,   ( n : 257 ; a :   0.0021 ) ,
   ( n : 258 ; a :  -0.0021 ) ,   ( n : 259 ; a :   0.0024 ) ,
   ( n : 260 ; a :   0.0022 ) ,   ( n : 261 ; a :   0.0022 ) ,
   ( n : 262 ; a :  -0.0021 ) ,   ( n : 263 ; a :  -0.0018 ) ,
   ( n : 264 ; a :   0.0022 ) ,   ( n : 265 ; a :  -0.0004 ) ,
   ( n : 266 ; a :  -0.0004 ) ,   ( n : 267 ; a :  -0.0019 ) ,
   ( n : 268 ; a :  -0.0023 ) ,   ( n : 269 ; a :   0.0022 ) ,
   ( n : 270 ; a :  -0.0002 ) ,   ( n : 271 ; a :   0.0016 ) ,
   ( n : 272 ; a :   0.0001 ) ,   ( n : 273 ; a :  -0.0015 ) ,
   ( n : 274 ; a :   0.0019 ) ,   ( n : 275 ; a :   0.0021 ) ,
   ( n : 277 ; a :  -0.0010 ) ,   ( n : 278 ; a :  -0.0014 ) ,
   ( n : 279 ; a :  -0.0020 ) ,   ( n : 280 ; a :  -0.0013 ) ,
   ( n : 281 ; a :   0.0015 ) ,   ( n : 282 ; a :  -0.0015 ) ,
   ( n : 283 ; a :   0.0015 ) ,   ( n : 284 ; a :  -0.0008 ) ,
   ( n : 285 ; a :   0.0019 ) ,   ( n : 286 ; a :  -0.0015 ) ,
   ( n : 288 ; a :   0.0020 ) ,   ( n : 289 ; a :  -0.0019 ) ,
   ( n : 290 ; a :  -0.0014 ) ,   ( n : 291 ; a :   0.0002 ) ,
   ( n : 292 ; a :  -0.0018 ) ,   ( n : 293 ; a :   0.0011 ) ,
   ( n : 294 ; a :  -0.0001 ) ,   ( n : 295 ; a :  -0.0015 ) ,
   ( n : 296 ; a :   0.0020 ) ,   ( n : 297 ; a :   0.0019 ) ,
   ( n : 298 ; a :   0.0019 ) ,   ( n : 299 ; a :  -0.0016 ) ,
   ( n : 300 ; a :  -0.0014 ) ,   ( n : 301 ; a :  -0.0013 ) ,
   ( n : 302 ; a :  -0.0002 ) ,   ( n : 303 ; a :  -0.0001 ) ,
   ( n : 304 ; a :  -0.0016 ) ,   ( n : 305 ; a :  -0.0016 ) ,
   ( n : 306 ; a :   0.0015 ) ,   ( n : 307 ; a :   0.0016 ) ,
   ( n : 308 ; a :   0.0013 ) ,   ( n : 309 ; a :  -0.0016 ) ,
   ( n : 310 ; a :  -0.0013 ) ,   ( n : 311 ; a :  -0.0002 ) ,
   ( n : 312 ; a :  -0.0013 ) ,   ( n : 313 ; a :  -0.0012 ) ,
   ( n : 314 ; a :   0.0018 ) ,   ( n : 315 ; a :  -0.0011 ) ,
   ( n : 316 ; a :   0.0014 ) ,   ( n : 317 ; a :   0.0014 ) ,
   ( n : 318 ; a :   0.0012 ) ,   ( n : 320 ; a :   0.0005 ) ,
   ( n : 321 ; a :   0.0010 ) ,   ( n : 322 ; a :   0.0015 ) ,
   ( n : 323 ; a :   0.0006 ) ,   ( n : 325 ; a :   0.0004 ) ,
   ( n : 326 ; a :   0.0005 ) ,   ( n : 327 ; a :   0.0005 ) ,
   ( n : 328 ; a :  -0.0001 ) ,   ( n : 329 ; a :   0.0003 ) ,
   ( n : 333 ; a :   0.0012 ) ,   ( n : 334 ; a :   0.0007 ) ,
   ( n : 335 ; a :  -0.0011 ) ,   ( n : 336 ; a :  -0.0006 ) ,
   ( n : 337 ; a :  -0.0006 ) ,   ( n : 339 ; a :  -0.0008 ) ,
   ( n : 342 ; a :   0.0008 ) ,   ( n : 344 ; a :   0.0010 ) ,
   ( n : 345 ; a :   0.0005 ) ,   ( n : 346 ; a :   0.0010 ) ,
   ( n : 347 ; a :  -0.0004 ) ,   ( n : 348 ; a :  -0.0006 ) ,
   ( n : 349 ; a :  -0.0012 ) ,   ( n : 351 ; a :   0.0006 ) ,
   ( n : 352 ; a :   0.0009 ) ,   ( n : 353 ; a :   0.0008 ) ,
   ( n : 354 ; a :  -0.0007 ) ,   ( n : 356 ; a :  -0.0010 ) ,
   ( n : 358 ; a :   0.0008 ) ,   ( n : 359 ; a :  -0.0005 ) ,
   ( n : 360 ; a :   0.0007 ) ,   ( n : 361 ; a :  -0.0006 ) ,
   ( n : 363 ; a :   0.0005 ) ,   ( n : 364 ; a :  -0.0008 ) ,
   ( n : 365 ; a :   0.0003 ) ,   ( n : 366 ; a :  -0.0005 ) ,
   ( n : 369 ; a :  -0.0004 ) ,   ( n : 370 ; a :   0.0010 ) ,
   ( n : 371 ; a :   0.0011 ) ,   ( n : 372 ; a :  -0.0004 ) ,
   ( n : 373 ; a :   0.0004 ) ,   ( n : 374 ; a :  -0.0006 ) ,
   ( n : 375 ; a :   0.0009 ) ,   ( n : 377 ; a :  -0.0005 ) ,
   ( n : 379 ; a :   0.0010 ) ,   ( n : 380 ; a :  -0.0005 ) ,
   ( n : 381 ; a :  -0.0009 ) ,   ( n : 382 ; a :   0.0005 ) ,
   ( n : 383 ; a :   0.0011 ) ,   ( n : 385 ; a :   0.0007 ) ,
   ( n : 386 ; a :  -0.0003 ) ,   ( n : 387 ; a :  -0.0004 ) ,
   ( n : 389 ; a :   0.0006 ) ,   ( n : 391 ; a :   0.0006 ) ,
   ( n : 392 ; a :   0.0008 ) ,   ( n : 393 ; a :  -0.0005 ) ,
   ( n : 394 ; a :   0.0009 ) ,   ( n : 395 ; a :   0.0006 ) ,
   ( n : 396 ; a :   0.0005 ) ,   ( n : 397 ; a :  -0.0006 ) ,
   ( n : 400 ; a :  -0.0001 ) ,   ( n : 401 ; a :  -0.0007 ) ,
   ( n : 402 ; a :  -0.0010 ) ,   ( n : 403 ; a :  -0.0005 ) ,
   ( n : 404 ; a :  -0.0001 ) ,   ( n : 405 ; a :   0.0001 ) ,
   ( n : 408 ; a :   0.0003 ) ,   ( n : 410 ; a :  -0.0005 ) ,
   ( n : 411 ; a :   0.0004 ) ,   ( n : 413 ; a :   0.0004 ) ,
   ( n : 414 ; a :  -0.0009 ) ,   ( n : 415 ; a :  -0.0001 ) ,
   ( n : 416 ; a :   0.0008 ) ,   ( n : 417 ; a :   0.0009 ) ,
   ( n : 418 ; a :   0.0010 ) ,   ( n : 419 ; a :  -0.0001 ) ,
   ( n : 420 ; a :  -0.0008 ) ,   ( n : 421 ; a :  -0.0008 ) ,
   ( n : 422 ; a :  -0.0004 ) ,   ( n : 423 ; a :   0.0004 ) ,
   ( n : 424 ; a :   0.0004 ) ,   ( n : 425 ; a :   0.0004 ) ,
   ( n : 426 ; a :  -0.0009 ) ,   ( n : 427 ; a :  -0.0001 ) ,
   ( n : 428 ; a :   0.0004 ) ,   ( n : 429 ; a :   0.0009 ) ,
   ( n : 430 ; a :  -0.0001 ) ,   ( n : 431 ; a :   0.0006 ) ,
   ( n : 432 ; a :   0.0004 ) ,   ( n : 433 ; a :  -0.0002 ) ,
   ( n : 434 ; a :  -0.0010 ) ,   ( n : 435 ; a :  -0.0004 ) ,
   ( n : 436 ; a :   0.0007 ) ,   ( n : 437 ; a :   0.0007 ) ,
   ( n : 438 ; a :  -0.0007 ) ,   ( n : 439 ; a :   0.0010 ) ,
   ( n : 440 ; a :   0.0005 ) ,   ( n : 441 ; a :   0.0011 ) ,
   ( n : 442 ; a :   0.0009 ) ,   ( n : 443 ; a :   0.0005 ) ,
   ( n : 444 ; a :   0.0007 ) ,   ( n : 449 ; a :  -0.0003 ) ,
   ( n : 452 ; a :   0.0001 ) ,   ( n : 453 ; a :  -0.0002 ) ,
   ( n : 455 ; a :  -0.0002 ) ,   ( n : 456 ; a :  -0.0002 ) ,
   ( n : 457 ; a :   0.0001 ) ,   ( n : 458 ; a :   0.0002 ) ,
   ( n : 459 ; a :  -0.0001 ) ,   ( n : 463 ; a :   0.0001 ) ,
   ( n : 464 ; a :  -0.0002 ) ,   ( n : 466 ; a :  -0.0002 ) ,
   ( n : 469 ; a :  -0.0003 ) ,   ( n : 470 ; a :  -0.0001 ) ,
   ( n : 473 ; a :   0.0003 ) ,   ( n : 474 ; a :  -0.0004 ) ,
   ( n : 476 ; a :  -0.0002 ) ,   ( n : 477 ; a :  -0.0002 ) ,
   ( n : 478 ; a :   0.0002 ) ,   ( n : 479 ; a :   0.0003 ) ,
   ( n : 480 ; a :   0.0002 ) ,   ( n : 481 ; a :   0.0001 ) ,
   ( n : 483 ; a :   0.0001 ) ,   ( n : 484 ; a :  -0.0003 ) ,
   ( n : 485 ; a :   0.0002 ) ,   ( n : 486 ; a :  -0.0002 ) ,
   ( n : 487 ; a :   0.0003 ) ,   ( n : 489 ; a :   0.0002 ) ,
   ( n : 490 ; a :  -0.0002 ) ,   ( n : 491 ; a :   0.0003 ) ,
   ( n : 493 ; a :  -0.0003 ) ,   ( n : 494 ; a :   0.0002 ) ,
   ( n : 497 ; a :   0.0001 ) ,   ( n : 500 ; a :   0.0002 ) ,
   ( n : 501 ; a :  -0.0002 ) ,   ( n : 502 ; a :  -0.0001 ) ,
   ( n : 503 ; a :   0.0002 ) ,   ( n : 504 ; a :  -0.0002 ) ,
   ( n : 505 ; a :  -0.0003 ) ,   ( n : 507 ; a :  -0.0002 ) ,
   ( n : 508 ; a :   0.0002 ) ,   ( n : 509 ; a :   0.0002 ) ,
   ( n : 510 ; a :  -0.0003 ) ,   ( n : 513 ; a :  -0.0002 ) ,
   ( n : 516 ; a :   0.0002 ) ,   ( n : 517 ; a :  -0.0001 ) ,
   ( n : 518 ; a :  -0.0001 ) ,   ( n : 519 ; a :   0.0001 ) ,
   ( n : 520 ; a :  -0.0003 ) ,   ( n : 522 ; a :   0.0001 ) ,
   ( n : 525 ; a :   0.0002 ) ,   ( n : 528 ; a :   0.0003 ) ,
   ( n : 532 ; a :  -0.0001 ) ,   ( n : 533 ; a :   0.0006 ) ,
   ( n : 537 ; a :   0.0004 ) ,   ( n : 538 ; a :   0.0002 ) ,
   ( n : 539 ; a :  -0.0002 ) ,   ( n : 540 ; a :  -0.0002 ) ,
   ( n : 541 ; a :  -0.0003 ) ,   ( n : 543 ; a :   0.0002 ) ,
   ( n : 544 ; a :   0.0002 ) ,   ( n : 545 ; a :   0.0002 ) ,
   ( n : 550 ; a :   0.0001 ) ,   ( n : 551 ; a :   0.0002 ) ,
   ( n : 555 ; a :   0.0003 ) ,   ( n : 558 ; a :  -0.0001 ) ,
   ( n : 560 ; a :   0.0002 ) ,   ( n : 561 ; a :   0.0003 ) ,
   ( n : 562 ; a :  -0.0002 ) ,   ( n : 566 ; a :  -0.0003 ) ,
   ( n : 567 ; a :   0.0001 ) ,   ( n : 569 ; a :  -0.0003 ) ,
   ( n : 570 ; a :   0.0003 ) ,   ( n : 571 ; a :  -0.0003 ) ,
   ( n : 572 ; a :   0.0002 ) ,   ( n : 574 ; a :   0.0001 ) ,
   ( n : 575 ; a :  -0.0001 ) ,   ( n : 576 ; a :   0.0002 ) ,
   ( n : 577 ; a :  -0.0004 ) ,   ( n : 578 ; a :  -0.0001 ) ,
   ( n : 580 ; a :   0.0003 ) ,   ( n : 581 ; a :   0.0002 ) ,
   ( n : 582 ; a :   0.0004 ) ,   ( n : 583 ; a :   0.0003 ) ,
   ( n : 584 ; a :   0.0002 ) ,   ( n : 585 ; a :  -0.0001 ) ,
   ( n : 586 ; a :  -0.0003 ) ,   ( n : 587 ; a :   0.0003 ) ,
   ( n : 589 ; a :  -0.0001 ) ,   ( n : 590 ; a :  -0.0002 ) ,
   ( n : 591 ; a :   0.0002 ) ,   ( n : 593 ; a :   0.0002 ) ,
   ( n : 595 ; a :  -0.0003 ) ,   ( n : 596 ; a :   0.0002 ) ,
   ( n : 599 ; a :  -0.0003 ) ,   ( n : 601 ; a :  -0.0002 ) ,
   ( n : 602 ; a :  -0.0002 ) ,   ( n : 603 ; a :  -0.0003 ) ,
   ( n : 606 ; a :   0.0002 ) ,   ( n : 607 ; a :   0.0002 ) ,
   ( n : 608 ; a :   0.0002 ) ,   ( n : 609 ; a :   0.0003 ) ,
   ( n : 610 ; a :  -0.0002 ) ,   ( n : 612 ; a :   0.0002 ) ,
   ( n : 614 ; a :  -0.0002 ) ,   ( n : 616 ; a :  -0.0002 ) ,
   ( n : 618 ; a :  -0.0002 ) ,   ( n : 619 ; a :   0.0002 ) ,
   ( n : 620 ; a :  -0.0003 ) ,   ( n : 621 ; a :  -0.0002 ) ,
   ( n : 627 ; a :  -0.0001 ) ,   ( n : 628 ; a :   0.0001 ) ,
   ( n : 630 ; a :   0.0004 ) ,   ( n : 631 ; a :  -0.0003 ) ,
   ( n : 633 ; a :  -0.0003 ) ,   ( n : 634 ; a :  -0.0001 ) ,
   ( n : 636 ; a :   0.0001 ) ,   ( n : 637 ; a :   0.0003 ) ,
   ( n : 638 ; a :   0.0002 ) ,   ( n : 639 ; a :   0.0002 ) ,
   ( n : 641 ; a :  -0.0001 ) ,   ( n : 642 ; a :   0.0002 ) ,
   ( n : 645 ; a :  -0.0003 ) ,   ( n : 646 ; a :  -0.0002 ) ,
   ( n : 647 ; a :   0.0003 ) ,   ( n : 648 ; a :  -0.0002 ) ,
   ( n : 649 ; a :  -0.0003 ) ,   ( n : 651 ; a :   0.0003 ) ,
   ( n : 652 ; a :  -0.0002 ) ,   ( n : 653 ; a :  -0.0004 ) ,
   ( n : 654 ; a :  -0.0002 ) ,   ( n : 655 ; a :   0.0002 ) ,
   ( n : 657 ; a :   0.0003 ) ,   ( n : 658 ; a :   0.0003 ) ,
   ( n : 659 ; a :   0.0002 ) ,   ( n : 661 ; a :   0.0002 ) ,
   ( n : 663 ; a :  -0.0003 ) ,   ( n : 666 ; a :  -0.0002 ) ,
   ( n : 667 ; a :   0.0002 ) ,   ( n : 668 ; a :  -0.0002 ) ,
   ( n : 669 ; a :  -0.0002 ) ,   ( n : 670 ; a :  -0.0002 ) ,
   ( n : 671 ; a :   0.0002 ) ,   ( n : 672 ; a :   0.0002 ) ,
   ( n : 673 ; a :   0.0002 ) ,   ( n : 674 ; a :  -0.0002 ) ,
   ( n : 675 ; a :  -0.0001 ) ,   ( n : 676 ; a :   0.0001 ) ,
   ( n : 677 ; a :   0.0001 ) ,   ( n : 678 ; a :   0.0002 ) ) ;
   AmpPCos  : Array [1..179] of TOneAmp =
 ( ( n :   1 ; a :   3.3386 ) ,   ( n :   2 ; a :  -1.3696 ) ,
   ( n :   3 ; a :   0.2796 ) ,   ( n :   4 ; a :  -0.0698 ) ,
   ( n :   5 ; a :   1.1817 ) ,   ( n :   6 ; a :  -0.0524 ) ,
   ( n :   7 ; a :  -0.0872 ) ,   ( n :   8 ; a :   0.0380 ) ,
   ( n :   9 ; a :   0.0816 ) ,   ( n :  10 ; a :   0.0111 ) ,
   ( n :  11 ; a :   0.0181 ) ,   ( n :  12 ; a :   0.0019 ) ,
   ( n :  13 ; a :  -0.0168 ) ,   ( n :  14 ; a :   0.0027 ) ,
   ( n :  15 ; a :  -0.0189 ) ,   ( n :  16 ; a :   0.0149 ) ,
   ( n :  17 ; a :   0.0129 ) ,   ( n :  18 ; a :   0.0031 ) ,
   ( n :  19 ; a :  -0.0150 ) ,   ( n :  20 ; a :   0.0158 ) ,
   ( n :  22 ; a :  -0.0018 ) ,   ( n :  23 ; a :   0.0131 ) ,
   ( n :  24 ; a :  -0.0001 ) ,   ( n :  25 ; a :   0.0010 ) ,
   ( n :  26 ; a :  -0.0074 ) ,   ( n :  27 ; a :  -0.0066 ) ,
   ( n :  28 ; a :   0.0079 ) ,   ( n :  29 ; a :   0.0011 ) ,
   ( n :  30 ; a :  -0.0016 ) ,   ( n :  31 ; a :   0.0013 ) ,
   ( n :  32 ; a :  -0.0037 ) ,   ( n :  33 ; a :   0.0063 ) ,
   ( n :  34 ; a :   0.0025 ) ,   ( n :  35 ; a :  -0.0010 ) ,
   ( n :  36 ; a :   0.0044 ) ,   ( n :  37 ; a :  -0.0014 ) ,
   ( n :  38 ; a :  -0.0011 ) ,   ( n :  39 ; a :   0.0025 ) ,
   ( n :  40 ; a :   0.0008 ) ,   ( n :  41 ; a :   0.0002 ) ,
   ( n :  42 ; a :   0.0002 ) ,   ( n :  43 ; a :  -0.0007 ) ,
   ( n :  44 ; a :  -0.0015 ) ,   ( n :  45 ; a :   0.0021 ) ,
   ( n :  46 ; a :  -0.0003 ) ,   ( n :  47 ; a :  -0.0021 ) ,
   ( n :  48 ; a :  -0.0008 ) ,   ( n :  49 ; a :   0.0006 ) ,
   ( n :  50 ; a :  -0.0024 ) ,   ( n :  51 ; a :   0.0005 ) ,
   ( n :  52 ; a :  -0.0006 ) ,   ( n :  53 ; a :  -0.0002 ) ,
   ( n :  54 ; a :   0.0015 ) ,   ( n :  55 ; a :  -0.0010 ) ,
   ( n :  56 ; a :   0.0008 ) ,   ( n :  57 ; a :   0.0005 ) ,
   ( n :  58 ; a :   0.0007 ) ,   ( n :  59 ; a :   0.0005 ) ,
   ( n :  60 ; a :   0.0011 ) ,   ( n :  61 ; a :  -0.0010 ) ,
   ( n :  62 ; a :  -0.0007 ) ,   ( n :  63 ; a :  -0.0002 ) ,
   ( n :  64 ; a :   0.0001 ) ,   ( n :  65 ; a :   0.0005 ) ,
   ( n :  66 ; a :  -0.0013 ) ,   ( n :  67 ; a :  -0.0006 ) ,
   ( n :  69 ; a :  -0.0353 ) ,   ( n :  70 ; a :  -0.0005 ) ,
   ( n :  71 ; a :   0.0009 ) ,   ( n :  74 ; a :   0.0008 ) ,
   ( n :  75 ; a :  -0.0002 ) ,   ( n :  76 ; a :   0.0004 ) ,
   ( n :  78 ; a :   0.0005 ) ,   ( n :  79 ; a :  -0.0003 ) ,
   ( n :  80 ; a :  -0.0001 ) ,   ( n :  81 ; a :   0.0009 ) ,
   ( n :  82 ; a :   0.0002 ) ,   ( n :  83 ; a :  -0.0006 ) ,
   ( n :  84 ; a :  -0.0003 ) ,   ( n :  85 ; a :  -0.0001 ) ,
   ( n :  86 ; a :  -0.0001 ) ,   ( n :  87 ; a :   0.0002 ) ,
   ( n :  89 ; a :  -0.0005 ) ,   ( n :  90 ; a :  -0.0002 ) ,
   ( n :  91 ; a :  -0.0003 ) ,   ( n :  92 ; a :   0.0001 ) ,
   ( n :  93 ; a :  -0.0025 ) ,   ( n :  94 ; a :  -0.0004 ) ,
   ( n :  95 ; a :  -0.0003 ) ,   ( n :  96 ; a :   0.0001 ) ,
   ( n :  98 ; a :   0.0005 ) ,   ( n :  99 ; a :  -0.0001 ) ,
   ( n : 100 ; a :  -0.0002 ) ,   ( n : 101 ; a :   0.0001 ) ,
   ( n : 104 ; a :   0.0004 ) ,   ( n : 105 ; a :  -0.0002 ) ,
   ( n : 106 ; a :   0.0003 ) ,   ( n : 107 ; a :   0.0001 ) ,
   ( n : 108 ; a :  -0.0003 ) ,   ( n : 109 ; a :  -0.0002 ) ,
   ( n : 110 ; a :   0.0001 ) ,   ( n : 112 ; a :  -0.0001 ) ,
   ( n : 113 ; a :   0.0001 ) ,   ( n : 114 ; a :   0.0002 ) ,
   ( n : 115 ; a :   0.0002 ) ,   ( n : 117 ; a :   0.0001 ) ,
   ( n : 119 ; a :   0.0002 ) ,   ( n : 123 ; a :  -0.0002 ) ,
   ( n : 124 ; a :  -0.0002 ) ,   ( n : 126 ; a :  -0.0001 ) ,
   ( n : 127 ; a :  -0.0003 ) ,   ( n : 128 ; a :   0.0001 ) ,
   ( n : 130 ; a :  -0.0001 ) ,   ( n : 131 ; a :  -0.0001 ) ,
   ( n : 132 ; a :   0.0001 ) ,   ( n : 133 ; a :   0.0001 ) ,
   ( n : 134 ; a :  -0.0001 ) ,   ( n : 136 ; a :  -0.0002 ) ,
   ( n : 137 ; a :  -0.0002 ) ,   ( n : 138 ; a :  -0.0001 ) ,
   ( n : 139 ; a :  -0.0001 ) ,   ( n : 140 ; a :   0.0001 ) ,
   ( n : 141 ; a :   0.0002 ) ,   ( n : 142 ; a :   0.0001 ) ,
   ( n : 144 ; a :  -0.0002 ) ,   ( n : 147 ; a :   0.0002 ) ,
   ( n : 148 ; a :  -0.0001 ) ,   ( n : 150 ; a :   0.0001 ) ,
   ( n : 151 ; a :  -0.0001 ) ,   ( n : 152 ; a :   0.0001 ) ,
   ( n : 154 ; a :   0.0001 ) ,   ( n : 155 ; a :  -0.0002 ) ,
   ( n : 156 ; a :   0.0001 ) ,   ( n : 158 ; a :  -0.0001 ) ,
   ( n : 159 ; a :   0.0002 ) ,   ( n : 162 ; a :   0.0001 ) ,
   ( n : 163 ; a :  -0.0001 ) ,   ( n : 166 ; a :  -0.0001 ) ,
   ( n : 168 ; a :   0.0001 ) ,   ( n : 169 ; a :   0.0001 ) ,
   ( n : 170 ; a :   0.0002 ) ,   ( n : 172 ; a :  -0.0004 ) ,
   ( n : 178 ; a :  -0.0028 ) ,   ( n : 181 ; a :  -0.0001 ) ,
   ( n : 182 ; a :  -0.0001 ) ,   ( n : 183 ; a :   0.0001 ) ,
   ( n : 184 ; a :   0.0001 ) ,   ( n : 191 ; a :   0.0001 ) ,
   ( n : 193 ; a :  -0.0001 ) ,   ( n : 196 ; a :  -0.0001 ) ,
   ( n : 200 ; a :  -0.0001 ) ,   ( n : 203 ; a :   0.0001 ) ,
   ( n : 204 ; a :  -0.0005 ) ,   ( n : 212 ; a :   0.0010 ) ,
   ( n : 223 ; a :   0.0001 ) ,   ( n : 224 ; a :   0.0001 ) ,
   ( n : 236 ; a :  -0.0003 ) ,   ( n : 253 ; a :  -0.0003 ) ,
   ( n : 266 ; a :  -0.0001 ) ,   ( n : 445 ; a :  -0.1988 ) ,
   ( n : 446 ; a :  -0.0063 ) ,   ( n : 448 ; a :   0.0005 ) ,
   ( n : 450 ; a :   0.0364 ) ,   ( n : 451 ; a :  -0.1044 ) ,
   ( n : 454 ; a :   0.0330 ) ,   ( n : 462 ; a :   0.0005 ) ,
   ( n : 475 ; a :  -0.0012 ) ,   ( n : 533 ; a :   0.0013 ) ,
   ( n : 534 ; a :   0.0030 ) ,   ( n : 535 ; a :  -0.0162 ) ,
   ( n : 536 ; a :   0.0075 ) ,   ( n : 555 ; a :  -0.0003 ) ,
   ( n : 556 ; a :  -0.0003 ) ,   ( n : 561 ; a :   0.0003 ) ,
   ( n : 563 ; a :  -0.0013 ) ,   ( n : 564 ; a :   0.0006 ) ,
   ( n : 597 ; a :  -0.0026 ) ,   ( n : 598 ; a :  -0.0010 ) ,
   ( n : 629 ; a :  -0.0005 ) ) ;
   AmpESin  : Array [1..133] of TOneAmp =
 ( ( n :   1 ; a :   1.5377 ) ,   ( n :   2 ; a :  -0.4587 ) ,
   ( n :   3 ; a :   0.1374 ) ,   ( n :   4 ; a :  -0.0291 ) ,
   ( n :   5 ; a :  -0.1924 ) ,   ( n :   6 ; a :  -0.0174 ) ,
   ( n :   7 ; a :   0.0358 ) ,   ( n :   8 ; a :   0.0318 ) ,
   ( n :   9 ; a :   0.0367 ) ,   ( n :  10 ; a :   0.0132 ) ,
   ( n :  11 ; a :   0.0039 ) ,   ( n :  12 ; a :  -0.0004 ) ,
   ( n :  13 ; a :   0.0082 ) ,   ( n :  14 ; a :  -0.0009 ) ,
   ( n :  15 ; a :  -0.0075 ) ,   ( n :  16 ; a :   0.0066 ) ,
   ( n :  17 ; a :   0.0078 ) ,   ( n :  18 ; a :   0.0020 ) ,
   ( n :  19 ; a :   0.0029 ) ,   ( n :  20 ; a :   0.0068 ) ,
   ( n :  22 ; a :  -0.0025 ) ,   ( n :  23 ; a :   0.0059 ) ,
   ( n :  24 ; a :  -0.0003 ) ,   ( n :  25 ; a :  -0.0003 ) ,
   ( n :  26 ; a :   0.0013 ) ,   ( n :  27 ; a :   0.0011 ) ,
   ( n :  28 ; a :  -0.0045 ) ,   ( n :  29 ; a :  -0.0001 ) ,
   ( n :  30 ; a :  -0.0005 ) ,   ( n :  31 ; a :   0.0013 ) ,
   ( n :  32 ; a :  -0.0014 ) ,   ( n :  33 ; a :   0.0026 ) ,
   ( n :  34 ; a :   0.0015 ) ,   ( n :  35 ; a :   0.0010 ) ,
   ( n :  36 ; a :   0.0019 ) ,   ( n :  37 ; a :   0.0002 ) ,
   ( n :  38 ; a :  -0.0005 ) ,   ( n :  39 ; a :   0.0014 ) ,
   ( n :  40 ; a :   0.0004 ) ,   ( n :  41 ; a :   0.0004 ) ,
   ( n :  42 ; a :  -0.0001 ) ,   ( n :  43 ; a :  -0.0004 ) ,
   ( n :  44 ; a :  -0.0005 ) ,   ( n :  45 ; a :   0.0012 ) ,
   ( n :  46 ; a :  -0.0003 ) ,   ( n :  47 ; a :  -0.0009 ) ,
   ( n :  48 ; a :   0.0004 ) ,   ( n :  49 ; a :   0.0001 ) ,
   ( n :  50 ; a :   0.0002 ) ,   ( n :  51 ; a :   0.0001 ) ,
   ( n :  52 ; a :   0.0003 ) ,   ( n :  53 ; a :  -0.0001 ) ,
   ( n :  54 ; a :   0.0007 ) ,   ( n :  55 ; a :   0.0002 ) ,
   ( n :  56 ; a :   0.0004 ) ,   ( n :  57 ; a :  -0.0002 ) ,
   ( n :  58 ; a :   0.0003 ) ,   ( n :  59 ; a :  -0.0002 ) ,
   ( n :  60 ; a :   0.0005 ) ,   ( n :  61 ; a :  -0.0004 ) ,
   ( n :  62 ; a :  -0.0003 ) ,   ( n :  63 ; a :  -0.0002 ) ,
   ( n :  65 ; a :  -0.0002 ) ,   ( n :  66 ; a :   0.0001 ) ,
   ( n :  67 ; a :  -0.0002 ) ,   ( n :  69 ; a :  -0.0139 ) ,
   ( n :  70 ; a :  -0.0002 ) ,   ( n :  71 ; a :   0.0004 ) ,
   ( n :  74 ; a :   0.0004 ) ,   ( n :  75 ; a :  -0.0002 ) ,
   ( n :  76 ; a :   0.0002 ) ,   ( n :  78 ; a :   0.0002 ) ,
   ( n :  79 ; a :  -0.0001 ) ,   ( n :  80 ; a :  -0.0001 ) ,
   ( n :  81 ; a :   0.0004 ) ,   ( n :  82 ; a :   0.0001 ) ,
   ( n :  84 ; a :  -0.0001 ) ,   ( n :  85 ; a :  -0.0001 ) ,
   ( n :  86 ; a :  -0.0001 ) ,   ( n :  87 ; a :   0.0001 ) ,
   ( n :  88 ; a :   0.0001 ) ,   ( n :  90 ; a :  -0.0001 ) ,
   ( n :  91 ; a :   0.0001 ) ,   ( n :  93 ; a :  -0.0010 ) ,
   ( n :  94 ; a :   0.0002 ) ,   ( n :  95 ; a :  -0.0001 ) ,
   ( n :  96 ; a :   0.0001 ) ,   ( n :  98 ; a :   0.0002 ) ,
   ( n :  99 ; a :  -0.0001 ) ,   ( n : 100 ; a :  -0.0001 ) ,
   ( n : 101 ; a :  -0.0001 ) ,   ( n : 104 ; a :   0.0002 ) ,
   ( n : 105 ; a :  -0.0001 ) ,   ( n : 106 ; a :   0.0002 ) ,
   ( n : 108 ; a :  -0.0001 ) ,   ( n : 109 ; a :  -0.0001 ) ,
   ( n : 110 ; a :   0.0001 ) ,   ( n : 112 ; a :  -0.0001 ) ,
   ( n : 114 ; a :   0.0001 ) ,   ( n : 115 ; a :   0.0001 ) ,
   ( n : 117 ; a :   0.0001 ) ,   ( n : 124 ; a :  -0.0001 ) ,
   ( n : 126 ; a :  -0.0001 ) ,   ( n : 131 ; a :  -0.0001 ) ,
   ( n : 138 ; a :  -0.0001 ) ,   ( n : 141 ; a :   0.0001 ) ,
   ( n : 147 ; a :   0.0001 ) ,   ( n : 159 ; a :   0.0001 ) ,
   ( n : 170 ; a :   0.0001 ) ,   ( n : 172 ; a :  -0.0002 ) ,
   ( n : 178 ; a :   0.0011 ) ,   ( n : 184 ; a :   0.0001 ) ,
   ( n : 204 ; a :  -0.0002 ) ,   ( n : 212 ; a :  -0.0002 ) ,
   ( n : 236 ; a :  -0.0001 ) ,   ( n : 253 ; a :  -0.0001 ) ,
   ( n : 331 ; a :  -0.0002 ) ,   ( n : 445 ; a :  -0.1679 ) ,
   ( n : 446 ; a :  -0.0027 ) ,   ( n : 448 ; a :   0.0004 ) ,
   ( n : 450 ; a :   0.0176 ) ,   ( n : 451 ; a :  -0.0891 ) ,
   ( n : 475 ; a :  -0.0010 ) ,   ( n : 533 ; a :  -0.0005 ) ,
   ( n : 534 ; a :   0.0014 ) ,   ( n : 535 ; a :  -0.0138 ) ,
   ( n : 555 ; a :   0.0001 ) ,   ( n : 556 ; a :  -0.0002 ) ,
   ( n : 561 ; a :  -0.0001 ) ,   ( n : 563 ; a :  -0.0011 ) ,
   ( n : 597 ; a :  -0.0011 ) ,   ( n : 598 ; a :  -0.0005 ) ,
   ( n : 629 ; a :  -0.0002 ) ) ;
   AmpPtsin  : Array [1..37] of TOneAmp =
 ( ( n :   1 ; a : -17.4666 ) ,   ( n :   2 ; a :  -0.1675 ) ,
   ( n :   3 ; a :  -0.0234 ) ,   ( n :   4 ; a :   0.0207 ) ,
   ( n :   5 ; a :  -0.3633 ) ,   ( n :   6 ; a :   0.1226 ) ,
   ( n :   7 ; a :   0.0073 ) ,   ( n :   8 ; a :  -0.0367 ) ,
   ( n :   9 ; a :  -0.0036 ) ,   ( n :  10 ; a :  -0.0494 ) ,
   ( n :  11 ; a :   0.0137 ) ,   ( n :  12 ; a :   0.0011 ) ,
   ( n :  13 ; a :   0.0010 ) ,   ( n :  14 ; a :   0.0063 ) ,
   ( n :  15 ; a :  -0.0063 ) ,   ( n :  16 ; a :  -0.0011 ) ,
   ( n :  17 ; a :  -0.0042 ) ,   ( n :  18 ; a :   0.0050 ) ,
   ( n :  19 ; a :   0.0011 ) ,   ( n :  20 ; a :  -0.0001 ) ,
   ( n :  23 ; a :  -0.0001 ) ,   ( n :  25 ; a :   0.0021 ) ,
   ( n :  28 ; a :  -0.0025 ) ,   ( n :  29 ; a :   0.0010 ) ,
   ( n :  30 ; a :   0.0072 ) ,   ( n :  32 ; a :  -0.0010 ) ,
   ( n :  33 ; a :   0.0011 ) ,   ( n :  35 ; a :  -0.0085 ) ,
   ( n :  38 ; a :  -0.0021 ) ,   ( n :  39 ; a :  -0.0011 ) ,
   ( n :  40 ; a :   0.0021 ) ,   ( n :  41 ; a :  -0.0011 ) ,
   ( n :  42 ; a :   0.0010 ) ,   ( n :  44 ; a :  -0.0011 ) ,
   ( n :  46 ; a :  -0.0011 ) ,   ( n :  47 ; a :  -0.0011 ) ,
   ( n : 123 ; a :  -0.0011 ) ) ;
   AmpEtcos  : Array [1..19] of TOneAmp =
 ( ( n :   1 ; a :   0.9086 ) ,   ( n :   2 ; a :  -0.3015 ) ,
   ( n :   3 ; a :  -0.0485 ) ,   ( n :   4 ; a :   0.0470 ) ,
   ( n :   5 ; a :  -0.0184 ) ,   ( n :   6 ; a :  -0.0677 ) ,
   ( n :   8 ; a :   0.0018 ) ,   ( n :   9 ; a :  -0.0063 ) ,
   ( n :  10 ; a :   0.0299 ) ,   ( n :  11 ; a :  -0.0009 ) ,
   ( n :  12 ; a :   0.0032 ) ,   ( n :  16 ; a :  -0.0011 ) ,
   ( n :  18 ; a :  -0.0010 ) ,   ( n :  20 ; a :  -0.0011 ) ,
   ( n :  23 ; a :  -0.0011 ) ,   ( n :  24 ; a :   0.0010 ) ,
   ( n :  28 ; a :  -0.0002 ) ,   ( n :  30 ; a :  -0.0042 ) ,
   ( n :  35 ; a :  -0.0001 ) ) ;
   AmpPtcos  : Array [1..6] of TOneAmp =
 ( ( n :   1 ; a :   0.0029 ) ,   ( n :   2 ; a :   0.0012 ) ,
   ( n :   3 ; a :   0.0002 ) ,   ( n :   5 ; a :  -0.0015 ) ,
   ( n :   6 ; a :   0.0002 ) ,   ( n :   8 ; a :   0.0001 ) ) ;
   AmpEtsin  : Array [1..5] of TOneAmp =
 ( ( n :   1 ; a :   0.0002 ) ,   ( n :   2 ; a :  -0.0003 ) ,
   ( n :   3 ; a :  -0.0001 ) ,   ( n :   5 ; a :   0.0005 ) ,
   ( n :  10 ; a :  -0.0001 ) ) ;
 Var
   i        : Byte ;
   t        : Extended ;
   narg     : Word ;
   argn     : TFundArg ;
   carg     : Extended ;
   sa,ca    : Extended ;
   aps,apc  : TOneAmp ;
   dps,dpc  : TOneAmp ;
   aec,aes  : TOneAmp ;
   dec,des  : TOneAmp ;
   nps,nec  : Word ; { 646 , 549 }
   npc,nes  : Byte ; { 179 , 133 }
   kps,kpc  : Byte ; {  37 ,   6 }
   kec,kes  : Byte ; {  19 ,   5 }
 Begin
   FundArgLuSo(DateJulian,argn);
   t:=(DateJulian-JD2000)/JulianC;
   DPsi:=0.0;
   DEps:=0.0;
   nps:=1;
   npc:=1;
   nec:=1;
   nes:=1;
   kps:=1;
   kpc:=1;
   kec:=1;
   kes:=1;
   aps:=AmpPSin[nps];
   apc:=AmpPCos[npc];
   aec:=AmpECos[nec];
   aes:=AmpESin[nes];
   dps:=AmpPtsin[kps];
   dpc:=AmpPtcos[kpc];
   dec:=AmpEtcos[kec];
   des:=AmpEtsin[kes];
   For narg:=1 To 678 Do
     Begin
       carg:=0;
       For i:=1 To 5 Do
         If  NArgLuSo[narg,i] <> 0
           Then
             carg:=carg+NArgLuSo[narg,i]*argn[i];
       ca:=Cos(carg);
       sa:=Sin(carg);
       If  narg <= 13
         Then { the big 13 terms in psi and 13 terms in epsilon }
           Begin
             DPsi:=DPsi+AmpPsi[narg]*sa;
             DEps:=DEps+AmpEps[narg]*ca;
           End;
       If  narg = aps.n
         Then { psi in phase 646 terms sin }
           Begin
             DPsi:=DPsi+aps.a*sa;
             nps:=nps+1;
             If  nps <= 646  Then  aps:=AmpPSin[nps];
           End;
       If  narg = aec.n
         Then { epsilon in phase 549 terms cos }
           Begin
             DEps:=DEps+aec.a*ca;
             nec:=nec+1;
             If  nec <= 549  Then  aec:=AmpECos[nec];
           End;
       If  narg = apc.n
         Then { psi out phase cos 179 terms }
           Begin
             DPsi:=DPsi+apc.a*ca;
             npc:=npc+1;
             If  npc <= 179  Then  apc:=AmpPCos[npc];
           End;
       If  narg = aes.n
         Then { eps out phase sin 133 terms }
           Begin
             DEps:=DEps+aes.a*sa;
             nes:=nes+1;
             If  nes <= 133  Then  aes:=AmpESin[nes];
           End;
       If  narg = dps.n
         Then { psi in phase t*sin 37 terms }
           Begin
             DPsi:=DPsi+dps.a*t*sa;
             kps:=kps+1;
             If  kps <= 37  Then  dps:=AmpPtsin[kps];
           End;
       If  narg = dec.n
         Then { eps in phase t*cos 19 terms }
           Begin
             DEps:=DEps+dec.a*t*ca;
             kec:=kec+1;
             If  kec <= 19  Then  dec:=AmpEtcos[kec];
           End;
       If  narg = dpc.n
         Then { psi out phase t*cos 6 terms }
           Begin
             DPsi:=DPsi+dpc.a*t*ca;
             kpc:=kpc+1;
             If  kpc <= 6  Then  dpc:=AmpPtcos[kpc];
           End;
       If  narg = des.n
         Then { eps out phase t*sin 5 terms }
           Begin
             DEps:=DEps+des.a*t*sa;
             kes:=kes+1;
             If  kes <= 5  Then  des:=AmpEtsin[kes];
           End;
     End;
   DPsi:=1.0e-3*Dpsi; { in arcsec }
   DEps:=1.0e-3*DEps; { in arcsec }
 End;

 END.
