 UNIT UnConTyp ;
 INTERFACE
 Const
   GraRad   = Pi / 180 ;
   RadGra   = 180 / Pi ;
   SecRad   = GraRad / 3600 ;
   RadSec   = 3600 / GraRad ;
   RadRev   = 43200.0 / Pi ;  { from rad/sec to rev/day }
   TwoPi    = 2 * Pi ;
   Pi22     = TwoPi ;
   HalfPi   = Pi / 2 ; 
 Const
   JD2000   = 2451545.0 ;
   JulianC  =   36525.0 ;
   DifEpoch = 2400000.5 ;
   MJD2000  = JD2000-DifEpoch ;
 Const
   GaussConst       = 0.0172020989500000e0 ;
   { in AstrUnit**3/((Ephemer.Day**2)*MassOfSun if in Sqr }
   CavendishConst   = 6.672e-20 ;     { in km**3/(kg*s**2) f }
   AstrUnit         = 1.49597870691e8 ;  { in km }
   VelOfLight       = 299792.4580 ;   { in km/s }
   VelOfRot         = 0.7292115e-4 ;  { the rotation of the Earth rad/s }
 Const
   GeoFM    : Extended  = 3.98600448e5 ; { km**3/s**2 f*M_Earth}
   GeoR0    : Extended  = 6.37814000e3 ; { km }
   ParmA    : Extended  = 1.0/298.257 ; // oblateness of the Earth
 Const
   FMoon    = 4902.799 ;      { km^3/s^2 for the Moon f*M_Moon}
   FSoon    = 1.32712438e11 ; { km^3/s^2 for the Sun  f*M_Sun}
   ScalMor  = 3422.54*SecRad ; { scale factor for Moon range ~ 1/60 }
 Type
   TVect3    = Array [1..3] of Extended ;
   TMatr33   = Array [1..3] of TVect3 ;
   TFundArg  = Array [1..14] of Extended ;
   TypeDim3  = TVect3 ;
   TypeDim33 = TMatr33 ;
 Type
   TDim11    = Array [1..11] of Extended ; // for UnitCEil class TCeil
   TEilParm  = Array [1..90] of Extended ; // for UnitCEil class TCeil
   TEilPang  = record                      // record with angle
                 pelm  : TEilParm ;        // parameter
                 angl  : Extended ;        // angle l radian
                 angg  : Extended ;        // angle g radian \omega+90 degree
                 angh  : Extended ;        // angle h radian \Omega-90 degree
               end;
   { the first partial derivations with respect to a e \delta param. 1 }
   TPartDer  = array [1..4] of Extended ; // derivations values in 2 3 4
   TPartDim  = array[1..11] of TPartDer ; // array of parameter UnitDelm
 IMPLEMENTATION
 END.
