
 { some routines for Eiler elements }

 UNIT UnForEil ;

 INTERFACE

 Uses
   UnConTyp ;

 Type
   TDim90   = Array [1..90] of Extended ;

 Procedure EilConst ( Var  c  : TDim90 ;
                      a1 , a2 , a3   : Extended ;
                      Var  edl , edg , edh    : Extended ) ;

 Procedure FromCartToEiler ( xx , vv     : TVect3 ; { type UnConTyp }
                             Var  ceil   : TDim90 ;
                             Var  ul , ug , uh  : Extended ) ;

 Procedure orbxv ( c    : TDim90 ;
                   ul , ug , uh  : Extended ;
                   Var  xx , vv  : TVect3 ) ; { type UnConTyp }

 Procedure FromElemToC ( an0 , ae , Incl     : Extended ;
                         Var   ceil          : TDim90 ;
                         Var   a1 , a2 , a3  : Extended ) ;

 IMPLEMENTATION

 Uses
   UnForFun , { for DATan2 }
   UnForKep ; // function KeplerEquation

 Const
   ol    = 0.0e0;
   o     = 1.0e0;
   w     = 2.0e0;
   t1    = 0.50e0;
   t2    = 0.375e0;
   t3    = 0.3125e0;
   t4    = 0.2734375e0;
   t5    = 2.46093750e-1;

 Const
   m     = 3;
   n11   = 11;
   n2    = 2;
   n3    = 3;
   n10   = n11-1;
   n5    = n10 div 2;
   n9    = n11-2;
   n8    = n11-3;
   n7    = n11-4;
   n6    = n11-5;

 Const
   ww    : Array [1..n8] of Byte =
         ( 0 , 2 , 0 , 6 , 0 , 20 , 0 , 70 ) ;

 Type
   TDim11   = Array [1..11] of Extended ;

 Var
   uu    : Array [1..n10,1..n10] of Extended ;
   tt    : Array [1..n6] of Extended ;
   td    : Array [1..n10] of Extended ;

 Var
   a,b,d,f,
   e,g,h,hh,
   g1,g2,g3,g4,g5          : TDim11 ;
   vv,ee,
   bks,bps,u,p,v,
   bks2,bks4,bks6,
   bks8,bps2,bps3,bps4     : TDim11 ;
   axx                     : Array [1..n6] of Extended ;
   aqf,acp,aff,app         : Array[1..n10] of Extended ;
   akp,akf                 : Array [1..n5] of Extended ;

 Var
   se,ce,ea,cpp,spp,ep,
   sff,cff,ef,pc,fc,ps,
   fs,uc,vc,us,rf,rp,ru    : Extended ;
   pudl,r4,r5,sw,cw,uw,bw  : Extended ;
   fm,rz,cj2,sig,ka2       : Extended ;
   fem,fa,ab,
   an0,fe,re,p3,fd,
   rd,rdz,pa,z2,z0,pe      : Extended ;
   p2,p1,p4,p5,d2,
   ad,rr,rc,rt,dz2,qdz     : Extended ;
   adz,rrz,rcz,e2,ae,az,
   x1,x2,al1,bc,pq22,ba    : Extended ;
   akr,bkr,ag1,ag2,r1,r2   : Extended ;
   ax,ak12,ak22,apr,dpr    : Extended ;
   abkr,ws,at,ag,s2        : Extended ;
   ag2kr,ak22kr            : Extended ;
   ax2,ag22,asag,q1,
   qk,q2,qa,qb,aqk,qq      : Extended ;
   r,rq,an,oh,ull,
   abc1,abc2,abcs,abcr,
   agkr,tt1,ac,aq,acw,aqw  : Extended ;
   aq0,sg,agw,qr,qe,
   ab22,qz,qu,ac0,bx2      : Extended ;
   beta,betw,betz,rx,af0,
   ap0,oda1,app0,aff0,amu  : Extended ;
   alam,rlam,anr,valueg    : Extended ;
   sf,sp                   : Array [1..n10] of Extended ;

 Procedure ToClcInitMassives ;
 Var
   i,j,k,kk,ii,jj  : Byte ;
 Begin
   tt[1]:=o;
   tt[2]:=t1;
   tt[3]:=t2;
   tt[4]:=t3;
   tt[5]:=t4;
   tt[6]:=t5;
   For j:=1 To n10 Do
     Begin
       r:=j;
       td[j]:=o/r;
     End;
   For i:=1 To n10 Do
     For j:=1 To n10 Do
       Begin
         uu[i][j]:=ol;
         If  i = j
           Then
             uu[i][j]:=o;
       End;
   k:=0;
   While  k < n8  Do
     Begin
       k:=k+2;
       kk:=k+1;
       r:=ww[k];
       For i:=kk To n10 Do
         Begin
           j:=i-k;
           ii:=i-1;
           jj:=j+1;
	   rq:=r+uu[ii][jj];
           r:=rq;
	   uu[i][j]:=rq;
         End;
     End;
   r:=o;
   For i:=1 To n10 Do
     Begin
       For j:=1 To i Do
         uu[i][j]:=r*uu[i][j];
       r:=t1*r;
     End;
   For i:=2 To n10 Do
     Begin
       ii:=i-1;
       For j:=1 To ii Do
         uu[j][i]:=uu[i][j];
     End;
 End;

 Procedure ToPlaceNullo ;
 Var
   i  : Byte ;
 Begin
   For i:=1 To n11 Do
     Begin
       a[i]:=ol;
       b[i]:=ol;
       d[i]:=ol;
       e[i]:=ol;
       u[i]:=ol;
       v[i]:=ol;
       vv[i]:=ol;
       ee[i]:=ol;
       bks[i]:=ol;
       bps[i]:=ol;
       bks2[i]:=ol;
       bps2[i]:=ol;
       f[i]:=ol;
       p[i]:=ol;
     End;
   For i:=1 To n10 Do
     Begin
       acp[i]:=ol;
       aqf[i]:=ol;
       app[i]:=ol;
       aff[i]:=ol;
     End;
 End;

 Procedure abba ( a , b         : TDim11 ;
                  Var c         : TDim11 ;
                  kc , lc , mc  : Byte ) ;
 Var
   i,j,n,kk  : Byte ;
 Begin
   For n:=1 To n11 Do  c[n]:=0.0e0;
   For n:=1 To mc Do
     Begin
       i:=0;
       If  n < kc
         Then
           kk:=n
         Else
           kk:=kc;
       While  i < kk  Do
         Begin
           i:=i+1;
           j:=n-i+1;
           If  j <= lc
             Then
               c[n]:=c[n]+a[i]*b[j];
         End;
     End;
 End;

 { to obtain a e d from a1 a2 a3 }

 Procedure ToGetSimpleElem ( c  : TDim90 ;  a1 , a2 , a3  : Extended ) ;
 Var
   numiter   : Word ;
   current   : Extended ;
   difiter   : Extended ;
   aq,bq,cq  : Extended ;
 Begin
   fm:=c[1];
   cj2:=c[3];
   sig:=c[4];
   fem:=o/fm;
   fa:=-fm/a1;
   ab:=fa;
   an0:=-a1*sqrt(-a1)*fem;
   fe:=-a2*fem;
   re:=-fe*a1*fem;
   p3:=a3*a3;
   fd:=-p3/a2;
   rd:=fd;
   rdz:=fd;
   pa:=p3*fem;
   z2:=cj2*cj2;
   z0:=cj2*sig;
   aq:=2*fm*z0;
   bq:=a1*z2;
   cq:=bq+a2;
   d2:=o-rd;
   ad:=sqrt(abs(d2));
   adz:=-ad;
   dz2:=d2;
   current:=10.0;
   difiter:=10.0; { initial }
   numiter:=0;
   While ( ( difiter > 1.0e-19 ) AND ( numiter < 9999 ) )  Do
     Begin
       numiter:=numiter+1;
       pe:=cj2/(ab*re);
       p2:=pe*pe;
       ps:=pe*sig;
       p1:=w*p2*(w-re);
       p5:=p2*re;
       p4:=p5*p5;
       d2:=o-rd;
       ad:=sqrt(abs(d2));
       rr:=o+p1*d2+p4*d2*d2;
       rc:=o-w*ps*ad-p5*d2;
       rr:=rc/rr;
       rf:=(o+p1+p4)*rr;
       rt:=o+(rf-rr)*rd;
       qdz:=aq*rd/(cq+aq*adz-bq*(d2+dz2));
       adz:=-ad+qdz;
       dz2:=Sqr(adz);
       rd:=fd*rt/rf;
       ab:=fa*(o-p5*rd*rr);
       re:=fe/(ab*rt);
       difiter:=Abs(current-ad);
       current:=ad;
     End;
   e2:=o-re;
   ae:=sqrt(abs(e2));
   az:=-a1*ab*ae*fem;
   pe:=cj2/(ab*re); { epsilon }
   p2:=pe*pe; { epsilon**2 }
   d2:=o-rd;
   ad:=sqrt(abs(d2));
   adz:=-ad+qdz;
   x1:=ab*(o-ae);
   x2:=ab*(o+ae);
 End;

 Procedure ToGetSomeParameter ( a1 , a2 , a3  : Extended ) ;
 Begin
   { for ksi }
   al1:=-ab+fa;
   apr:=al1;
   pq22:=z2*(a2+a3*a3)/(x1*x2*a1);
   akr:=Sqrt(x2*x2-2*apr*x2+pq22);
   bkr:=Sqrt(x1*x1-2*apr*x1+pq22);
   ag2:=sqrt(-a1*akr*bkr);
   r1:=akr-bkr;
   ax:=r1/(akr+bkr);
   ak22:=(Sqr(x2-x1)-r1*r1)/(4.0e0*akr*bkr);
   ak22kr:=-ak22/(1-ak22);
   ag2kr:=ag2*Sqrt(1-ak22);
   { for eta }
   apr:=-fa*sig*cj2-t1*(adz+ad)*z2;
   dpr:=a2/a1+z2*(1-d2-ad*adz-dz2)-2*fa*sig*cj2*(adz+ad);
   akr:=Sqrt(dpr+2*apr*ad-z2*d2);
   bkr:=Sqrt(dpr+2*apr*adz-z2*dz2);
   r1:=akr-bkr;
   ka2:=(z2*Sqr(ad-adz)+r1*r1)/(4.0e0*akr*bkr);
   r2:=o+ka2;
   ak12:=ka2/r2;
   abkr:=o/(akr+bkr);
   ag1:=sqrt(-a1*akr*bkr*r2);
   ws:=-(akr*adz-bkr*ad)*abkr;
   at:=-r1*abkr;
   ag:=(akr*adz+bkr*ad)*abkr;
 End;

 Procedure EilConst ( Var  c  : TDim90 ;
                      a1 , a2 , a3   : Extended ;
                      Var  edl , edg , edh    : Extended ) ;
 Var
   i,j,ii,ij,jj,l,k,i1,i2,i3,i4  : Byte ;
 Begin
   ToClcInitMassives;
   ToGetSimpleElem(c,a1,a2,a3); { to obtain a e d from a1 a2 a3 }
   ToGetSomeParameter(a1,a2,a3); { ax,as,ag,at and other }
   s2:=ws*ws;
   ax2:=ax*ax;
   r1:=o;
   axx[1]:=o;
   For i:=2 To 6 Do
     Begin
       r1:=ax2*r1;
       axx[i]:=r1;
     End;
   ag22:=ag*ag;
   asag:=w*ws*ag;
   ToPlaceNullo;
   d[1]:=o;
   d[2]:=-w*at;
   d[3]:=at*at;
   a[1]:=o;
   a[2]:=d[2];
   b[1]:=o-ag22;
   b[2]:=d[2]+asag;
   b[3]:=d[3]-s2;
   v[1]:=ag22;
   v[2]:=-asag;
   v[3]:=s2;
   vv[1]:=+ag;
   vv[2]:=-ws;
   r1:=o;
   e[1]:=o;
   ee[1]:=o;
   For i:=2 To n6 Do
     Begin
       r1:=at*r1;
       ee[i]:=r1;
       e[i]:=i*r1;
     End;
   q1:=o/(o-ak22);
   qk:=sqrt(q1);
   q2:=-ak22*q1;
   i:=0;
   rf:=o;
   rp:=o;
   qa:=ol;
   qb:=ol;
   j:=1;
   While  j <= n11  Do
     Begin
       i:=i+1;
       f[j]:=tt[i]*rf;
       p[j]:=tt[i]*rp;
       rf:=ak12*rf;
       rp:=q2*rp;
       qa:=qa+tt[i]*f[j];
       qb:=qb+tt[i]*p[j];
       j:=j+2;
     End;
   aqk:=qa;
   qa:=o/qa;
   qq:=qk*qa*ag1/ag2;
   an:=qq*qb;
   oh:=an-o;
   For i:=1 To n5 Do
     Begin
       ii:=2*i;
       rp:=ol;
       rf:=ol;
       j:=ii;
       While  j <= n10  Do
         Begin
           ij:=j+1;
           rp:=rp+uu[ii][j]*p[ij];
           rf:=rf+uu[ii][j]*f[ij];
           j:=j+2;
         End;
       akp[i]:=+td[ii]*qq*rp;
       akf[i]:=-td[ii]*qa*rf;
     End;

   For j:=m To n11 Do
     a[j]:=d[1]*f[j]+d[2]*f[j-1]+d[3]*f[j-2];
   For ii:=m To n11 Do
     Begin
       i:=n11-ii+m;
       l:=i-m+1;
       ull:=a[i]/b[m];
       u[l]:=ull;
       k:=i;
       For jj:=1 To m Do
         Begin
           j:=m-jj+1;
           a[k]:=a[k]-b[j]*ull;
           k:=k-1;
         End;
     End;

   qq:=a3/ag1;
   aq0:=ol;
   i:=0;
   j:=1;
   While  j <= n9  Do
     Begin
       i:=i+1;
       aq0:=aq0+tt[i]*u[j];
       j:=j+2;
     End;
   aq0:=qq*aq0;
   For i:=1 To n8 Do
     Begin
       rr:=ol;
       j:=i;
       While  j <= n8  Do
         Begin
           ij:=j+1;
           rr:=rr+uu[i][j]*u[ij];
           j:=j+2;
         End;
       aqf[i]:=td[i]*qq*rr;
     End;

   abc1:=sqrt(b[1]-b[2]+b[3]);
   abc2:=sqrt(b[1]+b[2]+b[3]);
   abcs:=abc1+abc2;
   abcr:=abc1-abc2;
   agkr:=4.0e0/(abcs*abcs-4.0e0*b[3]);
   sg:=sqrt(agkr);
   tt1:=t1;
   If  a3 < 0.0e0  Then  tt1:=-t1;
   ac:=tt1*sg*abcs;
   aq:=tt1*sg*abcr;
   acw:=tt1*abcs;
   aqw:=tt1*abcr;
   agw:=o/sg;

   q1:=o-ae*ax;
   qr:=o/q1;
   qe:=-(ax-ae)*qr;

   For i:=1 To n11 Do
     Begin
       g1[i]:=ol;
       g2[i]:=ol;
     End;
   g1[1]:=qr;
   g1[2]:=ax*qr;
   r1:=o;
   For i:=1 To n6 Do
     Begin
       g2[i]:=r1;
       r1:=qe*r1;
     End;

   abba(g1,g2,bks,n2,n6,n7);
   abba(bks,bks,bks2,n7,n7,n8);

   ab22:=o/(ab*ab);
   q2:=-z2*ab22;
   qz:=o;
   qq:=-a3*z2*ab22*qk/ag2;
   For i:=1 To n11 Do
     Begin
       bks8[i]:=bks2[i];
       bks4[i]:=bks2[i];
     End;
   k:=2;
   While  k < n10  Do
     Begin
       k:=k+2;
       qz:=qz*q2;
       abba(bks2,bks8,bks6,n8,n11,n11);
       For i:=1 To n11 Do
         Begin
           bks4[i]:=bks4[i]+qz*bks6[i];
           bks8[i]:=bks6[i];
         End;
     End;

   For i:=1 To n11 Do
     Begin
       qu:=bks4[i];
       u[i]:=qq*qu;
     End;

   abba(u,p,g,n11,n11,n11);

   ac0:=ol;
   i:=0;
   j:=1;
   While  j <= n11  Do
     Begin
       i:=i+1;
       ac0:=ac0+tt[i]*g[j];
       j:=j+2;
     End;

   For i:=1 To n10 Do
     Begin
       rr:=ol;
       j:=i;
       While  j <= n10  Do
         Begin
           ij:=j+1;
           rr:=rr+uu[i][j]*g[ij];
           j:=j+2;
         End;
       acp[i]:=td[i]*rr;
     End;

   bps[1]:=2.0e0*al1/ab;
   pq22:=pq22*ab22;
   For i:=1 To n11 Do
     bps[i]:=bps[i]-pq22*bks[i];

   abba(bps,bps,bps2,n7,n7,n8);

   For i:=1 To n11 Do
     bps4[i]:=t2*bps2[i];

   abba(bks,bps,g3,n7,n7,n11);

   abba(bps,bps2,bps3,n7,n8,n9);
   abba(bks,bps3,g4,n7,n9,n11);

   For i:=1 To n11 Do
     bps4[i]:=bps4[i]+t3*g4[i];

   ii:=4;
   k:=6;
   While  k < n10  Do
     Begin
       k:=k+2;
       ii:=ii+1;
       abba(g3,g4,g5,n11,n11,n11);
       For i:=1 To n11 Do
         Begin
           g4[i]:=g5[i];
           bps4[i]:=bps4[i]+tt[ii]*g5[i];
         End;
     End;

   bps4[1]:=-t1*pq22+bps4[1];
   bx2:=sqrt(o-ax2);
   beta:=ax/(o+bx2);
   betw:=o-beta*beta;
   betz:=az*betw;
   rx:=-a1*fem*ab*bx2*qr;
   qq:=z2*an0/ag1;
   abba(g2,bps4,h,n6,n11,n11);
   abba(v,e,g,n3,n6,n8);
   abba(g,f,hh,n8,n11,n11);

   For i:=1 To n11 Do
     Begin
       hh[i]:=qq*hh[i];
       h[i]:=rx*h[i];
     End;

   i:=0;
   j:=1;
   af0:=ol;
   ap0:=ol;
   While  j <= n11  Do
     Begin
       i:=i+1;
       ap0:=ap0+tt[i]* h[j];
       af0:=af0+tt[i]*hh[j];
       j:=j+2;
     End;

  For i:=1 To n10 Do
     Begin
       rp:=ol;
       rf:=ol;
       j:=i;
       While  j <= n10  Do
         Begin
           ij:=j+1;
           rp:=rp+uu[i][j]* h[ij];
           rf:=rf+uu[i][j]*hh[ij];
           j:=j+2;
         End;
       app[i]:=td[i]*rp;
       aff[i]:=td[i]*rf;
     End;

   i:=0;
   j:=2;
   While  j <= n8  Do
     Begin
       i:=i+1;
       aqf[j]:=aqf[j]+aq0*akf[i];
       acp[j]:=acp[j]+aq0*akp[i];
       aff[j]:=aff[j]+af0*akf[i];
       app[j]:=app[j]+af0*akp[i];
       j:=j+2;
     End;

   For i:=1 To n11 Do
     Begin
       g4[i]:=bps[i];
       bps4[i]:=t1*bps[i];
     End;

   ii:=2;
   k:=2;
   While  k < n10  Do
     Begin
       k:=k+2;
       ii:=ii+1;
       abba(g3,g4,g5,n11,n11,n11);
       For i:=1 To n11 Do
         Begin
           g4[i]:=g5[i];
           bps4[i]:=bps4[i]+tt[ii]*g5[i];
         End;
     End;

   abba(g2,bps4,h,n6,n11,n11);
   abba(vv,ee,g,n2,n6,n8);
   abba(g,f,hh,n8,n11,n11);

   oda1:=o/sqrt(-a1);
   rx:=oda1*sqrt(o-ax2)*qr;
   qq:=o/ag1;
   For i:=1 To n11 Do
     Begin
       hh[i]:=qq*hh[i];
       h[i]:=rx*h[i];
     End;

   i:=0;
   j:=1;
   app0:=oda1;
   aff0:=ol;
   While  j <= n11  Do
     Begin
       i:=i+1;
       aff0:=aff0+tt[i]*hh[j];
       app0:=app0+tt[i]*h[j];
       j:=j+2;
     End;

   amu:=ac0+an*aq0;
   alam:=-ap0-an*af0;

   rlam:=o/(o-alam);
   anr:=an0*rlam;

   edh:=a3;
   valueg:=(a1/an0)*af0+(-a2/ag1)*aqk-aq0*a3-w*fm*z0*aff0;
   edg:=valueg;
   edl:=(a1/anr)-oh*valueg-amu*a3+w*fm*app0-w*fm*z0*an*aff0;

   c[5]:=a1;
   c[6]:=a2;
   c[7]:=a3;
   c[8]:=ab;
   c[9]:=ae;
   c[10]:=ws;
   c[11]:=ac;
   c[12]:=ax;
   c[13]:=ag;
   c[14]:=at;
   c[15]:=aq;
   c[16]:=ag1;
   c[17]:=ag2;
   c[18]:=ak12;
   c[19]:=ak22;
   c[20]:=az;
   c[21]:=an;
   c[22]:=amu;
   c[23]:=alam;
   c[24]:=anr;
   c[25]:=anr*oh;
   c[26]:=anr*amu;
   c[27]:=an0;
   c[28]:=oh;
   c[29]:=aq0;
   c[30]:=af0;
   c[31]:=ac0;
   c[32]:=ap0;
   c[33]:=rlam;
   c[34]:=beta;
   c[35]:=agw;
   c[36]:=acw;
   c[37]:=aqw;
   c[38]:=betw;
   c[39]:=betz;
   c[40]:=ag2kr;

   For i:=1 To 5 Do
     Begin
       i1:=40+i;
       i2:=45+i;
       c[i1]:=akf[i];
       c[i2]:=akp[i];
     End;
   For i:=1 To 10 Do
     Begin
       i1:=50+i;
       i2:=60+i;
       i3:=70+i;
       i4:=80+i;
       c[i1]:=aqf[i];
       c[i2]:=acp[i];
       c[i3]:=aff[i];
       c[i4]:=app[i];
     End;
 End;

 Procedure FromCartToEiler ( xx , vv     : TVect3 ; { UnConTyp }
                             Var  ceil   : TDim90 ;
                             Var  ul , ug , uh  : Extended ) ;
 Var
   i,ii  : Byte ;
   x1,x2,x3,v1,
   v2,v3,zx,r2,u2,temp     : Extended ;
   r1,f2,bs,bt,z4,
   fi,vt,vs,a1,a2,a3       : Extended ;
   ab,ae,ws,ax,ag,at       : Extended ;
   edl,edg,edh             : Extended ;
 Begin
   z2:=Sqr(ceil[3]);
   z0:=ceil[3]*ceil[4];
   x1:=xx[1];
   x2:=xx[2];
   x3:=xx[3]-z0;
   v1:=vv[1];
   v2:=vv[2];
   v3:=vv[3];
   zx:=x3*x3;
   r2:=x1*x1+x2*x2+zx;
   u2:=v1*v1+v2*v2+v3*v3;
   r1:=x1*v1+x2*v2+x3*v3;
   temp:=r2-z2;
   f2:=0.5*(temp+sqrt(temp*temp+4*z2*zx));
   bs:=sqrt(f2);
   bt:=x3/bs;
   z4:=z2*bt*bt;
   fi:=2*ceil[1]/(f2+z4);
   vt:=bs*v3-bt*r1;
   vs:=bs*r1+z2*bt*v3;
   a1:=u2-fi*(bs-z0*bt);
   a3:=x1*v2-v1*x2;
   a2:=r1*r1-r2*u2+z2*v3*v3-fi*(bs*z4+z0*bt*f2);
   ceil[5]:=a1;
   ceil[6]:=a2;
   ceil[7]:=a3;
   EilConst(ceil,a1,a2,a3,edl,edg,edh);
   ab:=ceil[8];
   ae:=ceil[9];
   ws:=ceil[10];
   ax:=ceil[12];
   ag:=ceil[13];
   at:=ceil[14];
   ce:=(1.0-bs/ab)/ae;
   se:=sqrt(Abs(o-ce*ce));
   If  vs < 0.0  Then  se:=-se;
   ea:=DATan2(se,ce);
   cpp:=(ce-ax)/(1.00-ax*ce);
   spp:=sqrt(o-cpp*cpp);
   If  vs < 0.0  Then  spp:=-spp;
   ep:=DATan2(spp,cpp);
   cff:=(bt-ag)/(bt*at-ws);
   sff:=sqrt(Abs(o-cff*cff));
   If  vt < 0.0  Then  sff:=-sff;
   ef:=DATan2(sff,cff);
   pc:=o;
   fc:=o;
   ps:=ol;
   fs:=ol;
   For i:=1 To n10 Do
     Begin
       uc:=pc*cpp-ps*spp;
       vc:=fc*cff-fs*sff;
       us:=ps*cpp+pc*spp;
       vs:=fs*cff+fc*sff;
       sf[i]:=vs;
       sp[i]:=us;
       pc:=uc;
       ps:=us;
       fc:=vc;
       fs:=vs;
     End;
   rf:=ol;
   rp:=ol;
   ru:=ol;
   For i:=1 To n5 Do
     Begin
       ii:=2*i;
       rf:=rf+ceil[40+i]*sf[ii]+ceil[45+i]*sp[ii];
     End;
   For i:=1 To n10 Do
     Begin
       ru:=ru+ceil[50+i]*sf[i]+ceil[60+i]*sp[i];
       rp:=rp+ceil[70+i]*sf[i]+ceil[80+i]*sp[i];
     End;
   ul:=(ea-ceil[20]*se-ceil[23]*ep+rp)*ceil[33];
   pudl:=ep-ul;
   ug:=ef-ep-ceil[28]*pudl-rf;
   r4:=ceil[11]*cff-ceil[15];
   r5:=o/sqrt(r4*r4+sff*sff);
   cw:=r4*r5;
   sw:=sff*r5;
   uw:=DATan2(sw,cw);
   bw:=DATan2(x2,x1);
   uh:=bw-uw-ceil[22]*pudl-ru;
 End;

 Procedure orbxv ( c    : TDim90 ;
                   ul , ug , uh  : Extended ;
                   Var  xx , vv  : TVect3 ) ; { UnConTyp type }
 Var
   i,j,ii  : Byte ;
   e,p,f,bs,bt,rt,
   su,cu,ru,vt,vs,vw,re,
   ri,rx,r1,r2,r3,q1,q2,q3  : Extended ;
 Begin
   rx:=Sqrt(o-Sqr(c[12])); // sqrt(1-ax*ax)
   z2:=Sqr(c[3]);          // c^2
   z0:=c[3]*c[4];          // c*sigma
   e:=KeplerEquation(c[9],ul); // UnForKep M=E-e*sin(E) by Newton
   p:=e; // angle psi
   f:=p+ug; // angle phi~
   se:=Sin(e); // sin(E)
   ce:=Cos(e); // cos(E)
   sp[1]:=se;
   sf[1]:=Sin(f);
   For i:=2 To 10 Do
     Begin
       sp[i]:=ol;
       sf[i]:=ol;
     End;
   pudl:=ol;
   j:=0;
   r:=o;
   While  ( ( j < 15 ) AND ( r > 2.0e-18 ) )  Do
     Begin
       j:=j+1;
       rf:=ol;
       rp:=ol;
       For i:=1 To 5 Do
         Begin
           ii:=2*i;
           rf:=rf+c[40+i]*sf[ii]+c[45+i]*sp[ii];
         End;
       For i:=1 To 10 Do
         rp:=rp+c[70+i]*sf[i]+c[80+i]*sp[i];
       ea:=ul+c[20]*se+c[23]*pudl-rp; // angle E
       se:=Sin(ea);                   // sin(E)
       ce:=Cos(ea);                   // cos(E)
       re:=o/(o-c[12]*ce); // c[12] parametr ax
       spp:=rx*re*se;
       cpp:=(ce-c[12])*re;
       p:=ea+ArcTan((spp*ce-cpp*se)/(cpp*ce+spp*se)); // angle psi
       pudl:=p-ul;                                    // psi-l
       f:=p+ug+c[28]*pudl+rf;                         // phi~
       sff:=Sin(f);
       cff:=Cos(f);
       pc:=o;
       fc:=o;
       ps:=ol;
       fs:=ol;
       For i:=1 To 10 Do
         Begin
           uc:=pc*cpp-ps*spp;
           vc:=fc*cff-fs*sff;
           us:=ps*cpp+pc*spp;
           vs:=fs*cff+fc*sff;
           sf[i]:=vs;
           sp[i]:=us;
           pc:=uc;
           ps:=us;
           fc:=vc;
           fs:=vs;
         End;
       r:=Abs(ea-e);
       e:=ea;
     End;
   bs:=c[8]*(o-c[9]*ce);
   rt:=o/(o-c[14]*cff);
   bt:=(-c[10]*cff+c[13])*rt;
   r1:=bs*bs+z2;
   r2:=o-bt*bt;
   r3:=Sqrt(r1*r2);
   r4:=c[11]*cff-c[15];
   r5:=o/Sqrt(r4*r4+sff*sff);
   ru:=uh+c[22]*pudl;
   For i:=1 To 10 Do
     ru:=ru+c[50+i]*sf[i]+c[60+i]*sp[i];
   cw:=r4*r5;
   sw:=sff*r5;
   su:=Sin(ru);
   cu:=Cos(ru);
   xx[1]:=r3*(cw*cu-sw*su); { position x }
   xx[2]:=r3*(sw*cu+cw*su); { position y }
   xx[3]:=z0+bs*bt;         { position z }
   ri:=o/(bs*bs+z2*bt*bt);
   r1:=o/r1;
   r2:=o/r2;
   q1:=Sqrt(o-c[19]*spp*spp);
   q2:=Sqr(rx/(o+c[12]*cpp));
   q3:=c[8]*c[9]*c[17];
   vs:=q3*ri*q2*spp*q1;
   q1:=Sqrt(o-c[18]*cff*cff);
   q2:=(c[10]-c[13]*c[14])*c[16];
   vt:=q2*ri*rt*rt*sff*q1;
   vw:=c[7]*r1*r2;
   r4:=bs*vs*r1-bt*vt*r2;
   vv[1]:=xx[1]*r4-xx[2]*vw; { velosity x }
   vv[2]:=xx[2]*r4+xx[1]*vw; { velosity y }
   vv[3]:=bs*vt+vs*bt;     { velosity z }
 End;

 Procedure FromElemToC ( an0 , ae , Incl     : Extended ;
                         Var   ceil          : TDim90 ;
                         Var   a1 , a2 , a3  : Extended ) ;
 Var
   iter   : Byte ;
   ai,ci  : Extended ;
 Begin
   fm:=ceil[1];
   rz:=ceil[2];
   cj2:=ceil[3];
   sig:=ceil[4];
   z2:=Sqr(cj2);
   z0:=cj2*sig;
   aq:=2*fm*z0;
   a1:=-Exp(2.0/3.0*Ln(fm*an0));
   ai:=(Pi/180)*Incl;
   ws:=Sin(ai);
   s2:=Sqr(ws);
   ci:=Cos(ai);
   fa:=-fm/a1;
   ab:=fa;
   e2:=Sqr(ae);
   re:=1-e2;
   pe:=cj2/(ab*re);
   p2:=Sqr(pe);
   ad:=ws-pe*sig*(1-s2)*(1-pe*sig*ws-p2*(3-4*s2+e2));
   d2:=Sqr(ad);
   qdz:=0;
   adz:=-ad+qdz;
   dz2:=Sqr(adz);
   For iter:=1 To 7 Do
     Begin
       rr:=(1-2*pe*sig*ad-p2*d2*re);
       rr:=rr/(1+2*p2*d2*(1+e2)+Sqr(p2*d2*re));
       ab:=fa*(1-p2*re*(1-d2)*rr);
       pe:=cj2/(ab*re);
       p2:=Sqr(pe);
       rq:=2*p2*(1+e2)+Sqr(p2*re);
       a2:=-fm*ab*re*(1+rq*rr*(1-d2));
       p3:=+fm*ab*re*(1-d2)*(1+rq)*rr;
       qdz:=aq*(1-d2);
       qdz:=qdz/((a1*z2+a2)+aq*adz-a1*z2*(d2+dz2));
       adz:=-ad+qdz;
       dz2:=Sqr(adz);
       apr:=-fa*z0-0.5*(ad+adz)*z2;
       dpr:=a2/a1+z2*(1-d2-ad*adz-dz2)-2*fa*z0*(ad+adz);
       akr:=Sqrt(dpr+2*apr*ad-z2*d2);
       bkr:=Sqrt(dpr+2*apr*adz-z2*dz2);
       ad:=ws+(akr/(akr+bkr))*qdz;
       d2:=Sqr(ad);
     End;
   a3:=Sqrt(p3);
   If  ci < 0.0  Then  a3:=-a3;
 End;

 End.
