unit UnForSop ; { for global variable SatReflCoef SatEmpCoef }
interface
var
  satvalkr  : Extended ; { k_r surface reflection property satellite }
  satvalar  : Extended ; { A_midel midel area in m^2 satellite }
  satvalmr  : Extended ; { m mass in kg satellite }
  satarama  : extended ; { k_r*(A_midel/mass m^2/kg }
  satempac  : Extended ; { empiric acceleration rev./day^2 }
function ToGetReflValue ( kr , ar , mr  : Extended ) : Extended ;
function ToGetSataramas ( kr , ar , mr  : Extended ) : Extended ;
function ToGetReflValus ( cr  : Extended ) : Extended ;
function ToGetEmpaValue : extended ;
implementation
function ToGetReflValue ( kr , ar , mr  : Extended ) : Extended ;
begin
  if  mr < 2.0
    then { too small or nullo mass value }
      ToGetReflValue:=0.0
    else                                  { as acceleration }
      ToGetReflValue:=4.5606e-9*kr*ar/mr; { in km/s^2 }
end;
{ k_r - surface reflection coefficient
  A_midel - midel area of the surface m^2
  m_satellite - mass of the satellite kg } 
function ToGetSataramas ( kr , ar , mr  : Extended ) : Extended ;
begin
  satvalkr:=kr; { k_r - surface reflection coefficient }
  satvalar:=ar; { A_midel - midel area of the surface m^2 }
  satvalmr:=mr; { m_satellite - mass of the satellite  kg } 
  if  mr < 2.0
    then { too small or nullo mass value }
      ToGetSataramas:=0.0
    else                                  { as acceleration }
      ToGetSataramas:=kr*ar/mr; { in m^2/kg }
end;
{ value cr may be in the string with elements
  and  kr*ar/mr = 10^3*cr  in this case kr = 1.5 }
function ToGetReflValus ( cr  : Extended ) : Extended ;
begin
  ToGetReflValus:=4.5606e-6*cr;
end;
{ empiric acceleration value
  c_t in revolution per day in square }
function ToGetEmpaValue : extended ;
begin
  ToGetEmpaValue:=0.0; { initial nullo }
end;
end.
