unit UnFotrua ; { to change from true equatorial system }
interface       { to terrestrial system with true sidereal time }
uses
  UnConTyp ; { constants types TMatr33 for example }
{ to change from terrestrial to the true equator system }
Procedure ToObtainTruEquT ( tc  : Extended ; { in second from start }
                            var  term  : TMatr33 ;   { terra to true }
                            var  trum  : TMatr33 ) ; { true to terra }
implementation
uses
  UnForTyp , { for the global DatTime DatPole records }
  UnGetERP , { for the procedure ToObtainERParm }
  UnRotatM , { for the procedure ToClcTimeValue }
  UnForFun , { for matrix operations }
  UnForSit ; { for the function ToGetGrASTime }
{ to change from terrestrial to the true equator system }
Procedure ToObtainTruEquT ( tc  : Extended ; { in second from start }
                            var  term  : TMatr33 ;   { terra to true }
                            var  trum  : TMatr33 ) ; { true to terra }
Var
  td  : Extended ; { current data in julian day with the part }
  ut  : extended ; { moment UT1 with DUT in mjd }
  ts  : extended ; { greenwich true sidereal time for this UT1 }
  xp  : extended ; { current x_pole position in radian }
  yp  : extended ; { current y_pole position in radian }
  xm  : tmatr33 ;  { matrix rotation R_2(x_p) }
  ym  : tmatr33 ;  { matrix rotation R_1(y_p) }
  rs  : tmatr33 ;  { matrix rotation R_3(-Sg) }
  zm  : tmatr33 ;  { matrix R_1(y_p)*R_2(x_p) }
Begin
  td:=IntTime.begday+tc/86400.0; { current time in julian day }
  ToObtainERParm(td,DatPole); { UnGetERP , DatPole in UnForTyp }
  ToClcTimeValue(td);   { result to DatTime , DatPole external UnRotatM }
  { now we have
    DatPole.utc , julian day
    DatTime.ut1 , DatTime.tt , DatTime.teph
    DatPole.dut , DatPole.xpo , DatPole.ypo }
  ut:=DatTime.ut1-DifEpoch;  { UT1 in mjd const UnConTyp }
  ts:=ToGetGrASTime(ut,0.0); { UnForSit true sidereal time in radian }
  xp:=SecRad*DatPole.xpo; { UnConTyp UnForTyp to radian x_pole }
  yp:=SecRad*DatPole.ypo; { UnConTyp UnForTyp to radian y_pole }
  ForRotMatr(2,xp,xm);  { R_2(x_p) UnForFun }
  ForRotMatr(1,yp,ym);  { R_1(y_p) UnForFun }
  ForRotMatr(3,-ts,rs); { R_3(-Sg) UnForFun }
  ToMultMatr(ym,xm,zm); { R_1(y_p)*R_2(x_p) UnForFun }
  ToMultMatr(rs,zm,term); { matrix R_3(-Sg)*R_1(y_p)*R_2(x_p) }
  TranspMatr(term,trum);  { from true equator to terra system }
end;
end.
