
 { one class with some routines for Eiler elements }

 unit UnitCeil ;

 interface

 uses
   UnConTyp ; // type TDim11 array[1..11] of extended

 type

   TCeil = class
                                         { variables }
     ol,o,w          : Extended ; { simple 0.0 1.0 2.0 }
     t1,t2,t3,t4,t5  : Extended ; { simple value }

     m,n2,n3,n4      : Byte ;     { m=3 simple value 2 3 4 }
     n5,n6,n7,n8     : Byte ;     { 5 6 7 8 simple integer }
     n9,n10,n11      : Byte ;     { 9 10 11 simple integer }

     ww  : array [1..8] of Byte ;
     uu  : array [1..10,1..10] of Extended ;
     tt  : array [1..6] of Extended ;
     td  : array [1..10] of Extended ;

   private

     a,b,d,f,e,g,h,hh        : TDim11 ; // type UnConTyp
     g1,g2,g3,g4,g5          : TDim11 ; // type UnConTyp
     vv,ee,bks,bps,u,p,v     : TDim11 ; // type UnConTyp
     bks2,bks4,bks6          : TDim11 ; // type UnConTyp
     bks8,bps2,bps3,bps4     : TDim11 ; // type UnConTyp

     axx                     : array [1..6] of Extended ;
     aqf,acp,aff,app         : array[1..10] of Extended ;
     akp,akf                 : array [1..5] of Extended ;

     se,ce,ea,cpp,spp,ep,
     sff,cff,ef,pc,fc,ps,fs  : Extended ;
     uc,vc,us,vs,rf,rp,ru    : Extended ;
     pudl,r4,r5,sw,cw,uw,bw  : Extended ;

     ka2,fem,fa,
     fe,re,p3,fd,
     rd,rdz,pa,z2,z0         : Extended ;
     p2,p1,p4,p5,d2,
     rr,rc,rt,dz2,qdz        : Extended ;
     e2,x1,x2,al1,pq22       : Extended ;
     akr,bkr,ag1,ag2,r1,r2   : Extended ;
     ax,ak12,ak22,apr,dpr    : Extended ;
     abkr,s2,
     ag2kr,ak22kr,delt2      : Extended ;
     ax2,ag22,asag,q1,
     qk,q2,qa,qb,aqk,qq      : Extended ;
     r,rq,an,oh,ull,
     abc1,abc2,abcs,abcr,
     agkr,tt1,aq,acw,aqw     : Extended ;
     aq0,sg,agw,qr,qe,
     ab22,qz,qu,ac0,bx2      : Extended ;
     rx,af0,ap0,amu          : Extended ;
     alam,rlam,anr           : Extended ;

     sf,sp                   : array [1..10] of Extended ;

     procedure ToPlaceNullo ;      // initial nullo values

     procedure abba ( a , b         : TDim11 ; // type UnConTyp
                      var c         : TDim11 ; // type UnConTyp
                      kc , lc , mc  : Byte ) ; // simple integer

     procedure ElemFromAlpha ;

     procedure AlphaFromElem ;

     procedure ToGetSomeParm ;

     procedure ToPlaceValue ;

     { d\tau=(1/\bar\sigma_2)
              *\int(d\psi)/\sqrt(1-(\bar k_2^2)\cos^2\psi)
       d\tau=(1/\sigma_1)*\int(d\phi)/\sqrt(1-k_1^2)\cos^2\phi) }

     procedure FullElliptic ;  // value  \nu

     procedure ForCoefPhiPsi ; // values \kappa to link \phi \psi

     { w=+\alpha_3*\int(d\tau)/(1-\eta^2)
         -\alpha_3*c^2*\int(d\tau)/(\xi^2+c^2) }

     procedure ForCoefAlbega ; // values \alpha \beta \bar\gamma

     procedure ToDividePolin ; // polinoms a[..]/b[..] for d\tau/(1-\eta^2)

     procedure WPhiPeriodic ;  // periodic terms with angle phi for w

     procedure WPsiSecular ;   // for coefficient \alpha'_0

     procedure WPsiPeriodic ;  // for coefficients \alpha_i^p

    { to integrate expression
         dt = \xi^2 d\tau + c^2 * \eta^2 d\tau }

     procedure TimeSecular ;   // \int \xi^2 d\tau + c^2 * \eta^2 d\tau

     procedure TimePeriodic ;  // \int \xi^2 d\tau + c^2 * \eta^2 d\tau

     procedure AllParameter ;  // all parameter to array c of TEilParm

     procedure ToGetAllParm ;  // to calculate all parameter

   public

     c              : TEilParm ; // UnConTyp
                                 // geocentric gravitational constatnt f*M
     fm,rz,cj2,sig  : Extended ; // equatorial radius r_0 parameter c \sigma

     a1,a2,a3,incl  : Extended ;
     ab,ae,asu,ac   : Extended ;
     an0,az,at,ag   : Extended ;
     ad,adz,epscj2  : Extended ;

     procedure ToClcInitValues ; // type UnConTyp

     procedure EilConstFromAlpha ; // values array c of TEilParm UnConTyp

     procedure EilConstFromElems ; // values array c of TEilParm UnConTyp

     procedure FromCarToEil ( xx , vv  : TVect3 ;     // km km/s
                              Var  el  : TEilPang ) ; // type UnConTyp

     { input record el
       el.pelm array[1,..90] parameters
       el.angl el.angg el.angh three angles l g h in degree }

     procedure FromEilToCar ( el  : TEilPang ;           // UnConTyp
                              var  xx , vv  : TVect3 ) ; // km km/s

     { input
       anob  n mean motion in revolution/day
       aecc  e eccentricity
       ainc  i angle of inclination in degree }

     procedure FromElemToCeil ( anob , aecc , ainc  : Extended ) ;

           end; // class TCeil

 var
   ceiler  : TCeil ;

 implementation

 uses
   UnTypVar , // global variable signuc signum cosinus of inclination
   UnHarMod , // global array GemParmValue with constants
   UnForFun , // function DATan2 for example
   UnForKep ; // function KeplerEquation by Newton method

 { to calculate initial values for real and integer constants }

 procedure TCeil.ToClcInitValues ; // UnConTyp
 var
   i,j,k,ii,jj,kk  : Byte ;
 begin

   c[1]:=GemParmValue[1]; // fM
   c[2]:=GemParmValue[2]; // r_0
   c[3]:=GemParmValue[3]; // c
   c[4]:=GemParmValue[4]; // \sigma

   fm:=c[1];       // geocentric constant f*M  km^3/s^2
   rz:=c[2];       // equatorial radius r_0 km
   cj2:=c[3];      // parameter c approximately 210 km
   sig:=c[4];      // parameter \sigma approximately 1/30

   ol := 0.0e0 ;
   o  := 1.0e0 ;
   w  := 2.0e0 ;

   t1 := 0.50e0 ;
   t2 := 0.375e0 ;
   t3 := 0.3125e0 ;
   t4 := 0.2734375e0 ;
   t5 := 2.46093750e-1 ;

   m  := 3 ;

   n11:= 11 ;
   n2 := 2 ;
   n3 := 3 ;
   n4 := 4 ;
   n10:= n11-1 ;
   n5 := n10 div 2 ;
   n9 := n11-2 ;
   n8 := n11-3 ;
   n7 := n11-4 ;
   n6 := n11-5 ;

   ww[1]:=0;
   ww[2]:=2;
   ww[3]:=0;
   ww[4]:=6;
   ww[5]:=0;
   ww[6]:=20;
   ww[7]:=0;
   ww[8]:=70;

   tt[1]:=o;
   tt[2]:=t1;
   tt[3]:=t2;
   tt[4]:=t3;
   tt[5]:=t4;
   tt[6]:=t5;

   For j:=1 To n10 Do
     Begin
       r:=j;
       td[j]:=o/r;
     End;

   For i:=1 To n10 Do
     For j:=1 To n10 Do
       Begin
         uu[i][j]:=ol;
         If  i = j
           Then
             uu[i][j]:=o;
       End;

   k:=0;
   While  k < n8  Do
     Begin
       k:=k+2;
       kk:=k+1;
       r:=ww[k];
       For i:=kk To n10 Do
         Begin
           j:=i-k;
           ii:=i-1;
           jj:=j+1;
	   rq:=r+uu[ii][jj];
           r:=rq;
	   uu[i][j]:=rq;
         End;
     End;

   r:=o;
   For i:=1 To n10 Do
     Begin
       For j:=1 To i Do
         uu[i][j]:=r*uu[i][j];
       r:=t1*r;
     End;

   For i:=2 To n10 Do
     Begin
       ii:=i-1;
       For j:=1 To ii Do
         uu[j][i]:=uu[i][j];
     End;

 end; // ToClcInitValues

 procedure TCeil.ToPlaceNullo ; // initial nullo values
 var
   i  : Byte ;
 begin

   For i:=1 To n11 Do
     Begin
       a[i]:=ol;
       b[i]:=ol;
       d[i]:=ol;
       e[i]:=ol;
       u[i]:=ol;
       v[i]:=ol;
       vv[i]:=ol;
       ee[i]:=ol;
       bks[i]:=ol;
       bps[i]:=ol;
       bks2[i]:=ol;
       bps2[i]:=ol;
       f[i]:=ol;
       p[i]:=ol;
     End;

   For i:=1 To n10 Do
     Begin
       acp[i]:=ol;
       aqf[i]:=ol;
       app[i]:=ol;
       aff[i]:=ol;
     End;

 end; // ToPlaceNullo

 { to multiple two array
   result to the third array }

 procedure TCeil.abba ( a , b         : TDim11 ;
                        var c         : TDim11 ;
                        kc , lc , mc  : Byte ) ;
 var
   i,j,n,kk  : Byte ;
 begin
   For n:=1 To n11 Do  c[n]:=0.0e0;
   For n:=1 To mc Do
     Begin
       i:=0;
       If  n < kc
         Then
           kk:=n
         Else
           kk:=kc;
       While  i < kk  Do
         Begin
           i:=i+1;
           j:=n-i+1;
           If  j <= lc
             Then
               c[n]:=c[n]+a[i]*b[j];
         End;
     End;
 end; // CEil.abba to multiple polinoms

 { to obtain a e \delta 
   ab a semimajor axis
   ae e eccentricity
   ad \delta parametr
   a1 const 2*\alpha_1
   a2 const -(\alpha_2)^2
   a3 const \alpha_3 with signum
   result to variables
   ab ae ad adz an0 az epscj2 }

 procedure TCeil.ElemFromAlpha ;
 var
   j  : Byte ;
   aq,bq,cq  : Extended ;
 begin             // a1 a2 a3 is known a3 with signum
   fem:=o/fm;      // simple 1/(f*M)
   fa:=-fm/a1;     // -(f*M)/(2*\alpha_1)
   ab:=fa;         // the first value for semimajor axis
   { accurate value for n_0 \sqrt((-2\alpha_1)^3)/(f*M) }
   an0:=-a1*sqrt(-a1)*fem; // accurate value for n_0
   fe:=-a2*fem;    // (\alpha_2)^2/(f*M)
   { 1-e^2 approximately
     (\alpha_2)^2/(f*M*a) = ((\alpha_2)^2)/(f*M))*((-2\alpha_1)/(f*M)) }
   re:=-fe*a1*fem; // the first value for 1-e^2
   p3:=a3*a3;      // (\alpha_3)^2
   if  a3 < 0      // may be a case when
     then  signuc:=-1  // angle of inclination > 90 degree
     else  signuc:=+1; // angle of inclination < 90 degree
   fd:=-p3/a2;     // 1-\delta^2 approximately (\alpha^3)^2/(\alpha^2)^2
   rd:=fd;         // 1-\delta^2 approximately
   rdz:=fd;        // 1-(\delta*)^2 approximately
   pa:=p3*fem;     // \alpha_3/(f*M)
   z2:=cj2*cj2;    // c^2
   z0:=cj2*sig;    // c*\sigma
   aq:=2*fm*z0;    // 2*(f*M)*c*\sigma
   bq:=a1*z2;      // 2\alpha_1*c^2
   cq:=bq+a2;      // 2\alpha_1*c^2-(\alpha_2)^2
   d2:=o-rd;       // approx \delta^2
   ad:=sqrt(abs(d2));  // approx \delta
   adz:=-ad;           // approx \delta*
   dz2:=d2;            // approx (\delta*)^2
   For j:=1 To 7 Do         // some iterations
     Begin                  // small parameter \epsilon^2 near 0.001
       epscj2:=cj2/(ab*re); // \epsilon c/(a*(1-e^2)) approx 1/30
       p2:=epscj2*epscj2;   // \epsilon^2 approx 1/1000
       ps:=epscj2*sig;      // \epsilon*\sigma approx 1/1000
       p1:=w*p2*(w-re);     // 2*\epsilon^2*(1+e^2)
       p5:=p2*re;           // \epsilon^2*(1-e^2)
       p4:=p5*p5;           // (\epsilon^2*(1-e^2))^2
       d2:=o-rd;              // \delta^2
       ad:=sqrt(abs(d2));     // approx \delta
       rr:=o+p1*d2+p4*d2*d2;
       rc:=o-w*ps*ad-p5*d2;
       rr:=rc/rr;
       rf:=(o+p1+p4)*rr;
       rt:=o+(rf-rr)*rd;
       qdz:=aq*rd/(cq+aq*adz-bq*(d2+dz2));
       adz:=-ad+qdz;          // approx delta*
       dz2:=Sqr(adz);
       rd:=fd*rt/rf;
       ab:=fa*(o-p5*rd*rr);   // approx a
       re:=fe/(ab*rt);        // approx 1-e^2
     End;
   e2:=o-re;                  // e^2
   ae:=sqrt(abs(e2));         // e value eccentricity
   az:=-a1*ab*ae*fem;         // e*=-2*\alpha_1*a*e/(f*M)
   epscj2:=cj2/(ab*re);       // epsilon
   p2:=epscj2*epscj2;         // epsilon**2
   d2:=o-rd;
   ad:=sqrt(abs(d2));         // \delta   \eta_2
   adz:=-ad+qdz;              // \delta*  \eta_1
 end;  // TCeil.ElemFromAlpha

 { values
   a e \delta with signum are known
   ab a semimajor axis
   ae e eccentricity
   ad \delta parameter \eta_2
   simple formula to obtain
   2\alpha_1 \alpha_2^2 \alpha_3
   result to variables
   a1 const 2*\alpha_1
   a2 const -(\alpha_2)^2
   a3 const \alpha_3 with signum
   to obtain so adz an0 az epscj2 }

 procedure TCeil.AlphaFromElem ; // by iterations only for \delta*
 var
   j  : Byte ;
   pp,qq,aq,bq,cq  : Extended ;
 begin                  // ab ae ad and signuc is known
   e2:=Sqr(ae);         // e^2
   re:=o-e2;            // 1-e^2
   d2:=Sqr(ad);         // \delta^2
   rd:=o-d2;            // 1-\delta^2
   epscj2:=cj2/(ab*re); // \epsilon c/(a*(1-e^2)) approx 1/30
   p2:=epscj2*epscj2;   // \epsilon^2 approx 1/1000
   ps:=epscj2*sig;      // \epsilon*\sigma approx 1/1000
   p1:=w*p2*(w-re);     // 2*\epsilon^2*(1+e^2)
   p5:=p2*re;           // \epsilon^2*(1-e^2)
   p4:=p5*p5;           // (\epsilon^2*(1-e^2))^2
   rc:=o-w*ps*ad-p5*d2;
   rr:=o+p1*d2+p4*d2*d2;
   qq:=rc/rr;           // value for Q
   pp:=p1+p4;           // 2*\epsilon^2*(1+e^2)+(\epsilon^2*(1-e^2))^2
   { simple formula for constants }
   a1:=-(fm/ab)*(o-p5*rd*qq);  //   2\alpha_1
   a2:=-fm*ab*re*(o+pp*rd*qq); // -(\alpha_2)^2
   p3:=+fm*ab*re*rd*(o+pp)*qq; //  (\alpha_3)^2
   a3:=signuc*Sqrt(Abs(p3));   //   \alpha_3 with signum of cos(i)
   { some variables }
   fem:=o/fm;      // simple 1/(f*M)
   fa:=-fm/a1;     // -(f*M)/(2*\alpha_1)
   { accurate value for n_0 \sqrt((-2\alpha_1)^3)/(f*M) }
   an0:=-a1*sqrt(-a1)*fem; // accurate value for n_0
   { accurate value for e*=-2*\alpha_1*a*e/(f*M) }
   az:=-a1*ab*ae/fm;       // accurate value for e*
   { iterations to obtain value for \delta* }
   z2:=cj2*cj2; // c^2
   z0:=cj2*sig; // c*\sigma
   aq:=w*fm*z0; // 2*(f*M)*c*\sigma
   bq:=a1*z2;   // 2\alpha_1*c^2
   cq:=bq+a2;   // 2\alpha_1*c^2-(\alpha_2)^2
   adz:=-ad;    // approx \delta*      \eta_1
   dz2:=d2;     // approx (\delta*)^2
   { simple iterations to obtain \delta* = \eta_1 }
   for j:=1 to 7 do    // some iterations
     begin             // small parameter \epsilon^2 near 0.001
       qdz:=aq*rd/(cq+aq*adz-bq*(d2+dz2)); // small \Delta\delta
       adz:=-ad+qdz;   // approx \delta* \eta_1=-\eta_2+\Delta\delta
       dz2:=Sqr(adz);  // approx (\delta*)^2
     end;
 end; // TCeil.AlphaFromElem

 { to obtain values for parameters e^ s d \gamma and others }

 procedure TCeil.ToGetSomeParm ;
 var
   i  : Byte ;
 begin

   { for ksi }
   x1:=ab*(o-ae);                  // \xi_1=a*(1-e)
   x2:=ab*(o+ae);                  // \xi_2=a*(1+e)
   al1:=-ab+fa;                    // value fa -(f*M)/(2*\alpha_1)
   apr:=al1;                       // p simple
   pq22:=z2*(a2+a3*a3)/(x1*x2*a1); // p^2+q^2
   akr:=Sqrt(x2*x2-2*apr*x2+pq22); // n'
   bkr:=Sqrt(x1*x1-2*apr*x1+pq22); // n"
   ag2:=sqrt(-a1*akr*bkr);         // \sigma_2
   r1:=akr-bkr;                    // n'-n"
   ax:=r1/(akr+bkr);                          // e^ (n'-n")/(n'+n")
   ak22:=(Sqr(x2-x1)-r1*r1)/(4.0e0*akr*bkr);  // k_2^2
   ak22kr:=-ak22/(1-ak22);                    // (k_2^2)^
   ag2kr:=ag2*Sqrt(1-ak22);                   // (\sigma_2)^

   { for eta }
   apr:=-fa*sig*cj2-t1*(adz+ad)*z2;                       // p'
   dpr:=a2/a1+z2*(1-d2-ad*adz-dz2)-2*fa*sig*cj2*(adz+ad); // q'^2-p'^2
   akr:=Sqrt(dpr+2*apr*ad-z2*d2);                         // m'
   bkr:=Sqrt(dpr+2*apr*adz-z2*dz2);                       // m"
   r1:=akr-bkr;                                           // m'-m"
   ka2:=(z2*Sqr(ad-adz)+r1*r1)/(4.0e0*akr*bkr);           // k^2
   r2:=o+ka2;                                             // 1+k^2
   ak12:=ka2/r2;                 // k_1^2 k^2/(1+k^2)
   abkr:=o/(akr+bkr);            // 1/(m'+m")
   ag1:=sqrt(-a1*akr*bkr*r2);    // \sigma_1
   asu:=-(akr*adz-bkr*ad)*abkr;  // s (m"*\eta_2-m'*\eta_1)/(m'+m")
   at:=-r1*abkr;                 // d (m"-m')/m'+m")
   ag:=(akr*adz+bkr*ad)*abkr;    // \gamma (m"*\eta_2+m'*\eta_1)/(m'+m")

   { some simple values }
   s2:=asu*asu;    // s^2
   ax2:=ax*ax;     // (e^)^2
   r1:=o;
   axx[1]:=o;      // (e^)^2 to other powers
   for i:=2 to 6 do
     begin
       r1:=ax2*r1; // (e^)^2 to the next power
       axx[i]:=r1; // the next power of (e^)^2
     end;

   ag22:=ag*ag;    // \gamma^2
   asag:=w*asu*ag; // 2*s*\gamma

 end; // TCeil.ToGetSomeParm

 { some array for calculations }

 procedure TCeil.ToPlaceValue ;
 var
   i  : Byte ;
 begin
   d[1]:=o;          // 1
   d[2]:=-w*at;      // -2*d
   d[3]:=at*at;      // d^2
   a[1]:=o;          // 1
   a[2]:=d[2];       // -2*d
   b[1]:=o-ag22;     // 1-\gamma^2
   b[2]:=d[2]+asag;  // 2*s*\gamma-2*d
   b[3]:=d[3]-s2;    // d^2-s^2
   v[1]:=ag22;       // \gamma^2
   v[2]:=-asag;      // -2*s*\gamma
   v[3]:=s2;         // s^2
   vv[1]:=+ag;       // \gamma
   vv[2]:=-asu;      // -s
   r1:=o;            // 1
   e[1]:=o;          // 1
   ee[1]:=o;         // d^0
   for i:=2 to n6 do
     begin           // parameter d to power
       r1:=at*r1;    // to the next power    d^(i-1)
       ee[i]:=r1;    // the next power of d  d^(i-1)
       e[i]:=i*r1;   // i*d^(i-1)
     end;
 end; // ToPlaceValue

 { to sum terms for full elliptic integrals
      and to calculate value for the parameter
      \nu = (\sigma_1/\sigma_2)*(K(k_2)/K(k_1)-1 }

 procedure TCeil.FullElliptic ; // coef \nu between \phi and \psi
 var
   i,j  : Byte ;
 begin
   q1:=o/(o-ak22);  // 1/(1-k_2^2)
   qk:=sqrt(q1);    // sqrt(1/(1-k_2^2))
   q2:=-ak22*q1;    // -k_2^2*sqrt(1/(1-k_2^2))
   i:=0;
   rf:=o;           // initial values
   rp:=o;           // to calculate
   qa:=ol;          // two full
   qb:=ol;          // elliptic integrals
   j:=1;            // the first element in array with factors
   While  j <= n11  Do    // term plus term
     Begin
       i:=i+1;
       f[j]:=tt[i]*rf;    // the first  for k_1^2 with factor
       p[j]:=tt[i]*rp;    // the second for k_2^2 with factor
       rf:=ak12*rf;       // the next power for k_1^2
       rp:=q2*rp;         // the next power for k_2^2
       qa:=qa+tt[i]*f[j]; // qa is full elliptic integral K(k1)/(Pi/2)
       qb:=qb+tt[i]*p[j]; // qb is full elliptic integral K(k2)/(Pi/2)
       j:=j+2;            // to number in array with factors
     End;
   { qa is full elliptic integral K(k1)/(Pi/2)
     qb is full elliptic integral K(k2)/(Pi/2) }
   aqk:=qa;            // K(k1)/(Pi/2)
   qa:=o/qa;           // (Pi/2)/K(k1)
   qq:=qk*qa*ag1/ag2;  // (\sigma_1/\sigma_2)*(Pi/2)/K(k1)*sqrt(1/(1-k_2^2))
   an:=qq*qb;          // 1+\nu
   oh:=an-o;           // \nu = 1+\nu-1
 end; // TCeil.FullElliptic

 { \nu is coefficient secular
       to link two angles \phi and \psi
       but there are coefficients for periodic terms }

 procedure TCeil.ForCoefPhiPsi ; // periodic coefficients
 var
   i,j,ii,ij  : Byte ;
 begin
   { only even order coefficients
     \kappa_(2j) for \psi [\bar \kappa_(2j)] for \phi }
   For i:=1 To n5 Do  // for n5 coefficients
     Begin
       ii:=2*i;       // only even number
       rp:=ol;        // nullo initial
       rf:=ol;
       j:=ii;         // even so
       While  j <= n10  Do  // to sum
         Begin
           ij:=j+1;                // for factor
           rp:=rp+uu[ii][j]*p[ij]; // with factor for \kappa
           rf:=rf+uu[ii][j]*f[ij]; // with factor for \bar \kappa
           j:=j+2;                 // the next even number
         End;
       akp[i]:=+td[ii]*qq*rp; // value \kappa_(2j)      for \sin(2*j*\psi)
       akf[i]:=-td[ii]*qa*rf; // value \bar \kappa_(2j) for \sin(2*j*\phi)
     End;
 end; // ForCoefPhiPsi

 { to obtain accurate values for \alpha* \beta \bar\gamma
   formula for longitude w
   w=+\alpha_3*\int(d\tau)/(1-\eta^2)
     -\alpha_3*c^2*\int(d\tau)/(\xi^2+c^2) }

 procedure TCeil.ForCoefAlbega ;
 begin
   abc1:=sqrt(b[1]-b[2]+b[3]);  // \sqrt(A-B+C)
   abc2:=sqrt(b[1]+b[2]+b[3]);  // \sqrt(A+B+C)
   abcs:=abc1+abc2;             // plus
   abcr:=abc1-abc2;             // minus
   agkr:=4.0e0/(abcs*abcs-4.0e0*b[3]); // \bar\gamma
   sg:=sqrt(agkr);                     // \sqrt(\bar\gamma)
   tt1:=t1;                            // factor 1/2
   If  a3 < 0.0e0  Then  tt1:=-t1;     // negative for i > 90 degree
   ac:=tt1*sg*abcs;                    // coefficient \alpha near cos(i)
   aq:=tt1*sg*abcr;                    // coefficient \beta
   acw:=tt1*abcs;    // auxiliary \alpha/\sqrt(\bar\gamma)
   aqw:=tt1*abcr;    // auxiliary \beta/\sqrt(\bar\gamma)
   agw:=o/sg;        // auxiliary 1/\sqrt(\bar\gamma)
 end; // ForCoefAlbega

 { to calculate integral d\tau/(1-\eta^2)
      it is necessary to make simple division
      a_0+a_1*\cos(\phi)+a_2*\cos(2*\phi)+...+a_n*\cos(n*\phi)
      --------------------------------------------------------
              b_0+b_1*\cos(\phi)+b_2*\cos(2*\phi)
   result to array u[..] }

 procedure TCeil.ToDividePolin ; // polinoms
 var
   i,j,k,l,ii,jj  : Byte ;
 begin
   For j:=m To n11 Do
     a[j]:=d[1]*f[j]+d[2]*f[j-1]+d[3]*f[j-2];
   For ii:=m To n11 Do
     Begin
       i:=n11-ii+m;
       l:=i-m+1;
       ull:=a[i]/b[m];    // result
       u[l]:=ull;         // term by term
       k:=i;
       For jj:=1 To m Do
         Begin            // to divide by usual method
           j:=m-jj+1;           // from the top power
           a[k]:=a[k]-b[j]*ull; // to lower power
           k:=k-1;
         End;
     End;
   { for coefficient \beta_0
     main formula
     \Omega~ = \alpha'_0*\psi+\beta_0*\phi+periodic terms+const }
   qq:=a3/ag1;  // \apha_3/\sigma_1
   aq0:=ol;     // \beta_0 initial
   i:=0;
   j:=1;
   While  j <= n9  Do  // to sum term
     Begin
       i:=i+1;
       aq0:=aq0+tt[i]*u[j]; // to sum with factor
       j:=j+2;              // by using result of division
     End;
   aq0:=qq*aq0;  // this is value for \beta_0
 end; // ToDividePolin

 { to obtain periodic terms for \Omega with angle \phi }

 procedure TCeil.WPhiPeriodic ; // periodic terms with angle phi for w
 var
   i,j,ij  : Byte ;
 begin
   For i:=1 To n8 Do  // for n8 periodic terms
     Begin
       rr:=ol;
       j:=i;
       While  j <= n8  Do
         Begin
           ij:=j+1;
           rr:=rr+uu[i][j]*u[ij]; // to sum for current terms with factor
           j:=j+2;
         End;               // now result
       aqf[i]:=td[i]*qq*rr; // \beta_i^f
     End;
 end;

 { to obtain coefficient \alpha'_0 in formulae
   \Omega~ = \alpha'_0*\psi+\beta_0*\phi+periodic terms+const }

 procedure TCeil.WPsiSecular ; // for coefficient \alpha'_0
 var
   i,j,k  : Byte ;
 begin

   q1:=o-ae*ax;       // 1-e*(\bar e)
   qr:=o/q1;          // 1/(1-e*(\bar e))
   qe:=-(ax-ae)*qr;   // -((\bar e)*e)/(1-e*(\bar e))

   For i:=1 To n11 Do
     Begin
       g1[i]:=ol;
       g2[i]:=ol;
     End;
   g1[1]:=qr;         // the first power
   g1[2]:=ax*qr;
   r1:=o;
   For i:=1 To n6 Do
     Begin
       g2[i]:=r1;
       r1:=qe*r1;      // to the next power
     End;

   abba(g1,g2,bks,n2,n6,n7);     // to multiply polinoms
   abba(bks,bks,bks2,n7,n7,n8);

   ab22:=o/(ab*ab);              // 1/a^2
   q2:=-z2*ab22;                 // -c^2/a^2
   qz:=o;                  // initial unit
   qq:=-a3*z2*ab22*qk/ag2; // -\alpha_3*(c^2/a^2)*\sqrt(1/(1-k_2^2))/sigma_2
   For i:=1 To n11 Do
     Begin
       bks8[i]:=bks2[i];
       bks4[i]:=bks2[i];
     End;
   k:=2;
   While  k < n10  Do
     Begin
       k:=k+2;
       qz:=qz*q2;         // to the next power (-c^2/a^2)^k
       abba(bks2,bks8,bks6,n8,n11,n11);
       For i:=1 To n11 Do
         Begin
           bks4[i]:=bks4[i]+qz*bks6[i];
           bks8[i]:=bks6[i];
         End;
     End;

   For i:=1 To n11 Do
     Begin
       qu:=bks4[i];
       u[i]:=qq*qu;
     End;

   abba(u,p,g,n11,n11,n11);  // to multiply

   ac0:=ol;
   i:=0;
   j:=1;
   While  j <= n11  Do      // Teilor series
     Begin
       i:=i+1;              // with factor
       ac0:=ac0+tt[i]*g[j]; // \alpha'_0
       j:=j+2;              // result
     End;

 end; // WPsiSecular

 { to obtain periodic part for \Omega with angle \psi \alpha_i^p }

 procedure TCeil.WPsiPeriodic ; // for coefficients \alpha_i^p
 var
   i,j,ij  : Byte ;
 begin
   For i:=1 To n10 Do
     Begin
       rr:=ol;
       j:=i;
       While  j <= n10  Do
         Begin
           ij:=j+1;
           rr:=rr+uu[i][j]*g[ij]; // to sum with factor
           j:=j+2;
         End;
       acp[i]:=td[i]*rr;          // result \alpha_i^p
     End;
 end; // WPsiPeriodic

 { to integrate expression
      dt = \xi^2 d\tau + c^2 * \eta^2 d\tau }

 procedure TCeil.TimeSecular ; // \int \xi^2 d\tau + c^2 * \eta^2 d\tau
 var
   i,j,k,ii  : Byte ;
 begin

   { for \int \xi^2 d\tau }
   bps[1]:=2.0e0*al1/ab;
   pq22:=pq22*ab22;
   For i:=1 To n11 Do
     bps[i]:=bps[i]-pq22*bks[i];

   abba(bps,bps,bps2,n7,n7,n8);

   For i:=1 To n11 Do
     bps4[i]:=t2*bps2[i];

   abba(bks,bps,g3,n7,n7,n11);

   abba(bps,bps2,bps3,n7,n8,n9);
   abba(bks,bps3,g4,n7,n9,n11);

   For i:=1 To n11 Do
     bps4[i]:=bps4[i]+t3*g4[i];

   ii:=4;
   k:=6;
   While  k < n10  Do
     Begin
       k:=k+2;
       ii:=ii+1;
       abba(g3,g4,g5,n11,n11,n11);
       For i:=1 To n11 Do
         Begin
           g4[i]:=g5[i];
           bps4[i]:=bps4[i]+tt[ii]*g5[i];
         End;
     End;

   bps4[1]:=-t1*pq22+bps4[1];

   { for \int c^2 * \eta^2 d\tau }
   bx2:=sqrt(o-ax2);
   rx:=-a1*fem*ab*bx2*qr;
   qq:=z2*an0/ag1;
   abba(g2,bps4,h,n6,n11,n11);
   abba(v,e,g,n3,n6,n8);
   abba(g,f,hh,n8,n11,n11);

   For i:=1 To n11 Do
     Begin
       hh[i]:=qq*hh[i];
       h[i]:=rx*h[i];
     End;

   i:=0;
   j:=1;
   af0:=ol;
   ap0:=ol;
   While  j <= n11  Do
     Begin
       i:=i+1;
       ap0:=ap0+tt[i]* h[j];  // \gamma_0  for \psi
       af0:=af0+tt[i]*hh[j];  // \gamma'_0 for \phi
       j:=j+2;                // our result
     End;

   amu:=ac0+an*aq0;   // \mu
   alam:=-ap0-an*af0; // \lambda
   rlam:=o/(o-alam);  // 1/(1-\lambda)
   anr:=an0*rlam;     // n_0/(1-\lambda)
   { 2*(\sigma_1/(1-\lambda))/((2/\pi)*K(k_1)) }
   delt2:=2*ag1*rlam/aqk; // for derivation of \alpha_2

 end; // TimeSecular

 { to integrate expression
      dt = \xi^2 d\tau + c^2 * \eta^2 d\tau }

 procedure TCeil.TimePeriodic ; // \int \xi^2 d\tau + c^2 * \eta^2 d\tau
 var
   i,j,ij  : Byte ;
 begin                          // for periodic terms
  For i:=1 To n10 Do
     Begin
       rp:=ol;
       rf:=ol;
       j:=i;
       While  j <= n10  Do
         Begin
           ij:=j+1;
           rp:=rp+uu[i][j]* h[ij];
           rf:=rf+uu[i][j]*hh[ij];
           j:=j+2;
         End;
       app[i]:=td[i]*rp;  // \gamma_i^p
       aff[i]:=td[i]*rf;  // \gamma_i^f
     End;

   i:=0;
   j:=2;
   While  j <= n8  Do
     Begin                        // to replace variables
       i:=i+1;                    // and coefficients
       aqf[j]:=aqf[j]+aq0*akf[i]; // \alpha_j^f for \phi \Omega
       acp[j]:=acp[j]+aq0*akp[i]; // \beta_j^p  for \psi \Omega
       aff[j]:=aff[j]+af0*akf[i]; // \gamma_i^f fpr \phi n_0*(t-t_0)
       app[j]:=app[j]+af0*akp[i]; // \gamma_i^p fpr \psi n_0*(t-t_0)
       j:=j+2;
     End;
 end; // TimePeriodic

 procedure TCeil.AllParameter ; // all parameter to array c of TEilParm
 var
   i,i1,i2,i3,i4  : Byte ;
 begin

   c[5]:=a1;
   c[6]:=a2;
   c[7]:=a3;
   c[8]:=ab;
   c[9]:=ae;
   c[10]:=asu;
   c[11]:=ac;
   c[12]:=ax;
   c[13]:=ag;
   c[14]:=at;
   c[15]:=aq;
   c[16]:=ag1;
   c[17]:=ag2;
   c[18]:=ak12;
   c[19]:=ak22;
   c[20]:=az;
   c[21]:=an;
   c[22]:=amu;
   c[23]:=alam;       // \lambda
   c[24]:=anr;        // n_0/(1-\lambda)
   c[25]:=anr*oh;     // n_0*\nu/(1-\lambda)
   c[26]:=anr*amu;    // n_0*\mu/(1-\lambda)
   c[27]:=an0;        // n_0
   c[28]:=oh;         // \nu
   c[29]:=aq0; { beta0 for fi }
   c[30]:=af0; { gamma0prime for fi }
   c[31]:=ac0; { alpha0prime for psi }
   c[32]:=ap0; { gamma0 for psi }
   c[33]:=rlam;
   c[34]:=epscj2;
   c[35]:=agw;
   c[36]:=acw;
   c[37]:=aqw;
   c[38]:=ad;
   c[39]:=adz;
   c[40]:=delt2; { delta for derivation of alpha2 }

   For i:=1 To 5 Do
     Begin
       i1:=40+i;
       i2:=45+i;
       c[i1]:=akf[i];
       c[i2]:=akp[i];
     End;
   For i:=1 To 10 Do
     Begin
       i1:=50+i;
       i2:=60+i;
       i3:=70+i;
       i4:=80+i;
       c[i1]:=aqf[i];
       c[i2]:=acp[i];
       c[i3]:=aff[i];
       c[i4]:=app[i];
     End;
 end; // AllParameter

 procedure TCeil.ToGetAllParm ; // to calculate all parameter
 begin
   ToGetSomeParm ;   // some values e^ \sigma_2^ s d \gamma \sigma_1
   ToPlaceNullo ;    // nullo values to auxiliary arrays
   ToPlaceValue ;    // to fill auxiliary arrays by on nullo values
   FullElliptic ;    // value parameter \nu
   ForCoefPhiPsi ;   // value \kappa_(2j) [\bar \kappa_(2j)]
   ForCoefAlbega ;   // value \alpha \beta \bar\gamma
   ToDividePolin ;   // polinoms a[..]/b[..] for d\tau/(1-\eta^2) \beta_0
   WPhiPeriodic ;    // periodic terms with angle phi for w \beta_i^f
   WPsiSecular ;     // for coefficient \alpha'_0
   WPsiPeriodic ;    // for coefficients \alpha_i^p
   TimeSecular ;     // \int \xi^2 d\tau + c^2 * \eta^2 d\tau 
   TimePeriodic ;    // \int \xi^2 d\tau + c^2 * \eta^2 d\tau 
   AllParameter ;    // all parameter to array c of TEilParm
 end; // ToGetAllParm


 { value
   a1 2\alpha_1
   a2 -\alpha_2^2
   a3  \alpha_3
   is known but it is possible to fill array c with other values }

 procedure TCeil.EilConstFromAlpha ; // values to array c[1..90]
 begin
   ElemFromAlpha ;   // a e \delta \delta* by a1 a2 a3 values
   ToGetAllParm ;    // to calculate all parameter
 end; // TCeil.EilConstFromAlpha

 { values
   ab a semimajor axis
   ae e eccentricity
   ad \delta \eta_2
   and signum cosinus of inclination
   is known but it is possible to fill array c with other values }

 procedure TCeil.EilConstFromElems ; // values array c of TEilParm UnConTyp
 begin
   AlphaFromElem ;   // a1 a2 a3 \delta* by values a e \delta
   ToGetAllParm ;    // to calculate all parameter
 end; // TCeil.EilConstFromElems

 { initial condition vector
   xx DesCart position in km
   vv DesCart velosity in km/s
   to record  TEilPang with pelm angl angg angh }

 Procedure TCeil.FromCarToEil ( xx , vv  : TVect3 ;     // km km/s
                                Var  el  : TEilPang ) ; // type UnConTyp
 Var
   i,ii  : Byte ;
   x1,x2,x3,v1,v2,v3  : Extended ;
   zx,z4,r1,r2,u2,dp  : Extended ;
   f2,fi,bs,bt,vt,vs  : Extended ;
 Begin
   z2:=Sqr(c[3]);  // parameter c^2  but c near 210 km
   z0:=c[3]*c[4];  // c*\sigma
   x1:=xx[1];      // x km
   x2:=xx[2];      // y km
   x3:=xx[3]-z0;   // z-c*\sigma km
   v1:=vv[1];      // v_x km/s
   v2:=vv[2];      // v_y km/s
   v3:=vv[3];      // v_z km/s
   zx:=x3*x3;      // (z-c*\sigma)^2
   r2:=x1*x1+x2*x2+zx;    // r'^2
   u2:=v1*v1+v2*v2+v3*v3; // v^2
   r1:=x1*v1+x2*v2+x3*v3; // \vec r' * \vec v
   dp:=r2-z2;                        // difference
   f2:=t1*(dp+sqrt(dp*dp+4*z2*zx));  // \xi^2 current t1=0.5
   bs:=sqrt(f2);                     // \xi  value in km
   bt:=x3/bs;                        // \eta value (z-c*\sigma)/\xi
   z4:=z2*bt*bt;                     // c^2*\eta^2
   fi:=w*c[1]/(f2+z4);               // (2*f*M)/(\xi^2+c^2*\eta^2)
   vt:=bs*v3-bt*r1;                  // velosity \dot \eta
   vs:=bs*r1+z2*bt*v3;               // velosity \dot \xi
   a1:=u2-fi*(bs-z0*bt);             // const 2*\alpha_1
   a2:=r1*r1-r2*u2+z2*v3*v3-fi*(bs*z4+z0*bt*f2); // const -(\alpha_2)^2
   a3:=x1*v2-v1*x2;                  // const \alpha_3 with signum
   EilConstFromAlpha ;   // to fill array c by using value a1 a2 a3
   el.pelm:=c;           // array with parameter to result
   { value for elements ab ae asu at ag ... are known }
   ce:=(1.0-bs/ab)/ae;               // cos(E)
   se:=sqrt(Abs(o-ce*ce));           // sin(E)
   If  vs < 0.0  Then  se:=-se;      // sin(E)    with signum \dot \xi
   ea:=DATan2(se,ce);                // angle E in radian UnForFun
   cpp:=(ce-ax)/(1.00-ax*ce);        // cos(\psi)
   spp:=sqrt(o-cpp*cpp);             // sin(\psi)
   If  vs < 0.0  Then  spp:=-spp;    // sin(\psi) with signum \dot \xi
   ep:=DATan2(spp,cpp);              // angle \psi in radian UnForFun
   cff:=(bt-ag)/(bt*at-asu);          // cos(\phi)
   sff:=sqrt(Abs(o-cff*cff));        // sin(\phi)
   If  vt < 0.0  Then  sff:=-sff;    // sin(\phi) with signum \dot \eta
   ef:=DATan2(sff,cff);              // angle \phi in radian UnForFun
   pc:=o;                            // angle \psi \phi
   fc:=o;                            // initial unit  cos(0*a)
   ps:=ol;                           // initial nullo sin(0*a)
   fs:=ol;                           // for current value i
   For i:=1 To n10 Do                // to take
     Begin                           // into account
       uc:=pc*cpp-ps*spp;            // periodic terms
       vc:=fc*cff-fs*sff;            // cosinus and sinus
       us:=ps*cpp+pc*spp;            // for i*\psi
       vs:=fs*cff+fc*sff;            // for i*\phi
       sf[i]:=vs;                    // sin(i*\phi)
       sp[i]:=us;                    // sin(i*\psi)
       pc:=uc;                       // to the next
       ps:=us;                       // value i
       fc:=vc;                       // to keep curremt
       fs:=vs;                       // cosinus sinus
     End;
   rf:=ol; // nullo initial periodic part with angle \phi~
   rp:=ol; // nullo initial periodic part with angle \psi
   ru:=ol; // nullo initial periodic part with angle \Omega~
   For i:=1 To n5 Do
     Begin            // periodic part with angle \phi~
       ii:=2*i; 
       rf:=rf+c[40+i]*sf[ii]+c[45+i]*sp[ii];
     End;
   For i:=1 To n10 Do
     Begin            // periodic part with angles \psi \Omega
       ru:=ru+c[50+i]*sf[i]+c[60+i]*sp[i]; // for \psi
       rp:=rp+c[70+i]*sf[i]+c[80+i]*sp[i]; // for \Omega
     End;
   el.angl:=(ea-c[20]*se-c[23]*ep+rp)*c[33]; // result angle l in radian
   pudl:=ep-el.angl;                         // \psi-l
   el.angg:=ef-ep-c[28]*pudl-rf; // result angle g in radian
   r4:=c[11]*cff-c[15];          // \alpha*\cos(\phi)-\beta
   r5:=o/sqrt(r4*r4+sff*sff);    // 1/((\alpha*cos\phi-\beta)^2+sin^2\phi)
   cw:=r4*r5;                    // cos(w~)
   sw:=sff*r5;                   // sin(w~)
   uw:=DATan2(sw,cw);            // angle w~ in radian
   bw:=DATan2(x2,x1);  // longitude angle w  in radian w=w~+\Omega~           
   el.angh:=bw-uw-c[22]*pudl-ru; // result angle h in radian
 End;

 { record TEilPang
   pelm angl angg angh 
   to condition vector
   xx DesCart position in km
   vv DesCart velosity in km/s }

 Procedure TCeil.FromEilToCar ( el  : TEilPang ; // pelm[..] parameters ang l g h angles
                                var  xx , vv  : TVect3 ) ;     // km km/s types UnConTyp
 Var
   i,j,ii  : Byte ;
   e,p,f,bs,bt,rt,
   su,cu,ru,vt,vw,
   ri,r1,r2,r3,q1,q2,q3  : Extended ;
   ul,ug,uh  : Extended ; // angle elements l g h in radian
 Begin
   c:=el.pelm;             // parameters values type TElmParm array[1..90]
   ul:=el.angl;            // value angle l in radian from input record
   ug:=el.angg;            // value angle l in radian from input record
   uh:=el.angh;            // value angle l in radian from input record
   rx:=Sqrt(o-Sqr(c[12])); // \sqrt(1-(\bar e)^2) c[12] ax (\bar e)
   z2:=Sqr(c[3]);          // c^2 c near 210 km
   z0:=c[3]*c[4];          // c*\sigma 
   e:=KeplerEquation(c[9],ul); // E UnForKep M=E-e*sin(E) by Newton
   p:=e;                       // approximately angle \psi
   f:=p+ug;                    // approximately angle \phi~
   se:=Sin(e);                 // sin(E)
   ce:=Cos(e);                 // cos(E)
   sp[1]:=se;                  // approximately sin(\psi)
   sf[1]:=Sin(f);              // approximately sin(\phi)
   For i:=2 To 10 Do
     Begin                     // initial nullo for 
       sp[i]:=ol;              // sin(i*\psi)
       sf[i]:=ol;              // sin(i*\phi)
     End;
   pudl:=ol;                   // initial nullo \psi-l
   j:=0;                       // for iterations 
   r:=o;
   While  ( ( j < 15 ) AND ( r > 2.0e-18 ) )  Do 
     Begin                     // some iteration
       j:=j+1;                 // the next iteration
       rf:=ol;
       rp:=ol;
       For i:=1 To 5 Do
         Begin
           ii:=2*i;            // periodic part in \phi \psi equation
           rf:=rf+c[40+i]*sf[ii]+c[45+i]*sp[ii];
         End;
       For i:=1 To 10 Do       // periodic part in l E \psi \phi equation
         rp:=rp+c[70+i]*sf[i]+c[80+i]*sp[i];
       ea:=ul+c[20]*se+c[23]*pudl-rp; // new value E c[20] e*
       se:=Sin(ea);                   // sin(E)
       ce:=Cos(ea);                   // cos(E)
       re:=o/(o-c[12]*ce);            // 1/(1-(\bar e)*cos(E))
       spp:=rx*re*se;                 // \sin(\psi)
       cpp:=(ce-c[12])*re;            // \cos(\psi)
       p:=ea+ArcTan((spp*ce-cpp*se)/(cpp*ce+spp*se)); // new value \psi
       pudl:=p-ul;                    // new value \psi-l
       f:=p+ug+c[28]*pudl+rf;         // new value \phi
       sff:=Sin(f);                   // \sin(\phi)
       cff:=Cos(f);                   // \cos(\phi)
       pc:=o;
       fc:=o;
       ps:=ol;
       fs:=ol;
       For i:=1 To 10 Do
         Begin                        // to calculate
           uc:=pc*cpp-ps*spp;         // \sin(i*\psi)
           vc:=fc*cff-fs*sff;         // sin(i*\phi)
           us:=ps*cpp+pc*spp;         // by simple
           vs:=fs*cff+fc*sff;         // cosinus
           sf[i]:=vs;                 // sinus formulae
           sp[i]:=us;
           pc:=uc;
           ps:=us;
           fc:=vc;
           fs:=vs;
         End;
       r:=Abs(ea-e);                  // variable to compare
       e:=ea;                         // iteration result
     End;
   bs:=c[8]*(o-c[9]*ce);              // \xi=a*(1-e*cos(E))
   rt:=o/(o-c[14]*cff);               // 1/(1-d*cos(\phi))
   bt:=(-c[10]*cff+c[13])*rt;  // \eta (-s*cos(\phi+\gamma)/(1-d*cos(\phi))
   r1:=bs*bs+z2;               // \xi^2+c^2
   r2:=o-bt*bt;                // 1-\eta^2
   r3:=Sqrt(r1*r2);            // \sqrt((\xi^2+c^2)*(1-\eta^2));
   r4:=c[11]*cff-c[15];        // \alpha*cos(\phi)-\beta
   r5:=o/Sqrt(r4*r4+sff*sff);  // for angle w~
   ru:=uh+c[22]*pudl;          // for angle \Omega~=h+\mu*(\psi-l)+...
   For i:=1 To 10 Do
     ru:=ru+c[50+i]*sf[i]+c[60+i]*sp[i]; // the second part to \Omega
   cw:=r4*r5;                            // cos(w~)
   sw:=sff*r5;                           // sin(w~)
   su:=Sin(ru);                          // sin(\Omega)
   cu:=Cos(ru);                          // cos(\Omega)
   xx[1]:=r3*(cw*cu-sw*su);              // x position km result
   xx[2]:=r3*(sw*cu+cw*su);              // y position km result
   xx[3]:=z0+bs*bt;                      // z position km result
   ri:=o/(bs*bs+z2*bt*bt);               // 1/(\xi^2+c^2*\eta^2)
   r1:=o/r1;                             // 1/(\xi^2+c^2)
   r2:=o/r2;                             // 1/(1-\eta^2)
   q1:=Sqrt(o-c[19]*spp*spp);            // for \dot \xi
   q2:=Sqr(rx/(o+c[12]*cpp));            // with angle \psi
   q3:=c[8]*c[9]*c[17];                  // a*e*\sigma_2
   vs:=q3*ri*q2*spp*q1;                  // velosity \dot \psi
   q1:=Sqrt(o-c[18]*cff*cff);            // for \dot \phi
   q2:=(c[10]-c[13]*c[14])*c[16];        // (s-\gamma*d)*\sigma_1
   vt:=q2*ri*rt*rt*sff*q1;               // velosity \dot \eta
   vw:=c[7]*r1*r2;                       // \dot w with integral \alpha_3
   r4:=bs*vs*r1-bt*vt*r2;                // modul velosity
   vv[1]:=xx[1]*r4-xx[2]*vw;               // v_x velosity km/s result
   vv[2]:=xx[2]*r4+xx[1]*vw;               // v_y velosity km/s result
   vv[3]:=bs*vt+vs*bt;                   // v_z velosity km/s result
 End;

 { input values
   anob  mean motion           n in revolution per day
   aecc  eccentricity          e
   ainc  angle of inclination  i in degree }

 Procedure TCeil.FromElemToCeil ( anob , aecc , ainc  : Extended ) ;
 Var
   it  : Byte ;
   ci  : Extended ;
 Begin

   fm:=c[1];     // simple const are known 
   rz:=c[2];     // from initialiation
   cj2:=c[3];    // c
   sig:=c[4];    // \sigma
   z2:=Sqr(cj2); // c^2          km^2
   z0:=cj2*sig;  // c*sig        km

   aq:=w*fm*z0;  // 2*fm*c*sig   km^4/s^2
   ae:=aecc;                     // eccentrity
   an0:=Pi*anob/43200.0;         // mean motion to radian per second
   a1:=-Exp(2.0/3.0*Ln(fm*an0)); // accurate 2*\alpha_1 in km^2/s^2

   asu:=Sin(GraRad*ainc);        // sin(i)
   s2:=Sqr(asu);                 // sin^2(i)
   ci:=Cos(GraRad*ainc);         // cos(i)

   fa:=-fm/a1;          // approximately value a -f*M/(2*\alpha_1)
   ab:=fa;              // the same approximately semimajor axis
   e2:=Sqr(ae);         // e^2 for eccentricity
   re:=1-e2;            // 1-e^2
   epscj2:=cj2/(ab*re); // approximately small \epsilon=c/(a*(1-e^2))
   p2:=Sqr(epscj2);     // approximately small \epsilon^2

   ad:=asu-epscj2*sig*(1-s2)*(1-epscj2*sig*asu-p2*(3-4*s2+e2));
   d2:=Sqr(ad);   // approximately \delta=\eta_2 and \delta^2

   qdz:=-aq*(o-d2)/(fm*ab*re); // the first estimation \Delta\delta
   adz:=-ad+qdz;  // for approximately \delta*=\eta_1 value
   dz2:=Sqr(adz); // and (\delta*)^2

   For it:=1 To 6 Do  // simple iteration to find values a \delta 
     Begin              // \alpha_1 \alpha_2 \alpha_3
       rr:=(o-w*epscj2*sig*ad-p2*d2*re);        // value for Q     
       rr:=rr/(o+w*p2*d2*(o+e2)+Sqr(p2*d2*re)); // Q value
       ab:=fa*(o-p2*re*(1-d2)*rr);              // new value for a
       epscj2:=cj2/(ab*re);            // new value \epsilon
       p2:=Sqr(epscj2);                // \epsilon^2
       rq:=w*p2*(o+e2)+Sqr(p2*re);     // 2*\eps^2*(1+e^2)+(\eps^2*(1-e^2))^2
       a2:=-fm*ab*re*(o+rq*rr*(o-d2)); // -\alpha_2^2 new estimation
       p3:=+fm*ab*re*(o-d2)*(o+rq)*rr; // \alpha_3^2  new estimation
       qdz:=aq*(o-d2);                 // 2*f*M*c*\sigma*(1-\delta^2)
       qdz:=qdz/((a1*z2+a2)+aq*adz-a1*z2*(d2+dz2)); // \Delta\delta for \eta_1
       adz:=-ad+qdz;                   // \delta*=\eta_1=-\delta+\Delta\delta
       dz2:=Sqr(adz);                  // new value \delta and (\delta*)^2
       apr:=-fa*z0-0.5*(ad+adz)*z2;                      // value p' and
       dpr:=a2/a1+z2*(o-d2-ad*adz-dz2)-w*fa*z0*(ad+adz); // q'^2-p'^2
       akr:=Sqrt(dpr+w*apr*ad-z2*d2);                    // value m'
       bkr:=Sqrt(dpr+w*apr*adz-z2*dz2);                  // value m"
       ad:=asu+(akr/(akr+bkr))*qdz;     // new value \delta=\eta_2
       d2:=Sqr(ad);                     // new value \delta^2
     End;                       // for iteration

   a3:=Sqrt(Abs(p3));                // |\alpha_3|

   if  ci < 0.0
     then            // in the case cos(i)<0  i > 90 degree
       begin
         a3:=-a3;    // negative value \alpha_3 with signum
         signuc:=-1; // signum cosinus angle of inclination
       end
     else            // angle of inclination <90 degree
        signuc:=+1;  // positive value fof \alpha_3

   { some variables }
   fem:=o/fm;         // simple 1/(f*M)
   az:=-a1*ab*ae*fem; // accurate value for e*=(-2*\alpha_1)*a*e/(f*M)

   { now values
     of the constants
     2*\alpha_1 -\alpha_2^2 \alpha_3
     elements and parameters
     a e \delta \delta* e* n_0 asu -(f*M)/(2*\alpha_1) \epsilon are known }

   ToGetAllParm ; // to calculate all parameter to c[..]

 End; // TCeil.FromElemToCeil procedure

 end. // class TCeil
