
 { one class for derivations
   for eiler elements
   a       semimajor axis
   e       eccentricity
   delta   with refer to action variables L G H
   to call method ToGetDerSel after methods of TCeil class }

 unit UnitDeil ;

 interface

 uses
   UnConTyp , // type TypeDim3 TypeDim33 for example
   UnitCeil ; // methods and variables class TCeil

 type

   TDeil = class

   private
                               // part. deriv. with respect to L G H
     da1,da2,da3  : TypeDim3 ; // 2\alpha_1 (\alpha_2)^2 (\alpha_3)^2

     DerQ,DerEps  : TypeDim3 ; // type UnConTyp
     qa,qb,qp,qq  : Extended ;
     p2,e2,d2,d4  : Extended ;
     re,rd,pr,ep  : Extended ;

     fmnorm       : Extended ;  // fM after normalisation 1
     abnorm       : Extended ;  // to normalize a/r_0
     a1norm       : Extended ;  // to normalize a1*(r_0/fM)
     a2norm       : Extended ;  // to normalize a2/(fM*r_0)
     a3norm       : Extended ;  // to normalize a3/\sqrt(fM*r_0)

     DerAC        : TypeDim33 ; // matrix d (\alpha) /d ( a e^2 \delta^2 )
     DerACInv     : TypeDim33 ; // inversion for DerAC matrix
     DerAction    : TypeDim33 ; // d (\alpha) / d ( L G H ) matrix
     DerE2        : TypeDim33 ; // a e^2 \delta^2 respect  L G H

     procedure ToGetDerOne ; // with respect to action variable L G H

     procedure ToNormal ; // a/r_0 \alpha_2/(fM*r_0) ...

     procedure SomeVar ;  // values for usefull variables

     procedure DerOfEps ; // d\epsilon/d(a e^2)

     procedure DerOfQ ;   // dQ/d(a e^2 \delta^2)
                          // d(2\alpha_1 \alpha_2^2 \alpha_3^2)
     procedure DerOfAC ;  // /d(a e^2 \delta^2)

     procedure ToGetDerTwo ; // with respect to a e^2 \delta^2
                             // d(2\alpha_1 (\alpha_2)^2
     procedure ToGetDerCan ; //   (\alpha_3)^2)/d(L G H)

     procedure ToGetDerSqr ; // d(a e^2 \delta^2)/d(L G H)

     procedure ToGetDerElm ; // d(a e \delta)/d(L G H)

   public

     daone  : TypeDim3 ;  // da/dL da/dG da/dH
     deone  : TypeDim3 ;  // de/dL de/dG de/dH
     ddone  : TypeDim3 ;  // d\delta/dL d\delta/dG d\delta/dH


     { partial derivations from  a , e , \delta
       with  respect to action variables L , G , H }

     procedure ToGetDerSel ; // result to DerE2 array[1..3,1..3]

           end; // class TDeil

 var
   deiler  : TDeil ; // new class TDeil

 implementation

 uses
   UnForFun ; // procedure ToInverseSimpleMatr

 { partial derivations
   for three constants of integration
   2\alpha_1 (\alpha_2)^2 (\alpha_3)^2
   with respect to L G H  may be obtained only if massive ceiler.c is known }

 procedure TDeil.ToGetDerOne ; // result to da1 da2 da3 of array[1..3]
 begin
 with  ceiler  do // array c[1..90] from ceiler of class TCeil UnitCeil
   begin          // it is necessary to know values for this array
     { element c[5] or a1 is constant 2*\alpha_1 in the theory }
     da1[1]:=+2*c[24]; { partial derivation n_0/(1-\lambda) }
     da1[2]:=+2*c[25]; { of a1 with respect n_0*\nu/(1-\lambda) }
     da1[3]:=+2*c[26]; { to L G H --> 1 2 3 n_0*\mu/(1-\lambda) }
     { element c[6] or a2 is constant -(\alpha_2*\alpha_2)
       d(\alpha_2^2)/d(Li)=2*\alpha_2*d(\alpha_2)/d(Li) }
     da2[1]:=-c[40]*c[30];     { partial derivation c[40] from UnitCeil }
     da2[2]:=+c[40]*(1+c[32]+c[30]);               { of a2 with respect }
     da2[3]:=+c[40]*((1+c[32])*c[29]-c[30]*c[31]); { to L G H --> 1 2 3 }
     { element c[7] or a3 is constant alpha3 or element H in the theory }
     da3[1]:=0;      { partial derivation }
     da3[2]:=0;      { of a3 with respect }
     da3[3]:=2*c[7]; { to L G H --> 1 2 3 }
   end; // with ceiler
 end; // ToGetDerOne

 { a try to normalise some constants }

 procedure TDeil.ToNormal ;    // by using f*M and r_0
 begin
   fmnorm:=1;                  // value fm after normalisation
   with  ceiler  do
     begin                     // class TCeil
       abnorm:=ab/rz;          // value a after      normalisation
       a1norm:=a1*(rz/fm);     // value 2*\alpha_1   normalisation
       a2norm:=a2/(fm*rz);     // value -\alpha_2^2  normalisation
       a3norm:=a3/Sqrt(fm*rz); // value \alfa_3 with normalisation
     end;
 end; // ToNormalize

 { values for usefull variables }

 Procedure TDeil.SomeVar ;
 Begin                     // epscj2 c[34] \epsilon=c/(a*(1-e^2))
   p2:=Sqr(ceiler.epscj2); // UnitCeil \epsilon^2
   e2:=Sqr(ceiler.ae);     // e^2
   re:=1-e2;               // 1-e^2
   d2:=Sqr(ceiler.ad);     // \delta^2
   d4:=Sqr(d2);            // \delta^4
   rd:=1-d2;               // 1-\delta^2
   pr:=p2*re;              // \epsilon^2*(1-e^2)
   ep:=Sqr(pr);            // \epsilon^4*(1-e^2)^2
   qa:=1-2*ceiler.epscj2*ceiler.sig*ceiler.ad-pr*d2; // Q nominator
   qb:=1/(1+2*p2*d2*(1+e2)+ep*d4); // denominator for Q
   qp:=-qa*Sqr(qb);                // Q multiply denominator
   qq:=-2*(ceiler.epscj2*ceiler.sig*ceiler.ad+pr*d2)*qb
       +4*(p2*d2*(1+e2)+ep*d4)*qp; // value \epsilon*dQ/d\epsilon
 End; // SomeVar

 { \epsilon=c/(a*(1-e^2))
   d\epsilon/da   = -\epsilon/a
   d\epsilon/de^2 = +\epsilon/(1-e^2)
   but in our case values without \epsilon }

 Procedure TDeil.DerOfEps ;
 Begin
   DerEps[1]:=-1/abnorm; { deps/da with normalisation }
   DerEps[2]:=+1/re;     { deps/d(e**2) without epsilon }
   DerEps[3]:=0;         { deps/d(delta**2) }
 End; // DerOfEps

 { Q=(1-2*\epsilon*\sigma*\delta-\epsilon^2*(1-e^2)*\delta^2)
     /(1+2*\epsilon^2*(1+e^2)*\delta^2+\epsilon^4*(1-e^2)^2*\delta^4) }

 Procedure TDeil.DerOfQ ;          // dQ/da dQ/de^2 dQ/d\delta^2
 Var
   i  : Byte ;
   d  : Extended ;
 Begin
   d:=ceiler.ad;                   // value \delta UnitCeil
   if d < 1.0e-8  then  d:=1.0e-8; // to prevent nullo for divide
                                            // dQ/d\epsilon
   For i:=1 To 2 Do  DerQ[i]:=qq*DerEps[i]; // part for /da /de^2
   DerQ[2]:=DerQ[2]+p2*d2*qb+2*(p2*d2-ep*d4/re)*qp; // the second part /de^2
   DerQ[3]:=-(((ceiler.epscj2*ceiler.sig)/d)+pr)*qb
            +2*(p2*(1+e2)+ep*d2)*qp; // partial derivation dQ/d\delta^2
 End; // DerOfQ

 { to obtain derivations
   d(2\alpha_1 \alpha_2^2 \alpha_3^2) / d(a e^2 \delta^2) }

 Procedure TDeil.DerOfAC ;
 Var
   i      : Byte ;
   q1,q2  : Extended ;
   q3,q4  : Extended ;
   qc,qd  : Extended ;
   q5,q6  : Extended ;
 Begin
   q1:=fmnorm/abnorm;    // fm/a         with normalisation
   q2:=fmnorm*abnorm*re; // fm*a*(1-e^2) with normalisation
   q3:=-q1*(-pr*rd);     // fm/a*(\epsilon^2*(1-e^2)*(1-\delta^2))
   qc:=qa*qb;            // value for Q
   q4:=2*q3*qc;          // 2*fm/a*(\epsilon^2*(1-e^2)*(1-\delta^2))*Q
   qd:=q2*rd;            // fm*a*(1-e^2)*(1-\delta^2) for \alpha_3^2
   q5:=p2*(1+e2);        // \epsilon^2*(1+e^2)
   q6:=p2-ep/re;         // \epsilon^2-\epsilon^4*(1-e^2)
   For i:=1 To 3 Do      // partial derivations with respect to
     Begin                                       // a e^2 \delta^2
       DerAC[1,i]:=q4*DerEps[i]+q3*DerQ[i];      // for 2*\alpha_1
       DerAC[2,i]:=4*q2*qc*(q5+ep)*rd*DerEps[i]  // for \alpha_2^2
                   +q2*(2*q5+ep)*rd*DerQ[i];     // the first part
       DerAC[3,i]:=qd*(4*qc*(q5+ep)*DerEps[i]    // for \alpha_3^2
                      +(1+2*q5+ep)*DerQ[i]);     // the first part
     End;                                        // plus the second part
   DerAC[1,1]:=DerAC[1,1]-a1norm/abnorm; // d2\alpha_1/da normalisation
   DerAC[1,2]:=DerAC[1,2]-q1*p2*rd*qc;   // d2\alpha_1/de^2
   DerAC[1,3]:=DerAC[1,3]-q1*pr*qc;      // d2\alpha_1/d\delta^2
   DerAC[2,1]:=DerAC[2,1]-a2norm/abnorm; // d(\alpha_2)^2/da
   DerAC[2,2]:=DerAC[2,2]+a2norm/re+2*q2*qc*rd*q6; // d(\alpha_2)^2/de^2
   DerAC[2,3]:=DerAC[2,3]-q2*qc*(2*q5+ep);  // d(\alpha_2)^2/d\delta^2
   q1:=Sqr(a3norm); // (\alpha_3)^2 with normalisation
   DerAC[3,1]:=DerAC[3,1]+q1/abnorm;        // d(\alpha_3)^2/da
   DerAC[3,2]:=DerAC[3,2]-q1/re+2*qd*qc*q6; // d(\alpha_3)^2/de^2
   DerAC[3,3]:=DerAC[3,3]-q1/rd;            // d(\alpha_3)^2/d\delta^2
 End; // DerOfAC

 { partial derivations
   for three constants of integration
   2\alpha_1 (\alpha_2)^2 (\alpha_3)^2
   with respect to a e^2 \delta^2 from simple formulae }

 procedure TDeil.ToGetDerTwo ; // with respect to a e^2 \delta^2
 begin
   ToNormal ; // to normalise with fm and r_0
   SomeVar ;  // values for usefull variables
   DerOfEps ; // d\epsilon/d(a e^2)
   DerOfQ ;   // dQ/d(a e^2 \delta^2)
   DerOfAC ;  // d(2\alpha_1 \alpha_2^2 \alpha_3^2)/d(a e^2 \delta^2)
 end; // ToGetDerTwo values to matrix DerAC[1..3,1..3]

 { d(2\alpha_1 (\alpha_2)^2 (\alpha_3)^2)/d(L G H)
   result from da1 da2 da3 to DerAction of TypeDim33 }

 procedure TDeil.ToGetDerCan ; // result to DerAction of TypeDim33
 var
   i  : Byte ;
   x  : Extended ;  // factor to normalise
   y  : Extended ;  // factor to normalise
 begin              // d(2\alpha_1 (\alpha_2)^2 (\alpha_3)^2)/d(L G H)
   ToGetDerOne ;    // result to da1 da2 da3 of TypeDim3
   x:=ceiler.rz/ceiler.fm;       // factor r_0/(f*M) for 2*|alpha_1
   y:=1.0/(ceiler.fm*ceiler.rz); // factor 1/(f*M*r_0)
   for i:=1 to 3 do // with respect to L G H
     begin                       // normalisation by factor
       DerAction[1,i]:=x*da1[i]; // d (2\alpha_1) / d(L G H)
       DerAction[2,i]:=y*da2[i]; // d(\alpha_2^2) / d(L G H)
       DerAction[3,i]:=y*da3[i]; // d(\alpha_3^2) / d(L G H)
     end;
 end; // ToGetDerCan


 { to obtain partial derivations
   from selected parameters
   a e^2 \delta^2 with respect to L G H action variables }

 procedure TDeil.ToGetDerSqr ; // d(a e^2 \delta^2)/d(L G H)
 var                           // result to DerE2[1..3,1..3]
   i,j,k  : Byte ;             // simple counts
 begin
   for i:=1 to 3 do            // in matrix DerE2
     for j:=1 to 3 do          // derivations
       begin                   // from a e^2 \delta^2
         DerE2[i,j]:=0.0;      // with respect to L G H
         for k:=1 to 3 do
           DerE2[i,j]:=DerE2[i,j]+DerACInv[i,k]*DerAction[k,j];
       end;
 end;  // ToGetDerSqr d(a e^2 \delta^2)/d(L G H)

 { to obtain partial derivations
   from selected parameters
   a e \delta with respect to L G H action variables }

 procedure TDeil.ToGetDerElm ; // d(a e \delta)/d(L G H)
 var
   j  : Byte ;       // simple counts
   e  : Extended ;   // eccentricity
   d  : Extended ;   // parameter \delta
 begin               // result to matrix DerE2
   e:=ceiler.ae;     // eccentricity value
   d:=ceiler.ad;     // parameter \delta value
   for j:=1 to 3 do  // for L G H  unnormal
     begin
       daone[j]:=ceiler.rz*DerE2[1,j]; // a value to kilometer
       if  e < 1.0e-6                  // eccentricity is too small
         then  deone[j]:=0.0           // too small to divide
         else                          // de/d(L G H) =
           deone[j]:=0.5*DerE2[2,j]/e; // [de^2/d(L G H)]/(2*e)
       if  d < 1.0e-6                  // parm \delta is too small
         then  ddone[j]:=0.0           // too small to divide
         else                          // d\delta/d(L G H) =
           ddone[j]:=0.5*DerE2[3,j]/d; // [d\delta^2/d(L G H)]/(2*e)
     end;
 end; // ToGetDerElm

 { partial derivations from  a , e , \delta
   with  respect to action variables L , G , H }

 Procedure TDeil.ToGetDerSel ; // public procedure
 Begin
   { 2\alpha_1 (\alpha_2)^2 (\alpha_3)^2 derivations
     with respect to a e^2 \delta^2 from simple formulae }
   ToGetDerTwo ; // values to matrix DerAC
   { a e^2 \delta^2  derivations by inversion
     with respect to 2\alpha_1 (\alpha_2)^2 (\alpha_3)^2 }
   ToInverseSimpleMatr(DerAC,DerACInv); // UnForFun result DerACInv
   { d(2\alpha_1 (\alpha_2)^2 (\alpha_3)^2)/d(L G H) }
   ToGetDerCan ; // result from da1 da2 da3 to DerAction of TypeDim33
   ToGetDerSqr ; // d(a e^2 \delta^2)/d(L G H) to DerE2[1..3,1..]
   ToGetDerElm ; // d(a e \delta)/d(L G H) result to d a e \delta one
 End; // ToGetDerSel result  a , e , \delta with L G H

 end.
