
 { one class
   to obtain derivations
   for eiler parameters
   with respect to eiler elements a e \delta
   to call method only after methods of TCeil class }

 unit UnitDelm ;

 interface

 uses
   UnConTyp , // types TPartDer TPartDim partal derivations
   UnitCeil ; // class with methods and variables

 type
   TDelm = class

   private

     { auxiliary partial derivations with respect to a e \delta }

     dapr,dapq    : TPartDer ;
     dpsi,dphi    : TPartDim ;
     da,db,dw     : TPartDim ;
     g1,g2,bks    : TPartDim ;
     bks2,bks4    : TPartDim ;
     bks6,bks8    : TPartDim ;
     g3,g4,g5     : TPartDim ;
     bps,bps2     : TPartDim ;
     bps3,bps4    : TPartDim ;

     { some variables }

     w1,w2,wq,ws  : Extended ;
     wr,rr,rc,rs  : Extended ;
     dfa,de2,dd2  : TPartDer ;
     doe,dod,dac  : TPartDer ;
     dun,dp2,daq  : TPartDer ;
     dq,dr,dp,dx  : TPartDer ;
     dksi1,dksi2  : TPartDer ;
     deta1,deta2  : TPartDer ;
     dd1,db1,db2  : TPartDer ;
     dd,ds,du,dv  : TPartDer ;
     dc0,dq0,dp0  : TPartDer ;
     df0,dol      : TPartDer ;

     procedure DerMults ( AmpOne , AmpTwo  : TPartDer ;   // two terms
                          var   AmpResult  : TPartDer ) ; // result term

     procedure DerPower ( pow       : Extended ;   // power value
                          one       : TPartDer ;   // term to power
                          var  res  : TPartDer ) ; // result term

     procedure FactorAm ( f       : Extended ;   // factor
                          var  a  : TPartDer ) ; // to multiply

     procedure dabba ( da , db       : TPartDim ; // two polinoms
                       var  dc       : TPartDim ; // result
                       kc , lc , mc  : Byte ) ;   // to multiply

     procedure InitiDer ; // initial derivations a e \delta \epsilon

     procedure DerForQ ; // parameter Q

     procedure DerForC ; // for three constants

     procedure DerForKsi_ax ; // for \bar e

     procedure DerForKsi_k2 ; // for k_2^2

     procedure DerForKsi_g2 ; // for \sigma_2

     procedure DerForKsi ; // \xi_1 \xi_2

     procedure DerForEta_m ;

     procedure DerForEta_s ;

     procedure DerForEta_k ;

     procedure DerForEta ; // \eta_1 \eta_2 roots

     procedure DerForSec_abc ;  // A B C

     procedure DerForSec_gkr ;

     procedure DerForSec ;      // \alpha \beta

     procedure DerForNu_init ;  // for \phi=\psi+\nu*(\psi-l)+...

     procedure DerForNu_anu ;

     procedure DerForNu_cappa ;
 
     procedure DerForNu ;        // parameter \nu result dnu

     procedure DerForMu_init ;   // \Omega~=h+\mu*(\psi-l)+...

     procedure DerForMu_phi ;

     procedure DerForMu_psi ;

     procedure DerForMu_Add ;

     procedure DerForMu ;          // parameter \mu dmu

     procedure DerForLambda_init ; // parameter \lambda

     procedure DerForLambda_bps ;

     procedure DerForLambda_psi ;

     procedure DerForLambda_psig ;

     procedure DerForLambda_phi ;

     procedure DerForLambda_phig ;

     procedure DerForLambda_add ;

     procedure DerForLambda ;      // parameter \lambda

     procedure DerForMot ;    // result to dtremot[1..3]

   public

     { partial derivations with respect to a e \delta }

     da1,da2,da3  : TPartDer ; // \alpha_1 \alpha_2^2 ...
     dab,dae,dad  : TPartDer ; // a e \delta
     dep,dag,das  : TPartDer ; // \epsilon \gamma s
     dat,dax,daz  : TPartDer ; // d \bar e e*
     dgc,dgb,dgu  : TPartDer ;
     dk1,dg1,dk2  : TPartDer ; // k_1^2 \sigma_1 k2_2
     dg2,dnu,dmu  : TPartDer ; // \sigma_2 \nu \mu
     dn0,dlambda  : TPartDer ; // n_0 \lambda
     dkf,dkp      : array [1..5] of TPartDer ; // for \phi
     dqf,dcp      : array[1..10] of TPartDer ; // for \Omega
     dff,dpp      : array[1..10] of TPartDer ; // for E

     { n_0/(1-\lambda)      angle l d(dl/dt)/d(a e \delta)
       n_0*\nu/(1-\lambda)  angle g d(dg/dt)/d(a e \delta)
       n_0*\mu/(1-\lambda)  angle h d(dh/dt)/d(a e \delta) }

     dval         : TPartDer ; // d(dl/dt)/d(a e \delta)
     dvag         : TPartDer ; // d(dg/dt)/d(a e \delta)
     dvah         : TPartDer ; // d(dh/dt)/d(a e \delta)

     procedure DerEilParm ; // eiler parameters with partial derivations

           end; // class TDelm

 var
   delmer  : TDelm ; // new class TDelm

 implementation

 { DerMults procedure is only for multiplication
                      two terms in form of the massive with
                      partial derivations :
   x,dx/da,dx/de,dx/d(\delta) - correspond for parametr x,
   y,dy/da,dy/de,dy/d(\delta) - correspond for parametr y,
   we have
          c            = x*y ,
          dc/da        = x*dy/da+dx/da*y ,
          dc/de        = x*dy/de+dx/de*y ,
          dc/d(\delta) = x*dy/d(\delta)+dx/d(\delta)*y }

 procedure TDelm.DerMults ( AmpOne , AmpTwo  : TPartDer ;   // two terms
                            var   AmpResult  : TPartDer ) ; // result
 begin
   AmpResult[1]:=AmpOne[1]*AmpTwo[1];                     // c=x*y
   AmpResult[2]:=AmpOne[1]*AmpTwo[2]+AmpOne[2]*AmpTwo[1]; // x*dy/da+dx/da*y
   AmpResult[3]:=AmpOne[1]*AmpTwo[3]+AmpOne[3]*AmpTwo[1]; // x*dy/de+dx/de*y
   AmpResult[4]:=AmpOne[1]*AmpTwo[4]+AmpOne[4]*AmpTwo[1]; // x*dy/dd+dx/dd*y
 end;


 { DerPower  procedure
   is only for raising to power one term
   in form of the array with partial derivations :
   y dy/da dy/de dy/d(\delta)  values in one [1..4]
   we have
   z=(y in power x)
   dz/da=x*(y in power (x-1))*dy/da
   dz/de=x*(y in power (x-1))*dy/de
   dz/dd=x*(y in power (x-1))*dy/dd }

 procedure TDelm.DerPower ( pow       : Extended ;   // power value
                            one       : TPartDer ;   // term
                            var  res  : TPartDer ) ; // result
 Var
   b,r,y,z  : Extended ;
 begin
   y:=one[1];               // value of the term
   if  ( Abs(y) < 1.0e-13 )
     then                   // term is too small
       res:=one             // without raising to power
     else
       begin                // term to power
         r:=1/y;                 // y^(-1)
         if  ( Abs(pow+1) < 1.0e-3 )
           then
             b:=r // pow=-1 x=1/y
           else
             if  ( Abs(pow-2) < 1.0e-3 )
               then
                 b:=y*y // pow=+2 x=y^2
               else
                 if  ( Abs(pow+2) < 1.0e-3 )
                   then
                     b:=r*r // pow=-2 x=1/y^2
                   else
                     if  ( Abs(pow-0.5) < 1.0e-3 )
                       then
                         b:=Sqrt(y) // pow=+1/2 x=\sqrt(y)
                       else
                         if  ( Abs(pow+0.5) < 1.0e-3 )
                           then
                              b:=Sqrt(r) // pow=-1/2 x=1/\sqrt(y)
                           else
                             if  ( Abs(pow-1.5) < 1.0e-3 )
                               then
                                 begin         // pow=+3/2
                                   z:=Sqrt(y); // y^(1/2)
                                   b:=z*z*z;   // x=y^(3/2)
                                 end
                               else   // may be error if y<0
                                 b:=Exp(pow*Ln(Abs(y))); // y^(pow)
         z:=pow*b*r;       // pow*(y^(pow-1))
         res[1]:=b;        // y^(pow)
         res[2]:=z*one[2]; // pow*(y^(pow-1))*dy/da
         res[3]:=z*one[3]; // pow*(y^(pow-1))*dy/de
         res[4]:=z*one[4]; // pow*(y^(pow-1))*dy/dd
       end;
 end;

 { to multiply to our simple term to factor }

 procedure TDelm.FactorAm ( f       : Extended ;   // factor
                            var  a  : TPartDer ) ; // to multiply
 var
   i  : Byte ; // simple count 
 begin                             // for our array
   for i:=1 to 4 do  a[i]:=f*a[i]; // for all elements
 end;

 { to multiple two polinoms with the derivations }

 procedure TDelm.dabba ( da , db       : TPartDim ;
                         var  dc       : TPartDim ;
                         kc , lc , mc  : Byte ) ;
 Var
   k   : Byte ;
   ic  : Byte ;
   jc  : Byte ;
   nc  : Byte ;
   kk  : Byte ;
   dd  : TPartDer ;
 begin
   for nc:=1 to 11 do
     for k:=1 to 4 do  dc[nc][k]:=0.0; { nullo }
   for nc:=1 to mc do
     begin
       ic:=0;
       If  nc < kc
         then
           kk:=nc
         else
           kk:=kc;
       while  ic < kk  do
         begin
           ic:=ic+1;
           jc:=nc-ic+1;
           If  jc <= lc
             then
               begin
                 DerMults(da[ic],db[jc],dd);
                 for k:=1 to 4 do
                   dc[nc][k]:=dc[nc][k]+dd[k];
               end;
         end;
     end;
 end;

 { simple initial values for variables
   array ceiler.c[1..90] from class TCeil UnitCeil }

 procedure TDelm.InitiDer ;
 var
   i,j  : Byte ;
 begin
   { by using class TCeil }
   rc:=ceiler.c[3]*ceiler.c[3]; { c**2 }
   rs:=ceiler.c[3]*ceiler.c[4]; { c*sigma }
   rr:=2*ceiler.c[1]*rs;        { 2*fM*c*sigma }
   { initial value for power }
   w1:=-1; { for division }
   w2:=+2; { for Sqr }
   wr:=+0.5; { for Sqrt }
   ws:=+1.5; { for Sqrt(x**3) }
   { initial to arrays }
   for i:=1 to 4 do
     begin
       dol[i]:=0.0; { for nullo }
       dun[i]:=0.0; { for unit }
       dab[i]:=0.0; // for a
       dae[i]:=0.0; // for e
       dad[i]:=0.0; // for \delta
     end;
   for j:=1 to 11 do
     begin          // for array
       da[j]:=dol;  // nullo
       db[j]:=dol;  // values
       dw[j]:=dol;  // to array
     end;
   { the start partial derivatons }
   dun[1]:=1.0;          // unit 
   dab[1]:=ceiler.c[8];  // a
   dab[2]:=1.0;          // da/da = 1
   dae[1]:=ceiler.c[9];  // e
   dae[3]:=1.0;          // de/de = 1 }
   dad[1]:=ceiler.c[38]; // \delta
   dad[4]:=1.0;          // d(\delta)/d(\delta) = 1 
   { some values to power }
   DerPower(w2,dae,de2); { e^2 }
   DerPower(w2,dad,dd2); { \delta^2 }
   for i:=1 to 4 do
     begin
       doe[i]:=dun[i]-de2[i]; { 1-e^2 }
       dod[i]:=dun[i]-dd2[i]; { 1-\delta^2 }
     end;
   DerMults(dab,doe,dq);      { a*(1-e*e) }
   DerPower(w1,dq,dep);       { 1/(a*(1-e*e)) }
   FactorAm(ceiler.c[3],dep); { \epsilon = c/(a*(1-e*e)) }
   DerPower(w2,dep,dp2);      { \epsilon^2 }
 end;

 { to obtain derivations for parameter Q in daq }

 procedure TDelm.DerForQ ; // parameter Q
 var
   i  : Byte ;
 begin
   wq:=2.0*ceiler.c[4];  // 2*\sigma
   DerMults(dep,dad,dq); { epsilon*delta }
   DerMults(dp2,dd2,dp); { epsilon**2*delta**2 }
   DerMults(dp,doe,dr);  { epsilon**2*delta**2*(1-e**2) }
   DerPower(w2,dr,dx);   { in sqr }
   for i:=1 to 4 do
     begin
       dq[i]:=dun[i]-wq*dq[i]-dr[i];
       dr[i]:=dun[i]+2*dp[i]+dx[i];
     end;
   DerMults(dp,de2,dx); { epsilon**2*delta**2*e**2) }
   for i:=1 to 4 do
     dr[i]:=dr[i]+2*dx[i];
   DerPower(w1,dr,dx);  { to power (-1) }
   DerMults(dq,dx,daq); { value for Q }
 end;

 { to obtain derivations
   for 2*alpha1 alpha2**2 alpha3**2 with respect to a e delta }

 procedure TDelm.DerForC ; // for three constants
 var
   i  : Byte ; // simple count
 begin
   DerMults(dp2,doe,dr); { epsilon**2*(1-e**2) }
   DerMults(dr,dod,dp);  { eps**2*(1-e**2)*(1-delta**2) }
   DerMults(dp,daq,dq);  { the previous * Q }
   for i:=1 to 4 do
     dq[i]:=ceiler.c[1]*(dq[i]-dun[i]); // f*M*...
   DerPower(w1,dab,dfa); { 1/a }
   DerMults(dfa,dq,da1); // 2*alpha1
   DerPower(w2,dr,dx);   { Sqr(epsilon**2*(1-e**2)) }
   DerMults(dp2,de2,dr); { epsilon**2*e**2 }
   for i:=1 to 4 do
     dp[i]:=2*(dp2[i]+dr[i])+dx[i];
   DerMults(dp,daq,dq); { small q' }
   DerMults(dab,doe,dfa); { a*(1-e**2) }
   DerMults(dod,dq,dx); { (1-delta**2)*q' }
   for i:=1 to 4 do
     dr[i]:=ceiler.c[1]*(dun[i]+dx[i]);  // f*M*...
   DerMults(dfa,dr,da2); // alpha2**2 plus but a2 = -\alpha_2^2
   for i:=1 to 4 do
     dr[i]:=ceiler.c[1]*(daq[i]+dq[i]); { fm*(Q+q') }
   DerMults(dfa,dod,dx);
   DerMults(dx,dr,da3);  // alpha3**2
 end;

 procedure TDelm.DerForKsi_ax ;
 var
   i  : Byte ;
 begin
   for i:=1 to 4 do
     begin
       dq[i]:=dksi2[i]-dksi1[i]; { ksi2-ksi1 }
       dp[i]:=db1[i]-db2[i]; { n'-n" }
       dr[i]:=db1[i]+db2[i]; { n'+n" }
     end;
   DerPower(w1,dr,dx); { 1/(n'+n") }
   DerMults(dp,dx,dax); { ax=(n'-n")/(n'+n") }
 end;

 procedure TDelm.DerForKsi_k2 ; { for k2**2 }
 var
   i  : Byte ;
 begin
   DerPower(w2,dq,ds); { (ksi2-ksi1)**2 }
   DerPower(w2,dp,dx); { (n'-n")**2 }
   for i:=1 to 4 do
     dd[i]:=0.25*(ds[i]-dx[i]); { numenator }
   DerMults(db1,db2,dp); { n'*n" }
   DerPower(w1,dp,dq); { 1/(n'*n") denominator }
   DerMults(dd,dq,du); { pre k22 }
   for i:=1 to 4 do  dv[i]:=du[i]-dun[i]; { -(1-k22) }
   DerPower(w1,dv,dq); { -1/(1-k22) }
   DerMults(du,dq,dk2); { k2^**2=-k22/(1-k22) or -c[19]/(1-c[19]) }
 end;

 procedure TDelm.DerForKsi_g2 ; { for sigma2 }
 var
   i  : Byte ;
 begin
   for i:=1 to 4 do  dv[i]:=-dv[i]; { 1-k22 }
   DerMults(dp,dv,dr); { n'*n"*(1-k22) }
   DerMults(da1,dr,dq); { 2*alpha1*the same }
   for i:=1 to 4 do  dx[i]:=-dq[i]; { minus the same }
   DerPower(wr,dx,dg2); { sigma2kr c[17]*Sqrt(1-c[19]) }
 end;

 { derivations for roots ksi1 ksi2 }

 procedure TDelm.DerForKsi ; // \xi_1 \xi_2
 var
   i : Byte ;
 begin
   DerMults(dab,dae,dr); // a*e
   for i:=1 to 4 do
     begin
       dksi1[i]:=dab[i]-dr[i]; { ksi1 = a*(1-e) }
       dksi2[i]:=dab[i]+dr[i]; { ksi2 = a*(1+e) }
     end;
   DerPower(w1,da1,dfa);  { 1/(2*alpha1); }
   DerPower(w2,dksi1,du); { ksi1**2 }
   DerPower(w2,dksi2,dv); { ksi2**2 }
   DerMults(dp2,doe,dr);  { epsilon**2*(1-e**2) }
   DerMults(dr,dfa,dd);   { epsilon**2*(1-e**2)/(2*alpha1) }
   DerMults(dr,dod,dq);   { eps**2*(1-e**2)*(1-delta**2) }
   DerMults(dq,daq,ds);   { the same * Q }
   { futher the some parameters associated with ksi - ax ak2 ag2 }
   DerMults(dfa,ds,dp);
   for i:=1 to 4 do
     begin
       dp[i]:=-2*ceiler.c[1]*dp[i]; { 2*p }
       dx[i]:=da3[i]-da2[i]; // \alpha_3^2-\alpha_2^2 with derivations
     end;
   DerMults(dd,dx,dq); { p**2+q**2 }
   dapr:=dp; { 2*p }
   dapq:=dq; { p**2+q**2 }
   DerMults(dp,dksi1,ds); { 2*p*ksi1 }
   DerMults(dp,dksi2,dx); { 2*p*ksi2 }
   for i:=1 to 4 do
     begin
       dx[i]:=dv[i]-dx[i]+dq[i]; { n'**2 }
       ds[i]:=du[i]-ds[i]+dq[i]; { n"**2 }
     end;
   DerPower(wr,dx,db1); { n'=Sqrt(n'**2) }
   DerPower(wr,ds,db2); { n"=Sqrt(n"**2) }
   DerForKsi_ax;
   DerForKsi_k2;
   DerForKsi_g2;
 end;

 procedure TDelm.DerForEta_m ;
 var
   i  : Byte ;
 begin
   for i:=1 to 4 do
     begin
       dd[i]:=deta1[i]+deta2[i]; { eta1+eta2 }
       dp[i]:=rr*dfa[i]; { 2*fM*c*sigma/(2*alpha1) }
     end;
   DerMults(dp,dd,dq); { (2*fM*c*sigma/(2*alpha1))*(eta1+eta2) }
   DerMults(deta1,deta2,ds); { eta1*eta2 }
   DerMults(da2,dfa,dr); { alpha2**2/(2*alpha1) }
   for i:=1 to 4 do
     begin
       dp[i]:=+dp[i]-rc*dd[i]; { 2*p' }
       dq[i]:=-dr[i]+rc*(dun[i]-dd1[i]-ds[i]-dd2[i])+dq[i]; { q'**2-p'**2 }
     end;
   DerMults(dp,deta1,dr); { 2*p'*eta1 }
   DerMults(dp,deta2,ds); { 2*p'*eta2 }
   for i:=1 to 4 do
     begin
       du[i]:=dq[i]+ds[i]-rc*dd2[i]; { m'**2 }
       dv[i]:=dq[i]+dr[i]-rc*dd1[i]; { m"**2 }
     end;
   DerPower(wr,du,db1); { m'=Sqrt(m'**2) }
   DerPower(wr,dv,db2); { m"=Sqrt(m"**2) }
 end;

 procedure TDelm.DerForEta_s ;
 var
   i  : Byte ;
 begin
   for i:=1 to 4 do  dx[i]:=db1[i]+db2[i]; { m'+m" }
   DerPower(w1,dx,dr); { 1/(m'+m") }
   DerMults(db1,deta1,du); { m'*eta1 }
   DerMults(db2,deta2,dv); { m"*eta2 }
   for i:=1 to 4 do
     begin
       dq[i]:=du[i]+dv[i]; { m'*eta1+m"*eta2 }
       ds[i]:=dv[i]-du[i]; { m"*eta2-m'*eta1 }
       dd[i]:=db2[i]-db1[i]; { m"-m' }
     end;
   DerMults(dq,dr,dag); { ag - gamma c[13] }
   DerMults(ds,dr,das); { as c[10] }
   DerMults(dd,dr,dat); { at c[14] }
 end;

 procedure TDelm.DerForEta_k ;
 var
   i  : Byte ;
 begin
   DerMults(db1,db2,dx); { m'*m" }
   DerPower(w1,dx,dr); { 1/(m'*m") }
   DerPower(w2,dd,du); { (m"-m')**2 }
   for i:=1 to 4 do  dq[i]:=deta2[i]-deta1[i];
   DerPower(w2,dq,dp); { (et2-eta1)**2 }
   for i:=1 to 4 do
     ds[i]:=0.25*(rc*dp[i]+du[i]); { 1/4*(c**2*(eta2-eta1)**2+(m"-m')**2 }
   DerMults(ds,dr,dq); { k**2 }
   for i:=1 to 4 do  du[i]:=dun[i]+dq[i]; { 1+k**2 }
   DerPower(w1,du,dv); { 1/(1+k**2) }
   DerMults(dq,dv,dk1); { k1**2=k**2/(1+k**2) c[18] }
   DerMults(dx,du,dr); { m'*m"*(1+k**2) }
   DerMults(da1,dr,ds); { 2*alpha1*m'*m"*(1+k**2) }
   for i:=1 to 4 do  ds[i]:=-ds[i]; { minus the same - sigma1**2 }
   DerPower(wr,ds,dg1); { sigma1=Sqrt(sigma1**2) c[16] }
 end;

 { derivations for roots eta1 eta2 by iteration }

 procedure TDelm.DerForEta ; // \eta_1 \eta_2 roots
 var
   i,itr  : Byte ;
 begin
   for i:=1 to 4 do
     begin
       deta2[i]:=dad[i]; { eta2 = delta }
       dr[i]:=rr*(dun[i]-dd2[i]); { numerator 2*fM*c*sigma*(1-delta**2) }
       dq[i]:=rc*da1[i]; { 2*alpha1*c**2 }
       dp[i]:=dq[i]-da2[i]; { 2*alpha1*c**2-alpha2**2 }
       dd[i]:=0.0; { init nul for ddelta - value of the first order }
       deta1[i]:=-deta2[i]+dd[i]; { init for eta1 }
     end;
   for itr:=1 to 5 do
     begin
       DerPower(w2,deta1,dd1); { eta1**2); }
       for i:=1 to 4 do
         dx[i]:=dd1[i]+dd2[i]; { eta1**2+eta2**2 }
       DerMults(dq,dx,du); { 2*alpha1*c**2*(eta1**2+eta2**2) }
       for i:=1 to 4 do
         ds[i]:=dp[i]+rr*deta1[i]-du[i]; { denominator }
       DerPower(w1,ds,dx); { one over denominator }
       DerMults(dr,dx,dd); { ddelta - the next iteration }
       for i:=1 to 4 do
         deta1[i]:=-deta2[i]+dd[i]; { delta1=-delta2+ddelta }
     end;
   DerForEta_m ;
   DerForEta_s ;
   DerForEta_k ;
 end;

 procedure TDelm.DerForSec_abc ;
 var
   i  : Byte ;
 begin
   DerPower(w2,dag,dq); { gamma**2 }
   DerPower(w2,dat,dp); { d**2 }
   DerPower(w2,das,ds); { s**2 }
   DerMults(das,dag,dr); { s*gamma }
   for i:=1 to 4 do
     begin
       du[i]:=dun[i]-dq[i]; { A=1-gamma**2 }
       db[1][i]:=du[i];
       dv[i]:=2*(dr[i]-dat[i]); { B=2*(s*gamma-d) }
        db[2][i]:=dv[i];
       dx[i]:=dp[i]-ds[i]; { C=d**2-s**2 }
       db[3][i]:=dx[i];
       db1[i]:=du[i]-dv[i]+dx[i]; { A-B+C }
       db2[i]:=du[i]+dv[i]+dx[i]; { A+B+C }
     end;
 end;

 procedure TDelm.DerForSec_gkr ;
 Var
   i  : Byte ;
   r  : Extended ;
 begin
   DerPower(wr,db1,dr); { Sqrt(A-B+C) }
   DerPower(wr,db2,ds); { Sqrt(A+B+C) }
   for i:=1 to 4 do
     begin
       dq[i]:=dr[i]+ds[i]; { Sqrt(A-B+C)+Sqrt(A+B+C) }
       dp[i]:=dr[i]-ds[i]; { Sqrt(A-B+C)-Sqrt{A+B+C) }
     end;
   DerPower(w2,dq,dd); { (Sqrt(A-B+C)+Sqrt(A+B+C))**2 }
   if  ceiler.c[7] < 0  // angle may be > 90 degree
     then  r:=-0.5      // signum(cos(i) may be negative
     else  r:=+0.5;     // signum(alpha3) 
   for i:=1 to 4 do
     begin
       dq[i]:=r*dq[i]; { Sqrt plus or minus alpha/Sqrt(gamma^) }
       dp[i]:=r*dp[i]; { 0.5*signum(alpha3)  beta/Sqrt(gamma^) }
       ds[i]:=0.25*(dd[i]-4*dx[i]); { 1/gamma^ = (Sum(Sqrt)-4*C)/4 }
     end;
   DerPower(wr,ds,dr); { 1/Sqrt(gamma^) }
   DerPower(w1,dr,dx); { Sqrt(gamma^) }
   DerMults(dx,dq,dac); { alpha parameter c[11]}
   DerMults(dx,dp,daq); { beta  parameter c[15]}
   dgc:=dq; { alpha/Sqrt(gamma^) }
   dgb:=dp; { beta/Sqrt(gamma^) }
   dgu:=dr; { 1/Sqrt(gamma^) }
 end;

 { derivations for n0 e* alpha beta }

 procedure TDelm.DerForSec ;
 var
   i  : Byte ;
 begin
   for i:=1 to 4 do  dr[i]:=-da1[i]; { -2*alpha1 }
   DerPower(ws,dr,dq); { Sqrt((-2*alpha1)**3) }
   DerMults(dr,dab,ds); { (-2*alpha1)*a }
   DerMults(ds,dae,dx); { (-2*alpha1)*a*e }
   for i:=1 to 4 do
     begin
       dn0[i]:=dq[i]/ceiler.c[1]; { n0 c[27] }
       daz[i]:=dx[i]/ceiler.c[1]; { e* c[20] }
     end;
   DerForSec_abc ;
   DerForSec_gkr ;
 end;

 { formulae \pfi = \psi + \nu*(\psi-l) + ... }

 procedure TDelm.DerForNu_init ;
 var
   i,j,k  : Byte ;
 begin
   for i:=1 to 4 do
     begin { initial }
       dr[i]:=dk1[i]; { phi }
       dp[i]:=dk2[i]; { psi}
       db1[i]:=dun[i]; { for K(k1) phi }
       db2[i]:=dun[i]; { for K(k2) psi }
       dphi[1][i]:=dun[i]; { the first term in the expanding }
       dpsi[1][i]:=dun[i]; { 1/Sqrt(1-x)=1+1/2*x+3/8*x**2+15/48*x**3+... }
       for j:=2 to 11 do
         begin
           dphi[j][i]:=0.0; { initial }
           dpsi[j][i]:=0.0; { nullo }
         end;
     end;
   k:=1;
   j:=3;
   while  j < 11  do
     begin
       k:=k+1;
       for i:=1 to 4 do
         begin
           dphi[j][i]:=ceiler.tt[k]*dr[i]; { the next j term in  1/Sqrt(1-x) = }
           dpsi[j][i]:=ceiler.tt[k]*dp[i]; { = 1+1/2*x+3/8*x**2+15/48*x**3+... }
         end;
       DerMults(dk1,dr,du); { ak12**(j-1) }
       DerMults(dk2,dp,dv); { ak22**(j-1) }
       for i:=1 to 4 do
         begin
           dr[i]:=du[i];
           dp[i]:=dv[i];
           db1[i]:=db1[i]+ceiler.tt[k]*dphi[j][i];
           db2[i]:=db2[i]+ceiler.tt[k]*dpsi[j][i];
         end;
       j:=j+2;
     end;
 end;

 { parametr nu in dnu[i] }

 procedure TDelm.DerForNu_anu ;
 var
   i  : Byte ;
 begin
   { in db1[] is full elliptic integral K(k1)/(Pi/2) }
   DerMults(dg2,db1,dx); { sigma2^*(K(k1)/(Pi/2)) }
   DerPower(w1,dx,ds); { 1/(sigma2^*(K(k1)/(Pi/2))) }
   { in db2[] is full elliptic integral K(k2^)/(Pi/2) }
   DerMults(dg1,db2,dx); { sigma1*(K(k2^)/(Pi/2)) }
   DerMults(dx,ds,dd); { 1+nu }
   for i:=1 to 4 do  dnu[i]:=dd[i]-dun[i]; { for nu c[28] }
   DerMults(dg1,ds,dq); { sigma1/(sigma2^*(K(k1)/(Pi/2))) }
   DerPower(w1,db1,dx); { (Pi/2)/(K(k1) coefficient }
 end;

 { for coefficients cappa in the formulae phi=psi+g+... }

 procedure TDelm.DerForNu_cappa ;
 Var
   i,j,k  : Byte ;
   ii  : Byte ;
   ru  : Extended ;
 begin
   for k:=1 to 5 do
     begin
       ii:=2*k;
       for i:=1 to 4 do
         begin { initial nullo }
           dr[i]:=0.0; { phi }
           dp[i]:=0.0; { psi }
         end;
       j:=ii;
       while  j <= 10  do
         begin
           ru:=ceiler.uu[ii][j];
           for i:=1 to 4 do
             begin
               dr[i]:=dr[i]+ru*dphi[j+1][i]; { phi }
               dp[i]:=dp[i]+ru*dpsi[j+1][i]; { psi }
             end;
           j:=j+2;
         end;
       DerMults(dx,dr,du); { cappa^ for phi }
       DerMults(dq,dp,dv); { cappa  for psi }
       for i:=1 to 4 do
         begin
           dkf[k][i]:=-ceiler.td[ii]*du[i]; { c[41] c[42] }
           dkp[k][i]:=+ceiler.td[ii]*dv[i]; { c[46] c[47] }
         end;
     end;
 end;

 { derivations for the parameters in the formula
   phi=psi+g+nu*(psi-l)+Sum(cappa2j*Sin(2*j*psi)+cappa^2j*sin(2*j*phi)) }

 procedure TDelm.DerForNu ;
 begin
   DerForNu_init ;
   DerForNu_anu ;
   DerForNu_cappa ;
 end;

 procedure TDelm.DerForMu_init ;
 Var
   i,j,k,m,ii,jj,ik,il  : Byte ;
 begin
   m:=3;
   DerPower(w2,dat,dr); { d*d }
   for j:=m to 11 do
     begin
       DerMults(dat,dphi[j-1],dp);
       DerMults(dr,dphi[j-2],dq);
       { (1-2*d*Cos(phi)+d**2*Cos(phi)**2)/Sqrt(1-k1**2*Cos(phi)**2) }
       for i:=1 to 4 do
         da[j][i]:=dphi[j][i]-2*dp[i]+dq[i];
     end;
   DerPower(w1,db[3],dx); { 1/C or 1/b[m] }
   for ii:=m to 11 do
     begin
       ik:=11-ii+m;
       il:=ik-m+1;
       DerMults(da[ik],dx,ds); { a[i]/b[m] }
       dw[il]:=ds;
       k:=ik;
       for jj:=1 to m do
         begin
           j:=m-jj+1;
           DerMults(db[j],ds,dr);
           for i:=1 to 4 do
             da[k][i]:=da[k][i]-dr[i];
           k:=k-1;
         end;
     end;
   DerPower(wr,da3,dd); { in da3 a3**2 but in dd constant a3 }
   if  ceiler.c[7] < 0
     then { Sqrt(x**2) = +- x }
       for i:=1 to 4 do  dd[i]:=-dd[i];
   for j:=1 to 11 do
     begin
       bks[j]:=dol;
       bks2[j]:=dol;
     end;
 end;

 { for parameters associated with the angle phi - beta0 beta1 beta2 }

 procedure TDelm.DerForMu_phi ;
 Var
   i,j,k,ij  : Byte ;
 begin
   DerPower(w1,dg1,dr); { 1/sigma1 }
   DerMults(dd,dr,dp); { a3/sigma1 }
   dq:=dol; { initial nullo for beta0prime c[29] }
   k:=0;
   j:=1;
   while  j <= 9  do
     begin
       k:=k+1;
       for i:=1 to 4 do
         dq[i]:=dq[i]+ceiler.tt[k]*dw[j][i];
       j:=j+2;
     end;
   DerMults(dp,dq,dq0); { beta0prime - c[29] }
   { for beta1prime beta2prime dqf[1][i] dqf[2][i] - c[51] c[52] }
   for k:=1 to 8 do
     begin
       dx:=dol;
       j:=k;
       while  j <= 8  do
         begin
           ij:=j+1;
           for i:=1 to 4 do
             dx[i]:=dx[i]+ceiler.uu[k][j]*dw[ij][i];
           j:=j+2;
         end;
       DerMults(dp,dx,ds);
       for i:=1 to 4 do
         dqf[k][i]:=ceiler.td[k]*ds[i];
     end;
 end;

 { the parameters for the angle psi
   alpha0 alpha1 alpha2 alpha3 alpha4 all prime }

 procedure TDelm.DerForMu_psi ;
 Var
   i,j,k,ij  : Byte ;
 begin
   DerMults(dae,dax,dr); { e*e~ }
   for i:=1 to 4 do
     begin
       dr[i]:=dun[i]-dr[i]; { 1-e*e~ }
       dp[i]:=dae[i]-dax[i]; { -(e~-e) }
     end;
   DerPower(w1,dr,dq); { 1/(1-e*e~) }
   DerMults(dp,dq,ds); { -(e~-e)/(1-e*e~) }
   for k:=1 to 11 do
     begin
       g1[k]:=dol;
       g2[k]:=dol;
     end;
   g1[1]:=dq; { 1/(1-e*e~) }
   DerMults(dax,dq,g1[2]); { e~/(1-e*e~) }
   dr:=dun;
   for k:=1 to 6 do
     begin
       g2[k]:=dr;
       DerMults(ds,dr,dx);
       dr:=dx;
     end;
   dabba(g1,g2,bks,2,6,7);
   dabba(bks,bks,bks2,7,7,8);
   DerMults(dab,dab,dr); { a**2 }
   DerPower(w1,dr,dp); {1/a**2 }
   for i:=1 to 4 do  dq[i]:=-rc*dp[i]; { -(c/a)**2 }
   DerPower(w1,dg2,dx); { 1/sigma2^ }
   DerMults(dd,dq,du);
   DerMults(du,dx,dv); { -alpha3*(c/a)**2/sigma2^ }
   du:=dun;
   for k:=1 to 11 do
     begin { initial }
       bks8[k]:=bks2[k];
       bks4[k]:=bks2[k];
     end;
   j:=2;
   while  j < 10  do
     begin
       j:=j+2;
       DerMults(du,dq,dx);
       du:=dx; { (-(c/a)**2)**(j/2) }
       dabba(bks2,bks8,bks6,8,11,11);
       for k:=1 to 11 do
         begin
           DerMults(du,bks6[k],dx);
           for i:=1 to 4 do
             begin
               bks4[k][i]:=bks4[k][i]+dx[i];
               bks8[k][i]:=bks6[k][i];
             end;
         end;
     end;
   for k:=1 to 11 do
     begin
       DerMults(dv,bks4[k],du);
       g1[k]:=du;
     end;
   dabba(g1,dpsi,g3,11,11,11);
   { for alpha0prime c[31] }
   dc0:=dol;
   k:=0;
   j:=1;
   while  j <= 11  do
     begin
       k:=k+1;
       for i:=1 to 4 do
         dc0[i]:=dc0[i]+ceiler.tt[k]*g3[j][i];
       j:=j+2;
     end;
   { for alpha1prime alpha2prime c[61] c[62] }
   for k:=1 to 10 do
     begin
       dr:=dol;
       j:=k;
       while  j <= 10  do
         begin
           ij:=j+1;
           for i:=1 to 4 do
             dr[i]:=dr[i]+ceiler.uu[k][j]*g3[ij][i];
           j:=j+2;
         end;
       for i:=1 to 4 do
         dcp[k][i]:=ceiler.td[k]*dr[i];
     end;
 end;

 procedure TDelm.DerForMu_Add ;
 var
   i,j,k  : Byte ;
 begin
   k:=0;
   j:=2;
   while  j <= 8  do
     begin
       k:=k+1;
       DerMults(dq0,dkf[k],du);
       DerMults(dq0,dkp[k],dv);
       for i:=1 to 4 do
         begin
           dqf[j][i]:=dqf[j][i]+du[i];
           dcp[j][i]:=dcp[j][i]+dv[i];
         end;
       j:=j+2;
     end;
 end;

 { derivations for the parameters in the formula
   Omega~=h+mu*(psi-l)+Sum(alphaj*Sin(j*psi)+betaj*sin(j*phi)) }

 procedure TDelm.DerForMu ;
 var
   i  : Byte ;
 begin
   DerForMu_init ;
   DerForMu_phi ;
   DerForMu_psi ;
   DerForMu_Add ;
   DerMults(dnu,dq0,ds); { nu*beta0prime }
   for i:=1 to 4 do
     dmu[i]:=dc0[i]+dq0[i]+ds[i]; { mu c[22] }
 end;

 procedure TDelm.DerForLambda_init ;
 Var
   i,j,k  : Byte ;
 begin
   for j:=1 to 11 do
     begin
       bps[j]:=dol;
       bps2[j]:=dol;
     end;
   DerPower(w1,dab,dr); { 1/a }
   DerMults(dr,dr,dp); { 1/a**2 }
   DerMults(dapr,dr,bps[1]); { 2*p/a }
   DerMults(dapq,dp,db2); { (p**2+q**2)/a**2 }
   for k:=1 to 11 do
     begin
       DerMults(db2,bks[k],ds);
       for i:=1 to 4 do
         bps[k][i]:=bps[k][i]-ds[i];
     end;
   dabba(bps,bps,bps2,7,7,8);
   for k:=1 to 11 do
     for i:=1 to 4 do
       bps4[k][i]:=ceiler.t2*bps2[k][i];
 end;

 procedure TDelm.DerForLambda_bps ;
 Var
   i,j,k,ii  : Byte ;
 begin
   dabba(bks,bps,g3,7,7,11);
   dabba(bps,bps2,bps3,7,8,9);
   dabba(bks,bps3,g4,7,9,11);
   for k:=1 to 11 do
     for i:=1 to 4 do
       bps4[k][i]:=bps4[k][i]+ceiler.t3*g4[k][i];
   ii:=4;
   j:=6;
   while  j < 10  do
     begin
       j:=j+2;
       ii:=ii+1;
       dabba(g3,g4,g5,11,11,11);
       for k:=1 to 11 do
         for i:=1 to 4 do
           begin
             g4[k][i]:=g5[k][i];
             bps4[k][i]:=bps4[k][i]+ceiler.tt[ii]*g5[k][i];
           end;
     end;
   for i:=1 to 4 do
     bps4[1][i]:=bps4[1][i]-ceiler.t1*db2[i];
 end;

 procedure TDelm.DerForLambda_psi ;
 var
   i,k  : Byte ;
 begin
   DerMults(dax,dax,du); { e^**2 }
   for i:=1 to 4 do
     du[i]:=dun[i]-du[i]; { 1-e^**2 }
   DerPower(wr,du,dv); { Sqrt(1-e^**2) }
   for i:=1 to 4 do  dr[i]:=-da1[i]/ceiler.c[1]; { -2*alpha1/fm }
   DerMults(dr,dab,ds); { (-2*alpha1)*a/fm }
   DerMults(ds,dv,dx); { (-2*alpha1)*a*Sqrt(1-e^**2) }
   DerMults(dae,dax,dr); { e*e~ }
   for i:=1 to 4 do
     dr[i]:=dun[i]-dr[i]; { 1-e*e~ }
   DerPower(w1,dr,dq); { 1/(1-e*e~) }
   DerMults(dx,dq,dp); { ((-2*alpha1)/fm)*a*Sqrt(1-e^**2)/(1-e*e^) }
   dabba(g2,bps4,da,6,11,11);
   for k:=1 to 11 do
     begin
       DerMults(dp,da[k],dx);
       da[k]:=dx;
     end;
 end;

 procedure TDelm.DerForLambda_psig ;
 Var
   i,j,k,ij  : Byte ;
 begin
   k:=0;
   j:=1;
   dp0:=dol; { gamma0 }
   while  j <= 11  do
     begin
       k:=k+1;
       for i:=1 to 4 do
         dp0[i]:=dp0[i]+ceiler.tt[k]*da[j][i];
       j:=j+2;
     end;
   for k:=1 to 10 do
     begin { to obtain gammaJ ]}
       dr:=dol;
       j:=k;
       while  j <= 10  do
         begin
           ij:=j+1;
           for i:=1 to 4 do
             dr[i]:=dr[i]+ceiler.uu[k][j]*da[ij][i];
           j:=j+2;
         end;
       for i:=1 to 4 do
         dpp[k][i]:=ceiler.td[k]*dr[i]; { gammaJ }
     end;
 end;

 procedure TDelm.DerForLambda_phi ;
 var
   i,k  : Byte ;
 begin
   DerPower(w1,dg1,du); { 1/sigma1 }
   DerMults(dn0,du,dv); { n0/sigma1 }
   for i:=1 to 4 do  dv[i]:=rc*dv[i]; { c**2*n0/sigma1 }
   DerPower(w2,dag,dr); { gamma**2 }
   DerPower(w2,das,ds); { s**2  terms for  (-s*Cos(phi~)+gamma)**2 }
   DerMults(das,dag,dp); { s*gamma }
   for i:=1 to 4 do  dp[i]:=-2*dp[i]; { -2*s*gamma }
   g1[1]:=dr; { gamma**2 }
   g1[2]:=dp; { -2*s*gamma }
   g1[3]:=ds; { s**2  terms for  (-s*Cos(phi~)+gamma)**2 }
   g2[1]:=dun;
   dd:=dun; { terms for (1/(1-d*Cos(phi)))**2 }
   for k:=2 to 6 do
     begin
       DerMults(dat,dd,dx);
       dd:=dx;
       for i:=1 to 4 do
         g2[k][i]:=k*dd[i];
     end;
   dabba(g1,g2,g3,3,6,8);
   dabba(g3,dphi,db,8,11,11);
   for k:=1 to 11 do
     begin
       DerMults(dv,db[k],dx);
       db[k]:=dx;
     end;
 end;

 procedure TDelm.DerForLambda_phig ;
 Var
   i,j,k,ij  : Byte ;
 begin
   k:=0;
   j:=1;
   df0:=dol; { gamma0prime }
   while  j <= 11 do
     begin
       k:=k+1;
       for i:=1 to 4 do
         df0[i]:=df0[i]+ceiler.tt[k]*db[j][i];
       j:=j+2;
     end;
   for k:=1 to 10 do
     begin { to obtain gammaJprime }
       dr:=dol;
       j:=k;
       while  j <= 10  do
         begin
           ij:=j+1;
           for i:=1 to 4 do
             dr[i]:=dr[i]+ceiler.uu[k][j]*db[ij][i];
           j:=j+2;
         end;
       for i:=1 to 4 do
         dff[k][i]:=ceiler.td[k]*dr[i];
     end;
 end;

 procedure TDelm.DerForLambda_add ;
 var
   i,j,k  : Byte ;
 begin
   k:=0;
   j:=2;
   while  j <= 8  do
     begin
       k:=k+1;
       DerMults(df0,dkf[k],du);
       DerMults(df0,dkp[k],dv);
       for i:=1 to 4 do
         begin
           dff[j][i]:=dff[j][i]+du[i];
           dpp[j][i]:=dpp[j][i]+dv[i];
         end;
       j:=j+2;
     end;
 end;

 procedure TDelm.DerForLambda ;
 var
   i  : Byte ;
 begin
   DerForLambda_init ;
   DerForLambda_bps ;
   DerForLambda_psi ;
   DerForLambda_psig ;
   DerForLambda_phi ;
   DerForLambda_phig ;
   DerForLambda_add ;
   DerMults(dnu,df0,dq); { nu*gamma0prime }
   for i:=1 to 4 do
     dlambda[i]:=-dp0[i]-df0[i]-dq[i]; { lambda c[23] }
 end;

 { n_0/(1-\lambda)      angle l
   n_0*\nu/(1-\lambda)  angle g
   n_0*\mu/(1-\lambda)  angle h
   and derivations with respect to a e \delta }

 procedure TDelm.DerForMot ; // result to dval dvag dvah
 var
   i  : Byte ;               // simple count
 begin
   for i:=1 to 4 do            // for derivations
     dq[i]:=dun[i]-dlambda[i]; // 1-\lambda
   DerPower(w1,dq,dr);         // 1/(1-\lambda) power (-1)
   DerMults(dn0,dr,dq);   // n_0/(1-\lambda)     angle l
   dval:=dq;              // d(dl/dt)/d(a e \delta)
                          // n_0*\nu/(1-\lambda) angle g
   DerMults(dq,dnu,dvag); // d(dg/dt)/d(a e \delta)
                          // n_0*\mu/(1-\lambda) angle h
   DerMults(dq,dmu,dvah); // d(dh/dt)/d(a e \delta)
                          // result to dval dvag dvah
 end;                     // DerForMot

 { partial derivations of the first order
   from some parameters are in public arrays }

 procedure TDelm.DerEilParm ; // eiler parameters with partial derivations
 begin
   InitiDer ;      // initial nullo and for a e \delta
   DerForQ ;       // simple value Q with derivations
   DerForC ;       // \alpha_1 \alpha_2^2 \alpha_3^2
   DerForKsi ;     // \bar e k_2^2 \sigma_2
   DerForEta ;     // s d \gamma k_1^2 \sigma_1
   DerForSec ;     // \alpha \beta \gamma'
   DerForNu ;      // \phi=\psi+g+\nu*(\psi-l)+...
   DerForMu ;      // \Omega~=h+\mu*(\psi-l)+...
   DerForLambda ;  // \lambda with peridic terms
   DerForMot ;     // n_0 n_0*\nu n_0*\mu /(1-\lambda)
 end;              // DerEilParm

 end.

