
 UNIT UnitSort ; // to order any list by using Shell method
                 
 INTERFACE

 Uses
   UnForTyq ; // UnForTyc for maxobs global variable

 Type
   TReaNum  = Array[1..maxobs] of Extended ;
   TIntNum  = Array[1..maxobs] of LongInt ;

 Procedure ShellMethodForOrdering ( NumberOfTerm : longint ;
                                    Var  RealOrderMassive : TReaNum ;
                                    Var  IntOrderMassive  : TIntNum ) ;

 IMPLEMENTATION

 {  Algorithm of the quick ordering
              has been presented by  B.Mejer and K.Boduin
                  in the book   Methods of programming   .
                     Volume 2 , page 151 , printed in Moscow , MIR , 1982 . }

 Procedure ShellMethodForOrdering ( NumberOfTerm : longint ;
                                    Var  RealOrderMassive : TReaNum ;
                                    Var  IntOrderMassive  : TIntNum ) ;
 Var
   IBuf,InCurrent,
   InOne,InComp,NumJ,NumL   : longint ;
   Buf                      : Extended ;
 Begin
   If  ( NumberOfTerm <= 1 ) Then  Exit;
   InCurrent:=1;
   InComp:=NumberOfTerm div 9;
   While  ( InCurrent < InComp ) Do
     InCurrent:=3*InCurrent+1;
   While  ( InCurrent >= 1 )  Do
     Begin
       InOne:=InCurrent+1;
       For NumJ:=InOne To NumberOfTerm Do
         Begin
           NumL:=NumJ-InCurrent;
           While  ( ( NumL >= 1 )  AND
                    ( RealOrderMassive[NumL] >
                      RealOrderMassive[NumL+InCurrent] ) )  Do
             Begin
                      { to replace the elements }
               Buf:=RealOrderMassive[NumL];
               RealOrderMassive[NumL]:=RealOrderMassive[NumL+InCurrent];
               RealOrderMassive[NumL+InCurrent]:=Buf;
                      { to replace the number of the elements }
               IBuf:=IntOrderMassive[NumL];
               IntOrderMassive[NumL]:=IntOrderMassive[NumL+InCurrent];
               IntOrderMassive[NumL+InCurrent]:=IBuf;
               NumL:=NumL-InCurrent;
             End;
         End;
       InCurrent:=InCurrent div 3;
     End;
 End;

 END.
