unit UnStuFel ; { after adjusting }
interface       { to write new set of elements }
procedure ToFinishPromean ; { proc is called by main program }
implementation
uses
  UnForTyp , { global Day Pos Vel Start }
  UnHarMod , { global GemParmValue }
  UnForEil , { procedures for intermediare orbit }
  UnForDat , { for date and julian day }
  UnForFun , { simple functions }
  UnForSop , { global satempac empiric acceleration }
  UnForPrt , { text protocol file PrtFile }
  UnVakOsc , { ToGetOscul for osculating elements }
  UnVakElm , { procedure SimpleElem }
  UnitCeil , { class TCeil with ceiler variables }
  UnForStr ; { function FloatToSingle }
{ to write new set of elements
     with variables DayStart ElmStart UnForTyp }
procedure ToFinishPromean ; { proc is called by main program }
var
  ny,nm,nd  : integer ;  { year month day }
  partday   : extended ; { part of day in day }
  secpart   : extended ; { part of day in second }
  yearone   : extended ; { temporary for 1 january }
  aa,si,ci  : extended ; { n_0 sin(i) cps(i) }
  an,ae,ai  : extended ; { eiler parameters }
  ul,ug,uh  : extended ; { angles l g h in radian }
  au,ap,am  : extended ;
begin
  { epoch from julian day to civil date global UnForTyp }
  TransJDtoDate(DayStart,nd,nm,ny,secpart); { UnForDat }
  partday:=secpart/86400; { our part from second to day }
  TransDateToJD(1,1,ny,yearone); { UnForDat for 1 january }
  nd:=Round(DayStart-yearone)+1; { number of day from new year }
  { result middle elements in ElmStart of TVarSix }
  SimpleElem(ElmStart,aa,ae,si,ci,ul,ug,uh); { UnVakElm ceiler UnitCeil }
  an:=43200*ceiler.c[27]/Pi; { mean motion in revolution per day n_0 }
  ai:=ATanDegree(si,ci); { approximately inclination in degree }
  au:=(180/Pi)*uh+90;  { the ascending node in degree }
  ap:=(180/Pi)*ug-90;  { argument of perigei in degree }
  am:=(180/Pi)*ul;     { mean anomaly in degree }
  if  au <   0.0  then  au:=au+360.0;   { value between }
  if  au > 360.0  then  au:=au-360.0; { 0 and 360 degree }
  if  ap <   0.0  then  ap:=ap+360.0;   { value between }
  if  ap > 360.0  then  ap:=ap-360.0; { 0 and 360 degree }
  if  am <   0.0  then  am:=am+360.0;   { value between }
  if  am > 360.0  then  am:=am-360.0; { 0 and 360 degree }
  { to write to protocol about new set of elements }
  writeln(prtfile);    { UnForPrt }
  writeln(prtfile,' set of elements after improving');    { UnForPrt }
  writeln(prtfile);    { UnForPrt }
  writeln(prtfile,stoursat); { name of the satellite global UnForTyp}
  writeln(prtfile,ny:5,'    year for elements epoch');
  writeln(prtfile,nd:5,'    day from new year for elements epoch');
  writeln(prtfile,partday:16:12,'    part of day for elements epoch');
  writeln(prtfile,ai:16:7,'    inclination in degree');
  writeln(prtfile,au:16:7,'    the ascending node in degree');
  writeln(prtfile,ae:16:10,'    eccentricity');
  writeln(prtfile,ap:16:7,'    argument of perigei in degree');
  writeln(prtfile,am:16:7,'    mean anomaly in degree');
  writeln(prtfile,an:16:10,'    mean motion in revolution per day');
  writeln(prtfile,FloatToSingle(satarama,15):16,  { property to reflect }
                  '    reflection coef.  k_r*A_m/m_s m^2/kg');
  writeLn(prtfile,FloatToSingle(satempac,15):16,
                  '    empiric acceleration rev/day^2'); { empiric acceleration }
end;
end.

