
 { some procedures to start and finish orbit improving }

 UNIT UnTusDoi ;

 INTERFACE

 { by using ObrFile (UnForTyq) and DerFile (UnMatDer) }

 Procedure ForOrbitImprove ;

 Procedure ForOrbitPrognoz ; { for the rowmuvap }

 IMPLEMENTATION

 Uses
   UnConTyp , { TVect3  }
   UnForPrt , { prtfile text file }
   UnForTyq , { types TRecObr binary file ObrFile }
   UnForTyp , { global record IntTime .begday .cursec }
   UnForSop , { global variable satarama }
   UnTypVar , { global variables number of terms in arrays }
   UnMatDer , { global var numter DerFile DerRec type TRangeDer }
   UnTushor , { proc ShorTermsToRec to rewrite recobr ObrFile }
   UnForStr ; { function FloatToSingle }

 { for number of short periodic terms }
 function numsho : longint ;
 var
   k,n  : longint ;
 begin
   k:=mecone;
   n:=k;
   k:=mectwo;
   n:=n+k;
   k:=mectre;
   n:=n+k;
   k:=mecfur;
   n:=n+k;
   k:=mecfiv;
   n:=n+k;
   k:=mecsix;
   n:=n+k;
   numsho:=n; { number of terms result }
 end;
 { about secular and short periodic terms }

 procedure PriNumTerms ;
 begin
   writeln ; { global variables word from UnTypVar }
   writeln(' to sum perturbations');
   writeln(meccoh:8,'  secular terms');
   writeln(numsho:8,'  short periodic terms');
   writeln ;
   writeln(' Solar radiation pressure');
   writeln(mecaux:8,'  secular terms');
   writeln(mectmp:8,'  short periodic terms');
   writeln ;
   writeln(prtfile); { global variables word from UnTypVar }
   writeln(prtfile,' to sum perturbations');
   writeln(prtfile,meccoh:8,'  secular terms');
   writeln(prtfile,numsho:8,'  short periodic terms');
   writeln(prtfile);
   writeln(prtfile,' Solar radiation pressure');
   writeln(prtfile,mecaux:8,'  secular terms');
   writeln(prtfile,mectmp:8,'  short periodic terms');
   writeln(prtfile);
 end;

 { to print some information about our object }

 procedure PrintSatValue ( tb  : extended ;      { moment }
                           eb  : TVarSix ;       { elements }
                           sb  : shortstring ) ; { string }
 begin
   WriteLn ;
   WriteLn(' ',sb);
   WriteLn ;
   WriteLn(' nonsingular elements');
   writeln ;
   writeln(stoursat); { name of the satellite global UnForTyp }
   WriteLn('  ',tb:20:10,'  epoch julian day'); { epoch }
   WriteLn('  ',eb[1]:25:15,'  a  in kilometer');
   WriteLn('  ',eb[2]:25:15,'  l+g+h  in radian');
   WriteLn('  ',eb[3]:25:15,'  e*cos(g+h)');
   WriteLn('  ',eb[4]:25:15,'  e*sin(g+h)');
   WriteLn('  ',eb[5]:25:15,'  \delta*cos(h)');
   WriteLn('  ',eb[6]:25:15,'  \delta*sin(h)');
   WriteLn(' reflection coefficient k_r*A_m/m_s in m^2/kg');
   WriteLn('    ', { function from UnForStr }
                FloatToSingle(satarama,20):23); { global UnForSop }
   WriteLn(' empiric acceleration  d^2(M)/(dt)^2 in rev/day^2');
   WriteLn('    ',
                FloatToSingle(satempac,20):23); { global UnForSop }
   WriteLn(prtfile);
   WriteLn(prtfile,' ',sb);
   WriteLn(prtfile);
   WriteLn(prtfile,' nonsingular elements');
   writeln(prtfile);
   writeln(prtfile,stoursat); { name of the satellite global UnForTyp}
   WriteLn(prtfile,'  ',tb:20:10,'  epoch julian day'); { epoch }
   WriteLn(prtfile,'  ',eb[1]:25:15,'  a  in kilometer');
   WriteLn(prtfile,'  ',eb[2]:25:15,'  l+g+h  in radian');
   WriteLn(prtfile,'  ',eb[3]:25:15,'  e*cos(g+h)');
   WriteLn(prtfile,'  ',eb[4]:25:15,'  e*sin(g+h)');
   WriteLn(prtfile,'  ',eb[5]:25:15,'  \delta*cos(h)');
   WriteLn(prtfile,'  ',eb[6]:25:15,'  \delta*sin(h)');
   WriteLn(prtfile,' reflection coefficient k_r*A_m/m_s in m^2/kg');
   WriteLn(prtfile,'    ', { function from UnForStr }
                   FloatToSingle(satarama,20):23); { global UnForSop }
   WriteLn(prtfile,' empiric acceleration  d^2(M)/(dt)^2 in rev/day^2');
   WriteLn(prtfile,'    ',
                   FloatToSingle(satempac,20):23);
 end; { to print some information }

 { initial nullo values to new DerFile }

 Procedure ToStartImprove ( tb  : extended ;  eb  : TVarSix ) ; { UnForTyp }
 Var                      { input to protocol file as start value }
   m  : Byte ;
 Begin
   { binary file DerFile of TRangeDer UnMatDer is assigned }
   ReWrite(DerFile);    { variable from UnMatDer }
   With  DerRec  Do     { record for derivations }
     Begin              { DerRec  from  UnMatDer }
       day:=IntTime.begday; { start julian day }
       secp:=0; { second of time from start day }
       numbersite:=1873; { default ZveniGorod }
       RoEtalon:=0.0; { range value in km observation result O }
       RoResidual:=0.0; { residual O-C }
       RoNulloVar:=0.0; { nullo variant for isochronic derivations C }
       For m:=1 To MatrM Do  { for all elements }
         RoDerivats[m]:=0.0; { derivations for all variants }
     End;
   { binary file ObrFile of TRecObr UnForTyc is assigned }
   ReSet(ObrFile);                { to open to read }
   While  NOT EOF(ObrFile)  Do    { record by record from binqlos.tmp }
     Begin   { to read observations position x pole y pole delta UT }
       Read(ObrFile,recobr); { data as observations in record recobr }
       DerRec.day:=recobr.dd; { julian day }
       DerRec.secp:=recobr.sd; { second from start day }
       DerRec.numbersite:=recobr.no;
       DerRec.RoEtalon:=recobr.ro; { laser range observation in km }
       Write(DerFile,DerRec); { the next record }
     End;
   CloseFile(ObrFile); { but temporary }
   CloseFile(DerFile); { but temporary }
   PrintSatValue(tb,eb,'before improving');
   PriNumTerms ; { about secular and short periodic terms }
 End;

 { to print some results }

 Procedure ToFinishImprove ( DifPar  : TypeDimM ;   { corrections }
                             tb  : extended ;       { date for }
                             Var  eb  : TVarSix ) ; { elements }
 Var
   i  : Byte ;
 Begin
   { values of the elements after improving process }
   For i:=1 To 6 Do { for six nonsingular }
     eb[i]:=eb[i]+DifPar[i]; { elements }
   satarama:=satarama+DifPar[7]; { global var UnForSop }
   satempac:=satempac+DifPar[8]; { global var UnForSop }
   DayStart:=tb; { global UnForTyp date epoch in julian day }
   ElmStart:=eb; { global UnForTyp nonsingular elements }
   PrintSatValue(tb,eb,' after improving');
 End;

 { to improve elements by using data in binqlos.tmp file }

 Procedure ForOrbitImprove ;
 Var
   tb     : Extended ; { initial moment nullo }
   eb     : TVarSix  ; { nonsingular elements to adjust UnForTyp}
   dparm  : TypeDimM ; { for the correction parameters type UnMatDer }
 Begin
   AssignFile(DerFile,'der.tmp'); { file of TRangeDer UnMatDer }
   AssignFile(ObrFile,'binqlos.tmp'); { binary file with data }
   numter:=0; { global var UnMatDer number of iteration }
   tb:=DayStart; { global UnForTyp date day is assigned UnStarto }
   eb:=ElmStart; { global UnForTyp elements is assigned UnStarto }
   ToStartImprove(tb,eb); { initial nullo to derivation file }
   tresigma:=1.0e4; { global var UnMatDer to exclude points in metr}
repeat
   numter:=numter+1;
   if  numter < 2  then
     ShorTermsToRec ; { UnTushor short terms to recobr }
   WriteLn ;
   WriteLn(' iteration number',numter:4);
   WriteLn(prtfile);
   WriteLn(prtfile,' iteration number',numter:4);
   WriteLn(prtfile);
   ToObtainDerivations(eb) ;       { isochronic derivations UnMatDer }
   ClcVariablesCorrections(dparm); { from UnMatDer tb start moment }
   ToFinishImprove(dparm,tb,eb);   { eb elements after improving }
until  ( numter = 3 ) ;            { PosVelToTruEqu from UnTreRoc }
   Erase(ObrFile); { our binary file with information closed }
   Erase(DerFile); { our binary file procedure from UnDerMat }
 End;

 Procedure ForOrbitPrognoz ; { for the rowmuvap }
 Var
   tb     : Extended ; { initial moment nullo }
   eb     : TVarSix  ; { nonsingular elements to adjust UnForTyp}
 Begin
   AssignFile(DerFile,'der.tmp'); { file of TRangeDer UnMatDer }
   AssignFile(ObrFile,'binqlos.tmp'); { binary file with data }
   numter:=1; { global var UnMatDer number of iteration }
   tb:=DayStart; { global UnForTyp date day is assigned UnStarto }
   eb:=ElmStart; { global UnForTyp elements is assigned UnStarto }
   ToStartImprove(tb,eb); { initial nullo to derivation file }
   tresigma:=1.0e4; { global var UnMatDer to exclude points in metr}
   ShorTermsToRec ; { UnTushor short terms to recobr }
   WriteLn ;
   WriteLn(' iteration number',numter:4);
   WriteLn(prtfile);
   WriteLn(prtfile,' iteration number',numter:4);
   WriteLn(prtfile);
   ToObtainResiduals(eb); { only residuals with prognos UnMatDer }
   Erase(ObrFile); { our binary file with information closed }
   Erase(DerFile); { our binary file procedure from UnDerMat }
 End;

 END.
