unit UnTushor ; { to obtain and add short periodic terms }
interface
procedure ShorTermsToRec ;
implementation
uses
  UnTypVar , { fulstp step in day to integrate }
  UnForTyp , { type TVarSix }
  UnForTyq , { type TRecObr and global variables }
  UnVakOsc , { procedure ToGetOscul with short periodic terms }
  UnVashad , { procedure EverGratorShad }
  UnEverGo ; { to integrate orbit }
procedure ShorTermsToRec ;
var
  dstep  : Extended ; { step to integrate }
  nurec  : longint ;
  tc,zt  : Extended ; { time in second }
  ed,ee  : TVarSix ;  { type from UnForTyp nonsingular elements }
  ev,ez  : TVarSix ;  { nonsingular elements }
  de,eo  : TVarSix ;  { correction and osculating nonsingular }
  td,te  : Extended ; { two moment in second }
begin
  writeln('  to add short periodic terms');
  dstep:=86400*fulstp; { global var UnTypVar step in day to second }
  ev:=ElmStart;  { global UnForTyp nonsingular elements }
  td:=0.0; { initial moment in second from IntTime.begday }
  ed:=ev;  { initial elements values }
  te:=td;  { initial moment in second from IntTime.begday }
  ee:=ed;  { to start to integrate elements }
  EvorInit ;      { from UnEverGo to start EverGratorFord }
  EvorCoefNullo ; { from UnEverGo to start EverGratorFord }
  ReSet(ObrFile); { UnForTyq file is assigned in UnTusDoi }
  nurec:=-1;      { to rewrite each record recobr in File }
  while  not EOF(ObrFile)  do { for each record to array zs }
    begin                     { to add short periodic terms }
      Read(obrfile,recobr);   { global UnForTyc next record }
      nurec:=nurec+1;         { number of record that read }
      tc:=recobr.sd;          { time in second from start }
      while  ( te < (tc-1.0e-8) ) do { to integrate secular }
//        EverGratorFord(dstep,td,ed,te,ee); { equations UnEverGo }
        EverGratorShad(dstep,td,ed,te,ee); { equations UnEverGo }
      zt:=tc-td;                { interval in second }
      VarFromPolinom(zt,ed,ez); { UnEverGo result for our moment }
      ToGetOscul(tc,ez,de,eo);  { UnVakOsc to sum short terms de }
      recobr.zs:=de; { short periodic correction to current record }
      Seek(obrfile,nurec);   { obrfile to current position to write }
      Write(obrfile,recobr); { our record with short periodic corr. }
      if  ( ( nurec mod 100 ) = 0 )  then
        writeln(nurec+1:6,de[1]:12:7,de[2]:12:7,de[3]:12:7,
                          de[4]:12:7,de[5]:12:7,de[6]:12:7);
    end;
  CloseFile(ObrFile); { global UnForTyq after adding short terms }
end;
end.
