unit UnVakDes ; // ds/d(a e \delta) numerical values
interface
var
  dersa  : Extended ; // ds/da
  derse  : Extended ; // ds/de
  dersd  : Extended ; // ds/d\delta
procedure ForDerParms ; // ds/d(a e \delta)
implementation
uses
  UnitCeil ; // variables of class TCeil
{ s=\delta+\epsilon*\sigma*(1-\delta^2)
          -3*\epsilon^2*\sigma^2*\delta*(1-\delta^2)
          -\epsilon^3*\sigma*(1-\delta^2)*(3-4*\delta^2+e^2) }
procedure ForDerParms ;   // to otain ds/d(a e \delta)
var                       // by simple formula
  e,d,p,s,g  : Extended ; // parameters numerical values
  q,r,x,y,z  : Extended ; // auxiliary variables
begin                     // by using class TCeil
  e:=ceiler.ae;     // eccentricity
  d:=ceiler.ad;     // parameter \delta
  p:=ceiler.epscj2; // \epsilon=c/(a*(1-e^2))
  s:=ceiler.sig;    // \sigma constant near 1/30
  g:=p*s;           // \epsilon*\sigma
  q:=Sqr(e);        // e^2
  r:=Sqr(d);        // \delta^2
  x:=3-4*r+q;       // 3-4*\delta^2+e^2
  y:=Sqr(p);        // \epsilon^2
  z:=g*(1-r)            // \epsilon*\sigma*(1-\delta^2)
      *(1-6*g*d-3*y*x); //   *(1-6*\epsilon*\sigma*\delta
                        //      -3*\epsilon^2*(3-4*\delta^2+e^2))
  dersa:=-z/ceiler.ab;     // ds/da through \epsilon (-1/a)
  derse:=2*e*(z/(1-q)      // ds/de=2*e*(z/(1-e^2)
            -y*g*(1-r));   // -\epsilon^3*\sigma*(1-\delta^2)
  dersd:=1-2*g*d              // ds/d\delta=1-2*\epsilon*\sigma*\delta
          -3*Sqr(g)*(1-3*r)   // -3*\epsilon^2\sigma^2(1-3*\delta^2)
          +2*y*g*d*(7-8*r+q); // +2*\epsilon^3*\sigma*\delta*(7-...)
end;
end.
