{ all secular terms
  and short periodic
  due to the geopotential
         the Moon the Sun with tides
     are in array rowcoh^[..] meccoh terms from UnTypVar
     are in array rowsix^[..] mecsix terms from UnTypVar }
unit UnVakFup ; { forces term by term with a e s c l g h }
interface       { F the current term of hamiltonian }
uses
  UnTypVar , { for types and pointer array of record rowcoh^[..] }
  UnForTyp ; { for type TVarSix for forces }
{ to sum term by term to selected global variables }
procedure ToGetForceValue ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            var  forces  : TVarSix ) ; { array[1..6] UnForTyp }
{ to add short periodic terms to call from UnVakOsc }
procedure ToAddShortTerms ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            argvel  : TValArg ;        { array[1..9] UnTypVar }
                            elmsin  : TVarSix ;        { array[1..6] UnForTyp }
                            var  elmdif  : TVarSix ;   { array[1..6] UnForTyp }
                            var  elmout  : TVarSix ) ; { array[1..6] UnForTyp }
{ only for Solar radiation pressure
  to sum term by term to selected global variables }
procedure ToGetForceSolap ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            var  forces  : TVarSix ) ; { array[1..6] UnForTyp }
{ only for Solar radiation pressure short periodic terms }
procedure ToGetShortSolap ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            argvel  : TValArg ;        { array[1..9] UnTypVar }
                            var  elmdif  : TVarSix ) ; { array[1..6] UnForTyp }
implementation
uses
  UnHarMod , { for global array GemParmValue[2] = r_0 }
  UnVakDes , { for global variables dersa derse dersd }
  UnitDeil , { class TDeil public daone deone ddone[1..3] }
  UnitCeil , { class TCeil public variable ad \delta }
  UnitDelm , { class TDelm public variable /d(a e \delta) }
  UnForSop , { global factor satarama for Solar radiation }
  UnVakNuF ; { inert. forces dF/dG dF/dH df/dh dfibg h ah }
var { global variables for each part of forces and short terms }
  faxi  : Extended ; { numerical value F as function semimajor axis }
  famp  : Extended ; { numerical value for current amplitude }
  dfda  : Extended ; { numerical value dF/da partial derivation }
  dfde  : Extended ; { numerical value dF/de partial derivation }
  dfds  : Extended ; { numerical value dF/ds partial derivation s=sin(i) }
  dfdc  : Extended ; { numerical value dF/dc partial derivation c=cos(i) }
  dfdl  : Extended ; { numerical value dF/dl partial derivation }
  dfdg  : Extended ; { numerical value dF/dg partial derivation }
  dfdh  : Extended ; { numerical value dF/dh partial derivation }
  dfbl  : Extended ; { numerical value dF/dL partial derivation big L }
  dfbg  : Extended ; { numerical value dF/dG partial derivation big G }
  dfbh  : Extended ; { numerical value dF/dH partial derivation big H }
  dfdd  : Extended ; { numerical value dF/d\delta partial derivation }
  rvel  : Extended ; { numerical value denominator 1/(d(arg)/dt) }
  drva  : Extended ; { numerical value d/da(1/(d(arg)/dt)) }
  drve  : Extended ; { numerical value d/de(1/(d(arg)/dt)) }
  drvd  : Extended ; { numerical value d/dd(1/(d(arg)/dt)) }
{ initial nullo values to all partial derivations for sum }
procedure AllDerNullo ;
begin
  dfda:=0.0; { numerical value dF/da partial derivation }
  dfde:=0.0; { numerical value dF/de partial derivation }
  dfds:=0.0; { numerical value dF/ds partial derivation s=sin(i) }
  dfdc:=0.0; { numerical value dF/dc partial derivation c=cos(i) }
  dfdd:=0.0; { numerical value dF/d\delta partial derivation }
  dfdl:=0.0; { numerical value dF/dl partial derivation }
  dfdg:=0.0; { numerical value dF/dg partial derivation }
  dfdh:=0.0; { numerical value dF/dh partial derivation }
end;
{ to obtain numerical value
  for part f(a) in current term
  but in our case each term f(a) is function f(a/r_0) }
function ValueFaxis ( r  : TRowVar ) : Extended ;
var
  i  : Byte ;
  d  : Extended ;
  q  : Extended ;
  x  : Extended ;
  y  : Extended ;
begin           { (a/r_0)-(a_0/r_0) difference GemParmValue[2] UnHarMod }
  y:=(axicur-axinul)/GemParmValue[2]; { difference global from UnTypVar }
  q:=1.0;      { initial value }
  d:=r.amp[1]; { value for F for a=axinul }
  for i:=2 to maxder do { for row Teilor sum }
    begin               { term by term Teilor expansion }
      x:=i-1.0;         { integer to real }
      q:=(1.0/x)*q*y;   { for (1/n!)*x^n }
      d:=d+r.amp[i]*q;  { plus the next term in Teilor expansion }
    end;                { end for row Teilor sum }
  ValueFaxis:=d;      { numerical value }
end;
{ amplitude numerical value
  result to global var famp f(a)*e^j*s^k*c^l
  but in our case each term f(a) is function f(a/r_0) }
procedure ValueAmpitude ( f  : Extended ;  r  : TRowVar ) ;
var
  z  : Extended ; { part of amplitude f(a/r_0)*c^l }
begin
  z:=f*cosmow[r.mec[4]];  { part of amplitude f(a/r_0)*c^l }
  famp:=z*eccmow[r.mec[2]]*sinmow[r.mec[3]]; { f(a/r_0)*e^j*s^k*c^l }
end;
{ partial derivation dF/da power of a e s c in mec[1..4]
  but each term f(a) is function f(a/r_0) with derivations }
function DerWithAxi ( r  : TRowVar ;  s , c  : Extended ) : Extended ;
var
  i  : Byte ;     { count simple }
  p  : Extended ; { temporary value for e^*s^*c^ }
  y  : Extended ; { difference a-a_mean axinul from UnTypVar }
  x  : Extended ; { real value for integer i }
  q  : Extended ; { current power for dif(a) }
  d  : Extended ; { value for d/da }
  z  : Extended ; { value for sin or cos of argument }
begin             { (a/r_0)-(a_0/r_0) difference GemParmValue[2] UnHarMod }
  y:=(axicur-axinul)/GemParmValue[2]; { difference global from UnTypVar }
  p:=eccmow[r.mec[2]]*sinmow[r.mec[3]]*cosmow[r.mec[4]]; { e^j*s^k*c^l }
  q:=1.0;      { initial value }
  d:=r.amp[2]; { value for df(a/r_0)/d(a/r_0) for a=axinul }
  for i:=3 to maxder do { for row Teilor sum }
    begin               { term by term Teilor expansion }
      x:=i-2.0;         { integer to real }
      q:=(1.0/x)*q*y;   { for (1/n!)*x^n }
      d:=d+r.amp[i]*q;  { plus the next term in Teilor expansion }
    end;                { end for row Teilor sum }
  if  r.fcs = 'S'       { character for function }
    then  z:=s          { sinus argument }
    else  z:=c;         { cosinus argument }
  p:=p/GemParmValue[2]; { (1/r_0)*e^j*s^k*c^l }
  DerWithAxi:=d*p*z;    { result df/da=df/d(a/r_0)*d(a/r_0)/da }
end;
{ partial derivation dF/de power of a e s c in mec[1..4] }
function DerWithEcc ( r  : TRowVar ;  s , c  : Extended ) : Extended ;
var
  p  : Extended ; { temporary value for e^*s^*c^ }
  z  : Extended ; { value for sin or cos of argument }
begin
  DerWithEcc:=0.0;  { initial nullo when power of e is nullo for e^0 }
  if  r.mec[2] = 0  then  Exit ; { power of eccentricity is nullo }
  p:=r.mec[2]*eccmow[r.mec[2]-1]         { for e^j dF/de = j*e^(j-1) }
     *sinmow[r.mec[3]]*cosmow[r.mec[4]]; { j*e^(j-1)*s^k*c^l }
  if  r.fcs = 'S'       { character for function }
    then  z:=s          { sinus argument }
    else  z:=c;         { cosinus argument }
  DerWithEcc:=faxi*p*z; { result }
end;
{ partial derivation dF/ds power of  e sin(i) cos(i) in mec[1..4] }
function DerWithSin ( r  : TRowVar ;  s , c  : Extended ) : Extended ;
var
  p  : Extended ; { temporary value for e^*s^*c^ }
  z  : Extended ; { value for sin or cos of argument }
begin
  DerWithSin:=0.0;  { initial nullo when power of s is nullo for s^0 }
  if  r.mec[3] = 0  then  Exit ; { power of sinus inclination is nullo }
  p:=r.mec[3]*eccmow[r.mec[2]]             { for s^k dF/ds = k*s^(k-1) }
     *sinmow[r.mec[3]-1]*cosmow[r.mec[4]]; { k*e^j*s^(k-1)*c^l }
  if  r.fcs = 'S'       { character for function }
    then  z:=s          { sinus argument }
    else  z:=c;         { cosinus argument }
  DerWithSin:=faxi*p*z; { result faxi value for part f(a) }
end;
{ partial derivation dF/dc power of  e sin(i) cos(i) in mec[1..4] }
function DerWithCos ( r  : TRowVar ;  s , c  : Extended ) : Extended ;
var
  p  : Extended ; { temporary value for e^*s^*c^ }
  z  : Extended ; { value for sin or cos of argument }
begin
  DerWithCos:=0.0;  { initial nullo when power of c is nullo for c^0 }
  if  r.mec[4] = 0  then  Exit ; { power  cosinus inclination is nullo }
  p:=r.mec[4]*eccmow[r.mec[2]]             { for c^l dF/dc = l*c^(l-1) }
     *sinmow[r.mec[3]]*cosmow[r.mec[4]-1]; { l*e^j*s^k*c^(l-1) }
  if  r.fcs = 'S'       { character for function }
    then  z:=s          { sinus argument }
    else  z:=c;         { cosinus argument }
  DerWithCos:=faxi*p*z; { result faxi value for part f(a) }
end;
{ partial derivation dF/dl amplitude f(a)*e^j*s^k*c^l in famp global var }
function DerWithUdl ( r  : TRowVar ;  s , c  : Extended ) : Extended ;
var
  z  : Extended ; { value for sin or cos of argument }
begin
  DerWithUdl:=0.0;  { initial nullo when coefficient with element l equal 0 }
  if  r.mar[1] = 0  then  Exit ; { value of coefficient equal nullo }
  if  r.fcs = 'S'                { character for function }
    then  z:=+c                  { sinus   arg partial derivation with angle }
    else  z:=-s;                 { cosinus arg partial derivation with angle }
  DerWithUdl:=r.mar[1]*famp*z;   { result famp amplitude f(a)*e^j*s^k*c^l }
end;
{ partial derivation dF/dg amplitude f(a)*e^j*s^k*c^l in famp global var }
function DerWithUdg ( r  : TRowVar ;  s , c  : Extended ) : Extended ;
var
  z  : Extended ; { value for sin or cos of argument }
begin
  DerWithUdg:=0.0;  { initial nullo when coefficient with element g equal 0 }
  if  r.mar[2] = 0  then  Exit ; { value of coefficient equal nullo }
  if  r.fcs = 'S'                { character for function }
    then  z:=+c                  { sinus   arg partial derivation with angle }
    else  z:=-s;                 { cosinus arg partial derivation with angle }
  DerWithUdg:=r.mar[2]*famp*z;   { result famp amplitude f(a)*e^j*s^k*c^l }
end;
{ partial derivation dF/dh amplitude f(a)*e^j*s^k*c^l in famp global var }
function DerWithUdh ( r  : TRowVar ;  s , c  : Extended ) : Extended ;
var
  z  : Extended ; { value for sin or cos of argument }
begin
  DerWithUdh:=0.0;  { initial nullo when coefficient with element h equal 0 }
  if  r.mar[3] = 0  then  Exit ; { value of coefficient equal nullo }
  if  r.fcs = 'S'                { character for function }
    then  z:=+c                  { sinus   arg partial derivation with angle }
    else  z:=-s;                 { cosinus arg partial derivation with angle }
  DerWithUdh:=r.mar[3]*famp*z;   { result famp amplitude f(a)*e^j*s^k*c^l }
end;
{ r  current term
  s  sinus   argument
  c  cosinus argument
  to sum current term
  to values of partial derivations dF/d(a,e,s,c) }
procedure AllDerSum ( r  : TRowVar ;  s , c  : Extended ) ; { UnTypVar }
begin             { global variables dfda dfde dfds and others }
  faxi:=ValueFaxis(r);   { function of semimajor axis f(a) }
  ValueAmpitude(faxi,r); { value for amplitude famp }
  dfda:=dfda+DerWithAxi(r,s,c); { plus dF/da }
  dfde:=dfde+DerWithEcc(r,s,c); { plus dF/de }
  dfds:=dfds+DerWithSin(r,s,c); { plus dF/ds }
  dfdc:=dfdc+DerWithCos(r,s,c); { plus dF/dc }
  dfdl:=dfdl+DerWithUdl(r,s,c); { plus dF/dl for da/dt=dF/dl*da/dL }
  dfdg:=dfdg+DerWithUdg(r,s,c); { plus dF/dg }
  dfdh:=dfdh+DerWithUdh(r,s,c); { plus dF/dh }
end;
{ to sum term by term by using global variables
  argval for arguments l g h S_Z \lambda l l' F D
  forces for nonsingular elements
  a l+g+h e*cos(g+h) e*sin(g+h) s*cos(h) s*sin(h) }
procedure ToGetForceValue ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            var  forces  : TVarSix ) ; { array[1..6] UnForTyp }
var
  ia  : Byte ;     { count for arguments array 1..9 }
  kt  : Word ;     { count for terms in hamiltonian rowcoh^[..] meccoh }
  rc  : TRowVar ;  { type UnTypVar current record from rowcoh^[..] }
  va  : Extended ; { current argument value in radian }
  sa  : Extended ; { value sin(Argument) }
  ca  : Extended ; { value cos(Argument) }
  ee  : Extended ; { eccentricity for forces }
  si  : Extended ; { sinus   inclination for forces }
  ci  : Extended ; { cosinus inclination for forces }
  cg  : Extended ; { cos(g+h) for forces }
  sg  : Extended ; { sin(g+h) for forces }
  ch  : Extended ; { cos(h) for forces }
  sh  : Extended ; { sin(h) for forces }
  ds  : Extended ; { full derivative dF/ds=(dF/ds)+(dF/dc)*(dc/ds) }
  fa  : Extended ; { dF/da+dF/ds*ds/da }
  fe  : Extended ; { dF/de+dF/ds*ds/de }
  fd  : Extended ; { dF/ds*ds/d\delta }
  qb  : Extended ; { temporary variable }
  qc  : Extended ; { temporary variable }
  qm  : Extended ; { temporary variable for motions }
begin

  AllDerNullo ;    { initial nullo values to all partial derivations }
                   { perturbation due to the Geopot the Moon the Sun }
  kt:=0;           { initial nullo term }
repeat             { term by term record by record }
  kt:=kt+1;        { the next number of record }
  rc:=rowcoh^[kt]; { the next record to obtain forces }
                   { to sum l g h S_Z \lambda l l' F D }
  va:=0.0;         { initial nullo argument value }
  for ia:=1 to maxarg do { for all arguments }
    va:=va+rc.mar[ia]*argval[ia];   { value after sum in radian }
  sa:=Sin(va);     { sinus argument }
  ca:=Cos(va);     { cosinus argument }
  AllDerSum(rc,sa,ca); { values to partial derivations dF/d(a,e,s,c,l,g,h) }
until  kt = meccoh ; { the last record }
                   { perturbation due to the Solar radiation pressure }
  kt:=0;           { initial nullo term }
repeat             { term by term record by record }
  kt:=kt+1;        { the next number of record }
  rc:=rowaux^[kt]; { the next record to obtain forces }
                   { to sum l g h S_Z \lambda l l' F D }
  va:=0.0;         { initial nullo argument value }
  for ia:=1 to maxarg do { for all arguments }
    va:=va+rc.mar[ia]*argval[ia];   { value after sum in radian }
  sa:=Sin(va);     { sinus argument }
  ca:=Cos(va);     { cosinus argument }
  for ia:=1 to maxder do { for amplitudes with factor k_r*(A_midel/m_sat }
    rc.amp[ia]:=satarama*rc.amp[ia]; { factor UnForSop for Solar pressure }
  AllDerSum(rc,sa,ca); { values to partial derivations dF/d(a,e,s,c,l,g,h) }
until  kt = mecaux ; { the last record }

  { some numerical values for our variables }
  ee:=eccmow[1]; { global UnTypVar eccentricity }
  si:=sinmow[1]; { global UnTypVar sinus   inclination }
  ci:=cosmow[1]; { global UnTypVar cosinus inclination }
  cg:=Cos(argval[2]+argval[3]); { cos(g+h) }
  sg:=Sin(argval[2]+argval[3]); { sin(g+h) }
  ch:=Cos(argval[3]); { cos(h) }
  sh:=Sin(argval[3]); { sin(h) }

  { full partial derivative ( with dfds dfdc si ci )
    dF/ds=(dF/ds)+(dF/dc)*(dc/ds) where dc/ds=-(s/c) }
  ds:=dfds-(si/ci)*dfdc; { dF/ds with sin and cosinus inclination }
  { auxiliary values by using global var from UnVakDes }
  fa:=dfda+ds*dersa; { dF/da+dF/ds*ds/da UnVakdes ForDerParms }
  fe:=dfde+ds*derse; { dF/de+dF/ds*ds/de UnVakdes ForDerParms }
  fd:=ds*dersd;      { dF/d\delta = dF/ds*ds/d\delta UnVakdes }

  { derivations with respect to action variables L G H
    procedure deiler.ToGetDerSel is called from UnRights }
  with  deiler  do { deiler of class TDeil UnitDeil }
    begin          { d a e d one[1..3]  /dL /dG /dH }
      { dF/dL=dF/da*da/dL+dF/de*de/dL+dF/d\delta*d\delta/dL }
      dfbl:=fa*daone[1]+fe*deone[1]+fd*ddone[1]; { dF/dL deiler.daone }
      { dF/dG=dF/da*da/dG+dF/de*de/dG+dF/d\delta*d\delta/dG }
      dfbg:=fa*daone[2]+fe*deone[2]+fd*ddone[2]; { dF/dG deiler.deone }
      { dF/dH=dF/da*da/dH+dF/de*de/dH+dF/d\delta*d\delta/dH }
      dfbh:=fa*daone[3]+fe*deone[3]+fd*ddone[3]; { dF/dH deiler.ddone }
    end;

  { to add derivations UnVakNuF
    dfibg dF/dG dfibh dF/dH dfiah dF/dh due to inertia forces }
  dfbg:=dfbg+dfibg; { +dF/dG inertia forces global UnVakNuF }
  dfbh:=dfbh+dfibh; { +dF/dH inertia forces global UnVakNuF }
  dfdh:=dfdh+dfiah; { +dF/dh inertia forces global UnVakNuF }

  { right hand sides of our six equations
    where  dfdl dF/dl dfdg dF/dg dfdh dF/dh derivations }

  { the first  equation
    da/dt = dF/dl*da/dL+dF/dg*da/dG+dF/dh*da/dH }
  with  deiler  do  { deiler of TDeil class UnitDeil }
    forces[1]:=forces[1]+dfdl*daone[1]  { deiler.daone[1] da/dL }
                        +dfdg*daone[2]  { deiler.daone[2] da/dG }
                        +dfdh*daone[3]; { deiler.daone[3] da/dH }

  { the second equation
    d(l+g+h)/dt = -dF/dL-dF/dG-dF/dH }
  forces[2]:=forces[2]-dfbl-dfbg-dfbh;

  { temporary values
    for the third and fourth equations
    de/dt = dF/dl*de/dL+dF/dg*de/dG+dF/dh*de/dH }
  with  deiler  do  { deiler of TDeil class UnitDeil deone[1..3] }
    qb:=dfdl*deone[1]+dfdg*deone[2]+dfdh*deone[3]; { de/dt L G H }
  qc:=ee*(dfbg+dfbh);           { e*(dF/dG+dF/dH) }
  qm:=ee*(tremot[2]+tremot[3]); { e*(dg/dt+dh/dt motion }

  { the third  equation  d(e*cos(g+h))/dt }
  forces[3]:=forces[3]+qb*cg+(qc-qm)*sg; { cos sin (g+h) }

  { the fourth equation  d(e*sin(g+h))/dt }
  forces[4]:=forces[4]+qb*sg-(qc-qm)*cg; { sin cos (g+h) }

  { temporary values
    for the fifth and sixth equations
    d\delta/dt = dF/dl*d\delta/dL+dF/dg*d\delta/dG+dF/dh*d\delta/dH }
  with  deiler  do  { deiler of TDeil class UnitDeil ddone[1..3] }
    qb:=dfdl*ddone[1]+dfdg*ddone[2]+dfdh*ddone[3]; { dd/dt L G H }
  qc:=ceiler.ad*dfbh;      { \delta*dF/dH ceiler of TCeil UntCeil }
  qm:=ceiler.ad*tremot[3]; { \delta*dh/dt = s*n_0*\mu/(1-\lambda) }
                           { ceiler of class TCeil from UnitCeil }
  { the fifth  equation  d(\delta*cos(h))/dt }
  forces[5]:=forces[5]+qb*ch+(qc-qm)*sh; { cos(h) sin(h) }

  { the sixth  equation  d(\delta*sin(h))/dt }
  forces[6]:=forces[6]+qb*sh-(qc-qm)*ch; { sin(h) cos(h) }

end;

{ r  current term
  s  sinus   argument
  c  cosinus argument
  to sum current short periodic term
  our short periodic function S = \int F_p dt
  to values of partial derivations dS/d(a,e,s,c)
  after integration
        function sin in F_p replace by function -cos in S 
        function cos in F_p replace by function +sin in S
  for partial derivatives
      with respect to angle elements l g h
        function sin in F_p replace by function +sin in dS/d(l g h)
        function cos in F_p replace by function +cos in dS/d(l g h) }

procedure AllShortP ( r  : TRowVar ;  s , c  : Extended ) ; { UnTypVar }
var
  fz  : Extended ; { sinus or cosinus after integration }
  ds  : Extended ; { one term part dS/ds }
  rc  : Extended ; { one term part sin(i)/cos(i) }
begin              { global variables dfda dfde dfds and others }

  faxi:=ValueFaxis(r);   { function of semimajor axis f(a) }
  ValueAmpitude(faxi,r); { value for amplitude famp }

  if  r.fcs = 'S'        { to integrate our hamiltoni F_p }
    then  fz:=-famp*c    { term F_p with   sinus argument }
    else  fz:=+famp*s;   { term F_p with cosinus argument }

  dfda:=dfda+rvel*DerWithAxi(r,-c,s)+drva*fz; { plus dS/da }
  dfde:=dfde+rvel*DerWithEcc(r,-c,s)+drve*fz; { plus dS/de }
  dfdd:=dfdd+drvd*fz;                         { part dS/d\delta }

  rc:=sinmow[1]/cosmow[1]; { sin(i)/cos(i) -d(cos(i))/d(sin(i)) }

  { d/ds=(d/ds)+(d/dc)*(dc/ds) where dc/ds=-(s/c) }
  ds:=rvel*(DerWithSin(r,-c,s)-rc*DerWithCos(r,-c,s)); { part dS/ds }

  { auxiliary values by using global var from UnitDelm TDelm }
  dfda:=dfda+ds*delmer.das[2]; { dS/da+dS/ds*ds/da UnitDelm DerEilParm }
  dfde:=dfde+ds*delmer.das[3]; { dS/de+dS/ds*ds/de UnitDelm DerEilParm }
  dfdd:=dfdd+ds*delmer.das[4]; { dS/d\delta =dS/ds*ds/d\delta UnitDelm }

  dfdl:=dfdl+rvel*DerWithUdl(r,-c,s); { plus dS/dl }
  dfdg:=dfdg+rvel*DerWithUdg(r,-c,s); { plus dS/dg }
  dfdh:=dfdh+rvel*DerWithUdh(r,-c,s); { plus dS/dh }

end;

procedure ToSumSingle  ( val  : TValArg ;   // array[1..9] UnTypVar
                         vel  : TValArg ;   // array[1..9] UnTypVar
                         mec  : Word ;      // number of terms
                         row  : TRowPtr ) ; // array with terms UnTypVar
var
  ia  : Byte ;     // count for arguments array 1..9
  kt  : Word ;     // count for terms in hamiltonian rowone^[..] mecone
  rc  : TRowVar ;  // type UnTypVar current record from rowone^[..]
  va  : Extended ; // current argument value in radian
  vv  : Extended ; // current argument velosity in rad/s
  sa  : Extended ; // value sin(Argument)
  ca  : Extended ; // value cos(Argument)
  vz  : Extended ; // value -1/(velosity^2)
begin
  kt:=0;            { initial nullo term }
repeat              { term by term record by record }
  kt:=kt+1;         { the next number of record }
  rc:=row^[kt];     { to obtain short periodic perturbation }
  va:=0.0;          { initial nullo argument value }
  vv:=0.0;          { initial nullo velosity value }
  for ia:=1 to 9 do { arguments l g h S_Z \lambda l l' F D }
    begin
      va:=va+rc.mar[ia]*val[ia]; { value after sum in radian }
      vv:=vv+rc.mar[ia]*vel[ia]; { velos after sum in radian }
    end;
  sa:=Sin(va);                    { sinus argument }
  ca:=Cos(va);                    { cosinus argument }
  rvel:=1.0/vv;   { denominator 1/(d(arg)/dt) }
  vz:=-Sqr(rvel); { value -1/(velosity^2) }
  { for derivations denominator to a e \delta }
  drva:=vz*(rc.mar[1]*delmer.dval[2]   // i_1*d/da(dl/dt)
           +rc.mar[2]*delmer.dvag[2]   // i_2*d/da(dg/dt)
           +rc.mar[3]*delmer.dvah[2]); // i_3*d/da(dh/dt)
  drve:=vz*(rc.mar[1]*delmer.dval[3]   // i_1*d/de(dl/dt)
           +rc.mar[2]*delmer.dvag[3]   // i_2*d/de(dg/dt)
           +rc.mar[3]*delmer.dvah[3]); // i_3*d/de(dh/dt)
  drvd:=vz*(rc.mar[1]*delmer.dval[4]   // i_1*d/d\delta(dl/dt)
           +rc.mar[2]*delmer.dvag[4]   // i_2*d/d\delta(dg/dt)
           +rc.mar[3]*delmer.dvah[4]); // i_3*d/d\delta(dh/dt)
                       { dfdl dS/dl dfdg dS/dg dfdh dS/dh derivations }
  AllShortP(rc,sa,ca); { partial derivations dS/d(a,e,\delta,l,g,h) }
until  kt = mec ;      { the last record }
end;

{ input
  argval value of arguments radian
  argvel velosity arguments radian per second
  our short periodic function S = \int F_p dt }

procedure ToSumDerivations ( argval  : TValArg ;   // array[1..9] UnTypVar
                             argvel  : TValArg ) ; // array[1..9] UnTypVar
var
  ia  : Byte ;     // count for arguments array 1..9
  kt  : Word ;     // count for terms in hamiltonian rowone^[..] mecone
  rc  : TRowVar ;  // type UnTypVar current record from rowone^[..]
  va  : Extended ; // current argument value in radian
  vv  : Extended ; // current argument velosity in rad/s
  sa  : Extended ; // value sin(Argument)
  ca  : Extended ; // value cos(Argument)
  vz  : Extended ; // value -1/(velosity^2)
begin

  AllDerNullo ;     { initial nullo values to all partial derivations }
                    { in arrays from rowone^ to rowsix^
                         may be the terms for function F_p }
  if  mecone > 0    { the first portion }
    then            { of short periodic terms }
      ToSumSingle(argval,argvel,mecone,rowone);
  if  mectwo > 0    { the second portion }
    then            { of short periodic terms }
      ToSumSingle(argval,argvel,mectwo,rowtwo);
  if  mectre > 0    { the third portion }
    then            { of short periodic terms }
      ToSumSingle(argval,argvel,mectre,rowtre);
  if  mecfur > 0    { the fourth portion }
    then            { of short periodic terms }
      ToSumSingle(argval,argvel,mecfur,rowfur);
  if  mecfiv > 0    { the fifth portion }
    then            { of short periodic terms }
      ToSumSingle(argval,argvel,mecfiv,rowfiv);
  if  mecsix > 0    { the sixth portion }
    then            { of short periodic terms }
      ToSumSingle(argval,argvel,mecsix,rowsix);
                    { in array rowtmp^ are the terms for Solar pressure }
  kt:=0;            { initial nullo term }
repeat              { term by term record by record }
  kt:=kt+1;         { the next number of record }
  rc:=rowtmp^[kt];  { to obtain short periodic perturbation }
  va:=0.0;          { initial nullo argument value }
  vv:=0.0;          { initial nullo velosity value }
  for ia:=1 to 9 do { arguments l g h S_Z \lambda l l' F D }
    begin
      va:=va+rc.mar[ia]*argval[ia]; { value after sum in radian }
      vv:=vv+rc.mar[ia]*argvel[ia]; { velos after sum in radian }
    end;
  sa:=Sin(va);                    { sinus argument }
  ca:=Cos(va);                    { cosinus argument }
  rvel:=1.0/vv;   { denominator 1/(d(arg)/dt) }
  vz:=-Sqr(rvel); { value -1/(velosity^2) }
  { for derivations denominator to a e \delta }
  drva:=vz*(rc.mar[1]*delmer.dval[2]   // i_1*d/da(dl/dt)
           +rc.mar[2]*delmer.dvag[2]   // i_2*d/da(dg/dt)
           +rc.mar[3]*delmer.dvah[2]); // i_3*d/da(dh/dt)
  drve:=vz*(rc.mar[1]*delmer.dval[3]   // i_1*d/de(dl/dt)
           +rc.mar[2]*delmer.dvag[3]   // i_2*d/de(dg/dt)
           +rc.mar[3]*delmer.dvah[3]); // i_3*d/de(dh/dt)
  drvd:=vz*(rc.mar[1]*delmer.dval[4]   // i_1*d/d\delta(dl/dt)
           +rc.mar[2]*delmer.dvag[4]   // i_2*d/d\delta(dg/dt)
           +rc.mar[3]*delmer.dvah[4]); // i_3*d/d\delta(dh/dt)
                         { k_r*(A_midel/m_sat factor UnForSop }
  for ia:=1 to maxder do { for amplitudes with factor }
    rc.amp[ia]:=satarama*rc.amp[ia]; { for Solar pressure }
                       { dfdl dS/dl dfdg dS/dg dfdh dS/dh derivations }
  AllShortP(rc,sa,ca); { partial derivations dS/d(a,e,\delta,l,g,h) }
until  kt = mectmp ;   { the last record }

end;

{ to sum term by term by using global variables
  argval for arguments l g h S_Z \lambda l l' F D
  argvel d(l g h S_Z \lambda l l' F D)/dt rad/s
  short periodic terms for nonsingular elements
  a l+g+h e*cos(g+h) e*sin(g+h) s*cos(h) s*sin(h)
  input  set of nonsingular elements elmsin of TVarSix
  output set of nonsingular elements elmout of TVarSix }

procedure ToAddShortTerms ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            argvel  : TValArg ;        { array[1..9] UnTypVar }
                            elmsin  : TVarSix   ;      { array[1..6] UnForTyp }
                            var  elmdif  : TVarSix ;   { array[1..6] UnForTyp }
                            var  elmout  : TVarSix ) ; { array[1..6] UnForTyp }
var
  ee  : Extended ; { eccentricity }
  cg  : Extended ; { cos(g+h) }
  sg  : Extended ; { sin(g+h) }
  ch  : Extended ; { cos(h) }
  sh  : Extended ; { sin(h) }
  qb  : Extended ; { temporary variable }
  qc  : Extended ; { temporary variable }
begin

  ToSumDerivations(argval,argvel); { dS/d(a e \delta l g h) }

  { some numerical values for our variables }

  ee:=eccmow[1];                { global UnTypVar eccentricity }
  cg:=Cos(argval[2]+argval[3]); { cos(g+h) }
  sg:=Sin(argval[2]+argval[3]); { sin(g+h) }
  ch:=Cos(argval[3]);           { cos(h) }
  sh:=Sin(argval[3]);           { sin(h) }

  { derivations with respect to action variables L G H
    procedure deiler.ToGetDerSel is called from UnVakOsc }

  with  deiler  do            { deiler of class TDeil UnitDeil }
    begin                     { d a e d one[1..3]  /dL /dG /dH }
         { dS/dL=dS/da*da/dL+dS/de*de/dL+dS/d\delta*d\delta/dL }
      dfbl:=dfda*daone[1]+dfde*deone[1]+dfdd*ddone[1]; { dS/dL }
         { dS/dG=dS/da*da/dG+dS/de*de/dG+dS/d\delta*d\delta/dG }
      dfbg:=dfda*daone[2]+dfde*deone[2]+dfdd*ddone[2]; { dS/dG }
         { dS/dH=dS/da*da/dH+dS/de*de/dH+dS/d\delta*d\delta/dH }
      dfbh:=dfda*daone[3]+dfde*deone[3]+dfdd*ddone[3]; { dS/dH }
    end;

  { the first
    Poisson brackett \Delta a = [ a , S ]
    [ a , S ] = dS/dl*da/dL+dS/dg*da/dG+dS/dh*da/dH }

  with  deiler  do                { deiler of TDeil class UnitDeil }
    elmdif[1]:=+dfdl*daone[1]     { deiler.daone[1] da/dL }
               +dfdg*daone[2]     { deiler.daone[2] da/dG }
               +dfdh*daone[3];    { deiler.daone[3] da/dH }
  elmout[1]:=elmsin[1]+elmdif[1]; { plus short periodic terms }

  { the second equation Poisson brackett
    \Delta (l+g+h) = [ l+g+h , S ] = -dS/dL-dS/dG-dS/dH }

  elmdif[2]:=-dfbl-dfbg-dfbh;     { from middle to osculat }
  elmout[2]:=elmsin[2]+elmdif[2]; { plus short periodic terms }

  { temporary values
    for the third and fourth Poisson bracketts
    \Delta e = [ e , S ] = dS/dl*de/dL+dS/dg*de/dG+dS/dh*de/dH }

  with  deiler  do  { deiler of TDeil class UnitDeil deone[1..3] }
    qb:=dfdl*deone[1]+dfdg*deone[2]+dfdh*deone[3]; { [e,S] L G H }
  qc:=ee*(dfbg+dfbh);                          { e*(dS/dG+dS/dH) }

  { the third  Poisson bracket
    \Delta (e*cos(g+h))
    = [ e*cos(g+h) , S ]
    = [ e , S ] * cos(g+h) + e * (dS/dG+dS/dH) * sin(g+h) }

  elmdif[3]:=+qb*cg+qc*sg;        { cos sin (g+h) }
  elmout[3]:=elmsin[3]+elmdif[3]; { plus short periodic terms }

  { the fourth Poisson bracket
    \Delta (e*sin(g+h))
    = [ e*sin(g+h) , S ]
    = [ e , S ] * sin(g+h) - e * (dS/dG+dS/dH) * cos(g+h) }

  elmdif[4]:=+qb*sg-qc*cg;        { sin cos (g+h) }
  elmout[4]:=elmsin[4]+elmdif[4]; { plus short periodic terms }

  { temporary values
    for the fifth and sixth Poisson bracketts
    \Delta \delta = [ \delta , S ]
     = dS/dl*d\delta/dL+dS/dg*d\delta/dG+dS/dh*d\delta/dH }

  with  deiler  do  { deiler of TDeil class UnitDeil ddone[1..3] }
    qb:=dfdl*ddone[1]+dfdg*ddone[2]+dfdh*ddone[3]; { [d,S] L G H }
  qc:=ceiler.ad*dfbh;    { \delta*dS/dH ceiler of TCeil UnitCeil }

  { the fifth  Poisson brackett
    \Delta (\delta*cos(h))
    = [ \delta*cos(h) , S ]
    = [ \delta , S ] * cos(h) + \delta * dS/dH * sin(h) }

  elmdif[5]:=+qb*ch+qc*sh;        { cos(h) sin(h) }
  elmout[5]:=elmsin[5]+elmdif[5]; { plus short periodic terms }

  { the sixth  Poisson brackett
    \Delta (\delta*sin(h))
    = [ \delta*sin(h) , S ]
    = [ \delta , S ] * sin(h) - \delta * dS/dH * cos(h) }

  elmdif[6]:=+qb*sh-qc*ch;        { sin(h) cos(h) }
  elmout[6]:=elmsin[6]+elmdif[6]; { plus short periodic terms }

end; // to add short periodic terms to set of nonsingular elements

{ only for Solar radiation pressure
  to sum term by term by using global variables
  argval for arguments l g h S_Z \lambda l l' F D
  forces for nonsingular elements
  a l+g+h e*cos(g+h) e*sin(g+h) s*cos(h) s*sin(h) }

procedure ToGetForceSolap ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            var  forces  : TVarSix ) ; { array[1..6] UnForTyp }
var
  ia  : Byte ;     { count for arguments array 1..9 }
  kt  : Word ;     { count for terms in hamiltonian rowcoh^[..] meccoh }
  rc  : TRowVar ;  { type UnTypVar current record from rowcoh^[..] }
  va  : Extended ; { current argument value in radian }
  sa  : Extended ; { value sin(Argument) }
  ca  : Extended ; { value cos(Argument) }
  ee  : Extended ; { eccentricity for forces }
  si  : Extended ; { sinus   inclination for forces }
  ci  : Extended ; { cosinus inclination for forces }
  cg  : Extended ; { cos(g+h) for forces }
  sg  : Extended ; { sin(g+h) for forces }
  ch  : Extended ; { cos(h) for forces }
  sh  : Extended ; { sin(h) for forces }
  ds  : Extended ; { full derivative dF/ds=(dF/ds)+(dF/dc)*(dc/ds) }
  fa  : Extended ; { dF/da+dF/ds*ds/da }
  fe  : Extended ; { dF/de+dF/ds*ds/de }
  fd  : Extended ; { dF/ds*ds/d\delta }
  qb  : Extended ; { temporary variable }
  qc  : Extended ; { temporary variable }
begin

  AllDerNullo ;    { initial nullo values to all partial derivations }
                   { perturbation due to the Solar radiation pressure }
  kt:=0;           { initial nullo term }
repeat             { term by term record by record }
  kt:=kt+1;        { the next number of record }
  rc:=rowaux^[kt]; { the next record to obtain forces }
                   { to sum l g h S_Z \lambda l l' F D }
  va:=0.0;         { initial nullo argument value }
  for ia:=1 to maxarg do { for all arguments }
    va:=va+rc.mar[ia]*argval[ia];   { value after sum in radian }
  sa:=Sin(va);     { sinus argument }
  ca:=Cos(va);     { cosinus argument }
  for ia:=1 to maxder do { for amplitudes with factor k_r*(A_midel/m_sat }
    rc.amp[ia]:=satarama*rc.amp[ia]; { factor UnForSop for Solar pressure }
  AllDerSum(rc,sa,ca); { values to partial derivations dF/d(a,e,s,c,l,g,h) }
until  kt = mecaux ; { the last record }

  { some numerical values for our variables }
  ee:=eccmow[1]; { global UnTypVar eccentricity }
  si:=sinmow[1]; { global UnTypVar sinus   inclination }
  ci:=cosmow[1]; { global UnTypVar cosinus inclination }
  cg:=Cos(argval[2]+argval[3]); { cos(g+h) }
  sg:=Sin(argval[2]+argval[3]); { sin(g+h) }
  ch:=Cos(argval[3]); { cos(h) }
  sh:=Sin(argval[3]); { sin(h) }

  { full partial derivative ( with dfds dfdc si ci )
    dF/ds=(dF/ds)+(dF/dc)*(dc/ds) where dc/ds=-(s/c) }
  ds:=dfds-(si/ci)*dfdc; { dF/ds with sin and cosinus inclination }
  { auxiliary values by using global var from UnVakDes }
  fa:=dfda+ds*dersa; { dF/da+dF/ds*ds/da UnVakdes ForDerParms }
  fe:=dfde+ds*derse; { dF/de+dF/ds*ds/de UnVakdes ForDerParms }
  fd:=ds*dersd;      { dF/d\delta = dF/ds*ds/d\delta UnVakdes }

  { derivations with respect to action variables L G H
    procedure deiler.ToGetDerSel is called from UnRights }
  with  deiler  do { deiler of class TDeil UnitDeil }
    begin          { d a e d one[1..3]  /dL /dG /dH }
      { dF/dL=dF/da*da/dL+dF/de*de/dL+dF/d\delta*d\delta/dL }
      dfbl:=fa*daone[1]+fe*deone[1]+fd*ddone[1]; { dF/dL deiler.daone }
      { dF/dG=dF/da*da/dG+dF/de*de/dG+dF/d\delta*d\delta/dG }
      dfbg:=fa*daone[2]+fe*deone[2]+fd*ddone[2]; { dF/dG deiler.deone }
      { dF/dH=dF/da*da/dH+dF/de*de/dH+dF/d\delta*d\delta/dH }
      dfbh:=fa*daone[3]+fe*deone[3]+fd*ddone[3]; { dF/dH deiler.ddone }
    end;

  { forces due to Solar pressure for  our six equations
    where  dfdl dF/dl dfdg dF/dg dfdh dF/dh derivations }

  { the first  equation
    da/dt = dF/dl*da/dL+dF/dg*da/dG+dF/dh*da/dH }
  with  deiler  do  { deiler of TDeil class UnitDeil }
    forces[1]:=+dfdl*daone[1]  { deiler.daone[1] da/dL }
               +dfdg*daone[2]  { deiler.daone[2] da/dG }
               +dfdh*daone[3]; { deiler.daone[3] da/dH }

  { the second equation
    d(l+g+h)/dt = -dF/dL-dF/dG-dF/dH }
  forces[2]:=-dfbl-dfbg-dfbh;

  { temporary values
    for the third and fourth equations
    de/dt = dF/dl*de/dL+dF/dg*de/dG+dF/dh*de/dH }
  with  deiler  do  { deiler of TDeil class UnitDeil deone[1..3] }
    qb:=dfdl*deone[1]+dfdg*deone[2]+dfdh*deone[3]; { de/dt L G H }
  qc:=ee*(dfbg+dfbh);           { e*(dF/dG+dF/dH) }

  { the third  equation  d(e*cos(g+h))/dt }
  forces[3]:=+qb*cg+qc*sg; { cos sin (g+h) }

  { the fourth equation  d(e*sin(g+h))/dt }
  forces[4]:=+qb*sg-qc*cg; { sin cos (g+h) }

  { temporary values
    for the fifth and sixth equations
    d\delta/dt = dF/dl*d\delta/dL+dF/dg*d\delta/dG+dF/dh*d\delta/dH }
  with  deiler  do  { deiler of TDeil class UnitDeil ddone[1..3] }
    qb:=dfdl*ddone[1]+dfdg*ddone[2]+dfdh*ddone[3]; { dd/dt L G H }
  qc:=ceiler.ad*dfbh;      { \delta*dF/dH ceiler of TCeil UnitCeil }
                           { ceiler of class TCeil from UnitCeil }
  { the fifth  equation  d(\delta*cos(h))/dt }
  forces[5]:=+qb*ch+qc*sh; { cos(h) sin(h) }

  { the sixth  equation  d(\delta*sin(h))/dt }
  forces[6]:=+qb*sh-qc*ch; { sin(h) cos(h) }

end;

{ only for Solar radiation pressure
  to sum term by term by using global variables
  argval for arguments l g h S_Z \lambda l l' F D
  argvel d(l g h S_Z \lambda l l' F D)/dt rad/s
  short periodic terms for nonsingular elements
  a l+g+h e*cos(g+h) e*sin(g+h) s*cos(h) s*sin(h)
  output corrections to nonsingular elements elmdif of TVarSix }

procedure ToGetShortSolap ( argval  : TValArg ;        { array[1..9] UnTypVar }
                            argvel  : TValArg ;        { array[1..9] UnTypVar }
                            var  elmdif  : TVarSix ) ; { array[1..6] UnForTyp }
var
  ia  : Byte ;     // count for arguments array 1..9
  kt  : Word ;     // count for terms in hamiltonian rowone^[..] mecone
  rc  : TRowVar ;  // type UnTypVar current record from rowone^[..]
  va  : Extended ; // current argument value in radian
  vv  : Extended ; // current argument velosity in rad/s
  sa  : Extended ; // value sin(Argument)
  ca  : Extended ; // value cos(Argument)
  vz  : Extended ; // value -1/(velosity^2)
  ee  : Extended ; { eccentricity }
  cg  : Extended ; { cos(g+h) }
  sg  : Extended ; { sin(g+h) }
  ch  : Extended ; { cos(h) }
  sh  : Extended ; { sin(h) }
  qb  : Extended ; { temporary variable }
  qc  : Extended ; { temporary variable }
begin

  AllDerNullo ;     { initial nullo values to all partial derivations }
                    { in array rowtmp^ are the terms for Solar pressure }
  kt:=0;            { initial nullo term }
repeat              { term by term record by record }
  kt:=kt+1;         { the next number of record }
  rc:=rowtmp^[kt];  { to obtain short periodic perturbation }
  va:=0.0;          { initial nullo argument value }
  vv:=0.0;          { initial nullo velosity value }
  for ia:=1 to 9 do { arguments l g h S_Z \lambda l l' F D }
    begin
      va:=va+rc.mar[ia]*argval[ia]; { value after sum in radian }
      vv:=vv+rc.mar[ia]*argvel[ia]; { velos after sum in radian }
    end;
  sa:=Sin(va);                    { sinus argument }
  ca:=Cos(va);                    { cosinus argument }
  rvel:=1.0/vv;   { denominator 1/(d(arg)/dt) }
  vz:=-Sqr(rvel); { value -1/(velosity^2) }
  { for derivations denominator to a e \delta }
  drva:=vz*(rc.mar[1]*delmer.dval[2]   // i_1*d/da(dl/dt)
           +rc.mar[2]*delmer.dvag[2]   // i_2*d/da(dg/dt)
           +rc.mar[3]*delmer.dvah[2]); // i_3*d/da(dh/dt)
  drve:=vz*(rc.mar[1]*delmer.dval[3]   // i_1*d/de(dl/dt)
           +rc.mar[2]*delmer.dvag[3]   // i_2*d/de(dg/dt)
           +rc.mar[3]*delmer.dvah[3]); // i_3*d/de(dh/dt)
  drvd:=vz*(rc.mar[1]*delmer.dval[4]   // i_1*d/d\delta(dl/dt)
           +rc.mar[2]*delmer.dvag[4]   // i_2*d/d\delta(dg/dt)
           +rc.mar[3]*delmer.dvah[4]); // i_3*d/d\delta(dh/dt)
                         { k_r*(A_midel/m_sat factor UnForSop }
  for ia:=1 to maxder do { for amplitudes with factor }
    rc.amp[ia]:=satarama*rc.amp[ia]; { for Solar pressure }
                       { dfdl dS/dl dfdg dS/dg dfdh dS/dh derivations }
  AllShortP(rc,sa,ca); { partial derivations dS/d(a,e,\delta,l,g,h) }
until  kt = mectmp ;   { the last record }

  { some numerical values for our variables }

  ee:=eccmow[1];                { global UnTypVar eccentricity }
  cg:=Cos(argval[2]+argval[3]); { cos(g+h) }
  sg:=Sin(argval[2]+argval[3]); { sin(g+h) }
  ch:=Cos(argval[3]);           { cos(h) }
  sh:=Sin(argval[3]);           { sin(h) }

  { derivations with respect to action variables L G H
    procedure deiler.ToGetDerSel is called from UnVakOsc }

  with  deiler  do            { deiler of class TDeil UnitDeil }
    begin                     { d a e d one[1..3]  /dL /dG /dH }
         { dS/dL=dS/da*da/dL+dS/de*de/dL+dS/d\delta*d\delta/dL }
      dfbl:=dfda*daone[1]+dfde*deone[1]+dfdd*ddone[1]; { dS/dL }
         { dS/dG=dS/da*da/dG+dS/de*de/dG+dS/d\delta*d\delta/dG }
      dfbg:=dfda*daone[2]+dfde*deone[2]+dfdd*ddone[2]; { dS/dG }
         { dS/dH=dS/da*da/dH+dS/de*de/dH+dS/d\delta*d\delta/dH }
      dfbh:=dfda*daone[3]+dfde*deone[3]+dfdd*ddone[3]; { dS/dH }
    end;

  { the first
    Poisson brackett \Delta a = [ a , S ]
    [ a , S ] = dS/dl*da/dL+dS/dg*da/dG+dS/dh*da/dH }

  with  deiler  do                { deiler of TDeil class UnitDeil }
    elmdif[1]:=+dfdl*daone[1]     { deiler.daone[1] da/dL }
               +dfdg*daone[2]     { deiler.daone[2] da/dG }
               +dfdh*daone[3];    { deiler.daone[3] da/dH }

  { the second equation Poisson brackett
    \Delta (l+g+h) = [ l+g+h , S ] = -dS/dL-dS/dG-dS/dH }

  elmdif[2]:=-dfbl-dfbg-dfbh;     { from middle to osculat }

  { temporary values
    for the third and fourth Poisson bracketts
    \Delta e = [ e , S ] = dS/dl*de/dL+dS/dg*de/dG+dS/dh*de/dH }

  with  deiler  do  { deiler of TDeil class UnitDeil deone[1..3] }
    qb:=dfdl*deone[1]+dfdg*deone[2]+dfdh*deone[3]; { [e,S] L G H }
  qc:=ee*(dfbg+dfbh);                          { e*(dS/dG+dS/dH) }

  { the third  Poisson bracket
    \Delta (e*cos(g+h))
    = [ e*cos(g+h) , S ]
    = [ e , S ] * cos(g+h) + e * (dS/dG+dS/dH) * sin(g+h) }

  elmdif[3]:=+qb*cg+qc*sg;        { cos sin (g+h) }

  { the fourth Poisson bracket
    \Delta (e*sin(g+h))
    = [ e*sin(g+h) , S ]
    = [ e , S ] * sin(g+h) - e * (dS/dG+dS/dH) * cos(g+h) }

  elmdif[4]:=+qb*sg-qc*cg;        { sin cos (g+h) }

  { temporary values
    for the fifth and sixth Poisson bracketts
    \Delta \delta = [ \delta , S ]
     = dS/dl*d\delta/dL+dS/dg*d\delta/dG+dS/dh*d\delta/dH }

  with  deiler  do  { deiler of TDeil class UnitDeil ddone[1..3] }
    qb:=dfdl*ddone[1]+dfdg*ddone[2]+dfdh*ddone[3]; { [d,S] L G H }
  qc:=ceiler.ad*dfbh;    { \delta*dS/dH ceiler of TCeil UnitCeil }

  { the fifth  Poisson brackett
    \Delta (\delta*cos(h))
    = [ \delta*cos(h) , S ]
    = [ \delta , S ] * cos(h) + \delta * dS/dH * sin(h) }

  elmdif[5]:=+qb*ch+qc*sh;        { cos(h) sin(h) }

  { the sixth  Poisson brackett
    \Delta (\delta*sin(h))
    = [ \delta*sin(h) , S ]
    = [ \delta , S ] * sin(h) - \delta * dS/dH * cos(h) }

  elmdif[6]:=+qb*sh-qc*ch;        { sin(h) cos(h) }

end; { Solar pressure short periodic terms to nonsingular elements }

end.
