
 UNIT UnVakNuP ; { constant nutation 1980 sir Wahr position velosity }

 INTERFACE

 Uses
   UnConTyp ; { for type TFundArg }

 Function ToGetEpsiloM ( Tmjd  : Extended ) : Extended ; { in radian }

 Procedure FundArgPos ( Tmjd  : Extended ;
                        Var  FundArg : TFundArg ) ;

 Procedure ClcNutPos ( Tmjd : Extended ; { angles in radian }
                       Var  DeltaPsi , DeltaEps  : Extended ) ;

 Procedure FundArgVel ( Tmjd  : Extended ; { velosity in radian per second }
                        Var  VelArg : TFundArg ) ;

 Procedure ClcNutVel ( Tmjd : Extended ;   { velosity in radian per second }
                       Var  VelPsi , VelEps  : Extended ) ;

 function ToGetTetaV ( t  : Extended ) : Extended ;

 function ToGetZetaV ( t  : Extended ) : Extended ; { moment in mjd }

 IMPLEMENTATION

 Const
   { 1980 IAU Theory of Nutation  ( J. M. Wahr ) }
   NutArg   : Array [1..106,1..5] of ShortInt = { arguments }
            ( (   1 ,    0 ,    0 ,    0 ,    0 ) , 
              (   2 ,    0 ,    0 ,    0 ,    0 ) , 
              (   1 ,   -2 ,    0 ,    2 ,    0 ) , 
              (   0 ,    2 ,    0 ,   -2 ,    0 ) , 
              (   2 ,   -2 ,    0 ,    2 ,    0 ) , 
              (   0 ,    1 ,   -1 ,    0 ,   -1 ) , 
              (   1 ,    0 ,   -2 ,    2 ,   -2 ) ,
              (   1 ,    2 ,    0 ,   -2 ,    0 ) , 
              (   2 ,    0 ,    0 ,    2 ,   -2 ) , 
              (   0 ,    0 ,    1 ,    0 ,    0 ) , 
              (   2 ,    0 ,    1 ,    2 ,   -2 ) , 
              (   2 ,    0 ,   -1 ,    2 ,   -2 ) , 
              (   1 ,    0 ,    0 ,    2 ,   -2 ) , 
              (   0 ,    2 ,    0 ,    0 ,   -2 ) , 
              (   0 ,    0 ,    0 ,    2 ,   -2 ) , 
              (   0 ,    0 ,    2 ,    0 ,    0 ) , 
              (   1 ,    0 ,    1 ,    0 ,    0 ) ,
              (   2 ,    0 ,    2 ,    2 ,   -2 ) ,
              (   1 ,    0 ,   -1 ,    0 ,    0 ) , 
              (   1 ,   -2 ,    0 ,    0 ,    2 ) , 
              (   1 ,    0 ,   -1 ,    2 ,   -2 ) , 
              (   1 ,    2 ,    0 ,    0 ,   -2 ) , 
              (   1 ,    0 ,    1 ,    2 ,   -2 ) , 
              (   0 ,    1 ,    0 ,    0 ,   -1 ) , 
              (   0 ,    2 ,    1 ,    0 ,   -2 ) , 
              (   1 ,    0 ,    0 ,   -2 ,    2 ) ,
              (   0 ,    0 ,    1 ,   -2 ,    2 ) , 
              (   2 ,    0 ,    1 ,    0 ,    0 ) , 
              (   1 ,   -1 ,    0 ,    0 ,    1 ) , 
              (   0 ,    0 ,    1 ,    2 ,   -2 ) , 
              (   2 ,    0 ,    0 ,    2 ,    0 ) , 
              (   0 ,    1 ,    0 ,    0 ,    0 ) , 
              (   1 ,    0 ,    0 ,    2 ,    0 ) , 
              (   2 ,    1 ,    0 ,    2 ,    0 ) , 
              (   0 ,    1 ,    0 ,    0 ,   -2 ) , 
              (   2 ,   -1 ,    0 ,    2 ,    0 ) ,
              (   0 ,    0 ,    0 ,    0 ,    2 ) , 
              (   1 ,    1 ,    0 ,    0 ,    0 ) , 
              (   1 ,   -1 ,    0 ,    0 ,    0 ) , 
              (   2 ,   -1 ,    0 ,    2 ,    2 ) , 
              (   1 ,    1 ,    0 ,    2 ,    0 ) , 
              (   2 ,    0 ,    0 ,    2 ,    2 ) , 
              (   0 ,    2 ,    0 ,    0 ,    0 ) , 
              (   2 ,    1 ,    0 ,    2 ,   -2 ) , 
              (   2 ,    2 ,    0 ,    2 ,    0 ) ,
              (   0 ,    0 ,    0 ,    2 ,    0 ) , 
              (   1 ,   -1 ,    0 ,    2 ,    0 ) , 
              (   1 ,   -1 ,    0 ,    0 ,    2 ) , 
              (   1 ,    1 ,    0 ,    0 ,   -2 ) , 
              (   1 ,   -1 ,    0 ,    2 ,    2 ) , 
              (   0 ,    1 ,    1 ,    0 ,   -2 ) , 
              (   2 ,    0 ,    1 ,    2 ,    0 ) , 
              (   2 ,    0 ,   -1 ,    2 ,    0 ) , 
              (   2 ,    1 ,    0 ,    2 ,    2 ) ,
              (   0 ,    1 ,    0 ,    0 ,    2 ) , 
              (   2 ,    2 ,    0 ,    2 ,   -2 ) , 
              (   1 ,    0 ,    0 ,    0 ,    2 ) , 
              (   1 ,    0 ,    0 ,    2 ,    2 ) , 
              (   1 ,    1 ,    0 ,    2 ,   -2 ) , 
              (   1 ,    0 ,    0 ,    0 ,   -2 ) , 
              (   0 ,    1 ,   -1 ,    0 ,    0 ) , 
              (   1 ,    2 ,    0 ,    2 ,    0 ) , 
              (   0 ,    0 ,    1 ,    0 ,   -2 ) , 
              (   0 ,    1 ,    0 ,   -2 ,    0 ) ,
              (   0 ,    0 ,    0 ,    0 ,    1 ) , 
              (   0 ,    1 ,    1 ,    0 ,    0 ) , 
              (   0 ,    1 ,    0 ,    2 ,    0 ) , 
              (   2 ,    1 ,   -1 ,    2 ,    0 ) , 
              (   2 ,   -1 ,   -1 ,    2 ,    2 ) , 
              (   1 ,   -2 ,    0 ,    0 ,    0 ) , 
              (   2 ,    3 ,    0 ,    2 ,    0 ) , 
              (   2 ,    0 ,   -1 ,    2 ,    2 ) ,
              (   2 ,    1 ,    1 ,    2 ,    0 ) , 
              (   1 ,   -1 ,    0 ,    2 ,   -2 ) , 
              (   1 ,    2 ,    0 ,    0 ,    0 ) , 
              (   2 ,    1 ,    0 ,    0 ,    0 ) , 
              (   0 ,    3 ,    0 ,    0 ,    0 ) , 
              (   2 ,    0 ,    0 ,    2 ,    1 ) , 
              (   2 ,   -1 ,    0 ,    0 ,    0 ) , 
              (   0 ,    1 ,    0 ,    0 ,   -4 ) , 
              (   2 ,   -2 ,    0 ,    2 ,    2 ) , 
              (   2 ,   -1 ,    0 ,    2 ,    4 ) , 
              (   0 ,    2 ,    0 ,    0 ,   -4 ) ,
              (   2 ,    1 ,    1 ,    2 ,   -2 ) , 
              (   1 ,    1 ,    0 ,    2 ,    2 ) , 
              (   2 ,   -2 ,    0 ,    2 ,    4 ) , 
              (   2 ,   -1 ,    0 ,    4 ,    0 ) , 
              (   0 ,    1 ,   -1 ,    0 ,   -2 ) , 
              (   1 ,    2 ,    0 ,    2 ,   -2 ) , 
              (   2 ,    2 ,    0 ,    2 ,    2 ) ,
              (   1 ,    1 ,    0 ,    0 ,    2 ) , 
              (   2 ,    0 ,    0 ,    4 ,   -2 ) , 
              (   2 ,    3 ,    0 ,    2 ,   -2 ) , 
              (   0 ,    1 ,    0 ,    2 ,   -2 ) , 
              (   1 ,    0 ,    1 ,    2 ,    0 ) , 
              (   1 ,   -1 ,   -1 ,    0 ,    2 ) , 
              (   1 ,    0 ,    0 ,   -2 ,    0 ) , 
              (   2 ,    0 ,    0 ,    2 ,   -1 ) , 
              (   0 ,    0 ,    1 ,    0 ,    2 ) , 
              (   0 ,    1 ,    0 ,   -2 ,   -2 ) , 
              (   1 ,    0 ,   -1 ,    2 ,    0 ) , 
              (   1 ,    1 ,    1 ,    0 ,   -2 ) ,
              (   0 ,    1 ,    0 ,   -2 ,    2 ) , 
              (   0 ,    2 ,    0 ,    0 ,    2 ) , 
              (   2 ,    0 ,    0 ,    2 ,    4 ) , 
              (   0 ,    0 ,    1 ,    0 ,    1 ) ) ;
   { 1980 IAU Theory of Nutation  ( J. M. Wahr ) }
   CoefNut  : Array [1..106,1..4] of Single = { amplitudes }
    ( (   -17.199600 ,     -0.017420 ,      9.202500 ,      0.000890 ) , 
      (     0.206200 ,      0.000020 ,     -0.089500 ,      0.000050 ) , 
      (     0.004600 ,      0.000000 ,     -0.002400 ,      0.000000 ) , 
      (     0.001100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000300 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (    -0.000300 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000200 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -1.318700 ,     -0.000160 ,      0.573600 ,     -0.000310 ) , 
      (     0.142600 ,     -0.000340 ,      0.005400 ,     -0.000010 ) , 
      (    -0.051700 ,      0.000120 ,      0.022400 ,     -0.000060 ) , 
      (     0.021700 ,     -0.000050 ,     -0.009500 ,      0.000030 ) , 
      (     0.012900 ,      0.000010 ,     -0.007000 ,      0.000000 ) ,
      (     0.004800 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (    -0.002200 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.001700 ,     -0.000010 ,      0.000000 ,      0.000000 ) , 
      (    -0.001500 ,      0.000000 ,      0.000900 ,      0.000000 ) , 
      (    -0.001600 ,      0.000010 ,      0.000700 ,      0.000000 ) ,
      (    -0.001200 ,      0.000000 ,      0.000600 ,      0.000000 ) , 
      (    -0.000600 ,      0.000000 ,      0.000300 ,      0.000000 ) , 
      (    -0.000500 ,      0.000000 ,      0.000300 ,      0.000000 ) , 
      (     0.000400 ,      0.000000 ,     -0.000200 ,      0.000000 ) , 
      (     0.000400 ,      0.000000 ,     -0.000200 ,      0.000000 ) , 
      (    -0.000400 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.227400 ,     -0.000020 ,      0.097700 ,     -0.000050 ) , 
      (     0.071200 ,      0.000010 ,     -0.000700 ,      0.000000 ) ,
      (    -0.038600 ,     -0.000040 ,      0.020000 ,      0.000000 ) , 
      (    -0.030100 ,      0.000000 ,      0.012900 ,     -0.000010 ) , 
      (    -0.015800 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (     0.012300 ,      0.000000 ,     -0.005300 ,      0.000000 ) ,
      (     0.006300 ,      0.000000 ,     -0.000200 ,      0.000000 ) , 
      (     0.006300 ,      0.000010 ,     -0.003300 ,      0.000000 ) , 
      (    -0.005800 ,     -0.000010 ,      0.003200 ,      0.000000 ) , 
      (    -0.005900 ,      0.000000 ,      0.002600 ,      0.000000 ) , 
      (    -0.005100 ,      0.000000 ,      0.002700 ,      0.000000 ) , 
      (    -0.003800 ,      0.000000 ,      0.001600 ,      0.000000 ) , 
      (     0.002900 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (     0.002900 ,      0.000000 ,     -0.001200 ,      0.000000 ) , 
      (    -0.003100 ,      0.000000 ,      0.001300 ,      0.000000 ) , 
      (     0.002600 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (     0.002100 ,      0.000000 ,     -0.001000 ,      0.000000 ) , 
      (     0.001600 ,      0.000000 ,     -0.000800 ,      0.000000 ) , 
      (    -0.001300 ,      0.000000 ,      0.000700 ,      0.000000 ) , 
      (    -0.001000 ,      0.000000 ,      0.000500 ,      0.000000 ) , 
      (    -0.000700 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (     0.000700 ,      0.000000 ,     -0.000300 ,      0.000000 ) , 
      (    -0.000700 ,      0.000000 ,      0.000300 ,      0.000000 ) , 
      (    -0.000800 ,      0.000000 ,      0.000300 ,      0.000000 ) ,
      (     0.000600 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000600 ,      0.000000 ,     -0.000300 ,      0.000000 ) , 
      (    -0.000600 ,      0.000000 ,      0.000300 ,      0.000000 ) , 
      (    -0.000700 ,      0.000000 ,      0.000300 ,      0.000000 ) ,
      (     0.000600 ,      0.000000 ,     -0.000300 ,      0.000000 ) , 
      (    -0.000500 ,      0.000000 ,      0.000300 ,      0.000000 ) , 
      (     0.000500 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000500 ,      0.000000 ,      0.000300 ,      0.000000 ) , 
      (    -0.000400 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000400 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000400 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000300 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000300 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000300 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (    -0.000300 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (    -0.000200 ,      0.000000 ,      0.000100 ,      0.000000 ) ,
      (    -0.000300 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (    -0.000300 ,      0.000000 ,      0.000100 ,      0.000000 ) ,
      (     0.000200 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (    -0.000200 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (     0.000200 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (    -0.000200 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (     0.000200 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000200 ,      0.000000 ,     -0.000100 ,      0.000000 ) ,
      (     0.000100 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (    -0.000200 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,     -0.000100 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000100 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,     -0.000100 ,      0.000000 ) ,
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) , 
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (    -0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ,
      (     0.000100 ,      0.000000 ,      0.000000 ,      0.000000 ) ) ;

 Function ToGetEpsiloM ( Tmjd  : Extended ) : Extended ; { in radian }
 Var
   dt,dt2,dt3  : Extended ;
 Begin { constant SecRad from UnConTyp }
   dt:=(Tmjd-51544.5e0)/36525.0e0;
   dt2:=dt*dt;
   dt3:=dt*dt2;
   ToGetEpsiloM:=SecRad*(84381.448-46.8150*dt-0.00059*dt2+0.001813*dt3);
 End;

 { FundArgPos is a procedure
   to calculate Fundamental Arguments in radians
      on moment Tmjd in Modified Julian Date.
      FundArg[1..5] is massive of the values of arguments.
      global const - GraRad - for change from degrees to radians. }

 Procedure FundArgPos ( Tmjd  : Extended ;
                        Var  FundArg : TFundArg ) ;
 Var
   r,dt,dt2,dt3 : Extended;
   i,l : Integer;
 Begin
   dt:=(Tmjd-51544.5e0)/36525.0e0;
   dt2:=sqr(dt);  dt3:=dt*dt2;
   FundArg[1]:=218.31643250e0+481267.8812772222e0*dt
                             -0.00161167e0*dt2+0.00000528e0*dt3;
   FundArg[2]:=134.96298139e0+477198.8673980556e0*dt
                             +0.00869722e0*dt2+0.00001778e0*dt3;
   FundArg[3]:=357.52772333e0+35999.05034e0*dt
                             -0.00016028e0*dt2-0.00000333e0*dt3;
   FundArg[4]:= 93.27191028e0+483202.0175380555e0*dt
                             -0.00368250e0*dt2+0.00000306e0*dt3;
   FundArg[5]:=297.85036306e0+445267.11148e0*dt
                             -0.00191417e0*dt2+0.00000528e0*dt3;
   for i:=1 to 5 do
     Begin
       r:=FundArg[i]; l:=Trunc(r/360.e0); FundArg[i]:=GraRad*(r-360.e0*l);
     End;
 End;

 { ClcNutPos is a procedure
   to calculate the parameters of nutation in longitude and obliquity
      and value of the mean obliquity in radians on the moment Tmjd.
      the arguments and coefficients
          of nutation theory are contained in the NutArg and CoefNut .
      global parameter - SecRad - for change from arcsecs to radians . }

 Procedure ClcNutPos ( Tmjd : Extended ; { angles in radian }
                       Var  DeltaPsi , DeltaEps  : Extended ) ;
 Var
   i,k : Integer;
   r,dt   : Extended ;
   FundArg      : TFundArg ; { type from UnConTyp }
 Begin
   FundArgPos(Tmjd,FundArg);
   dt:=(Tmjd-51544.5e0)/36525.0e0;
   DeltaPsi:=0.e0;
   DeltaEps:=0.e0;
   for k:=1 to 106 do
     Begin
       r:=NutArg[k,1]*(FundArg[1]-FundArg[4]);
       for i:=2 to 5 do  r:=r+NutArg[k,i]*FundArg[i];
       DeltaPsi:=DeltaPsi+(CoefNut[k,1]
                       +dt*CoefNut[k,2])*Sin(r);
       DeltaEps:=DeltaEps+(CoefNut[k,3]
                       +dt*CoefNut[k,4])*Cos(r);
     End;
   DeltaPsi:=SecRad*DeltaPsi; { in radian }
   DeltaEps:=SecRad*DeltaEps;
 End;

 { to calculate velosity of the fundamental argument
   d(\lambda)/dt d(l_M)/dt d(l'_S)/dt d(F)/dt d(D)/dt in radian per second }

 Procedure FundArgVel ( Tmjd  : Extended ; { velosity in radian per second }
                        Var  VelArg : TFundArg ) ; { time in mjd }
 Var
   i  : Byte ;
   r,dt,dt2  : Extended ;
 Begin
   dt:=(Tmjd-51544.5e0)/36525.0e0;
   dt2:=Sqr(dt);
   VelArg[1]:= 481267.8812772222e0              { degree per century }
              -2*0.00161167e0*dt+3*0.00000528e0*dt2; { d(\lambda)/dt }
   VelArg[2]:= 477198.8673980556e0              { degree per century }
              +2*0.00869722e0*dt+3*0.00001778e0*dt2; { d(l_M)dt }
   VelArg[3]:= 35999.05034e0                    { degree per century }
              -2*0.00016028e0*dt-3*0.00000333e0*dt2; { d(l'_S)/dt }
   VelArg[4]:= 483202.0175380555e0              { degree per century }
              -2*0.00368250e0*dt+3*0.00000306e0*dt2; { d(F)/dt }
   VelArg[5]:= 445267.11148e0                   { degree per century }
              -2*0.00191417e0*dt+3*0.00000528e0*dt2; { d(D)/dt }
   r:=GraRad/(86400.0*36525.0); { simple factor }
   for i:=1 to 5 do             { from degree per century }
     VelArg[i]:=r*VelArg[i];    {   to radian per  second }
 End;

 { to calculate velosity of the nutation parameter
   d(\Delta\psi)/dt d(\Delta\epsilon)/dt in radian per second }

 Procedure ClcNutVel ( Tmjd : Extended ;   { velosity in radian per second }
                       Var  VelPsi , VelEps  : Extended ) ; { time in mjd }
 Var
   i,k     : Byte ;
   r,v,dt  : Extended ;
   PosArg  : TFundArg ; { type from UnConTyp }
   VelArg  : TFundArg ; { type from UnConTyp }
 Begin
   FundArgPos(Tmjd,PosArg); { fundamental arguments \lambda l_M l'_S F D }
   FundArgVel(Tmjd,VelArg); { velosity f. arguments \lambda l_M l'_S F D }
   dt:=(Tmjd-51544.5e0)/36525.0e0;
   VelPsi:=0.0e0;
   VelEps:=0.0e0;
   for k:=1 to 106 do
     Begin
       r:=NutArg[k,1]*(PosArg[1]-PosArg[4]); { \Omega=\lambda-F position }
       v:=NutArg[k,1]*(VelArg[1]-VelArg[4]); { \Omega=\lambda-F velosity }
       for i:=2 to 5 do                      { other arguments }
         begin                               { l_M l'_S F D }
           r:=r+NutArg[k,i]*PosArg[i];       { sum for position radian }
           v:=v+NutArg[k,i]*VelArg[i]        { sum for velosity rad/sec }
         end;
       VelPsi:=VelPsi                                 { arcsec per second }
               +v*(CoefNut[k,1]+dt*CoefNut[k,2])*Cos(r); { d(\Delta\psi)/dt }
       VelEps:=VelEps                                 { arcsec per second }
               -v*(CoefNut[k,3]+dt*CoefNut[k,4])*Sin(r); { d(\D\epsilon)/dt }
     End;
   VelPsi:=SecRad*VelPsi; { in radian per second UnConTyp }
   VelEps:=SecRad*VelEps; { in radian per second UnConTyp }
 End;

 { to get value d(\theta)/dt
   for velosity precession angle \theta in radian per second }

 function ToGetTetaV ( t  : Extended ) : Extended ; { moment in mjd }
 var
   d  : Extended ;
   v  : Extended ;
 begin
   d:=(t-51544.5e0)/36525.0e0; { difference with mjd moment in century }
   v:=2004.3109-(2*0.42665+3*0.041833*d)*d; { arcsec per century }
   ToGetTetaV:=SecRad*v/(86400.0*36525.0); { to radian per second }
 end;

 { to get value d(z_A)/dt+d(\zeta_A)/dt
   for velosity precession angle z_A \zeta_A in radian per second }

 function ToGetZetaV ( t  : Extended ) : Extended ; { moment in mjd }
 var
   d  : Extended ; { simple difference }
   r  : extended ; { temporary value }
   v  : Extended ; { temporary value }
 begin
   d:=(t-51544.5e0)/36525.0e0; { difference with mjd moment in century }
   r:=2*2306.2181; { in second of arc with factor 2 for z_A+\zeta_A }
   v:=r+(2*0.30188+3*0.017998*d)*d; { arcsec per century \zeta_A }
   v:=v+(2*1.09468+3*0.018203*d)*d; { the same but \zeta_A+z_A }
   ToGetZetaV:=SecRad*v/(86400.0*36525.0); { to radian per second }
 end;

 END.
