unit unvaksha ; { for shadow cases }
interface
uses
  UnConTyp , { for type TVect3 and constants }
  UnForTyp ; { for type TVarSix global IntTime SelTerM TruEquT }
const
  maxshadow  = 31 ; { maximum shadow cases for one step with EverGrator }
var { global variables for unit unvashad }
  numshadow  : byte ; { current number of shadow cases }
  shadowone  : array[1..maxshadow] of extended ; { start  shadow }
  shadowtwo  : array[1..maxshadow] of extended ; { finish shadow }
  shadowcor  : array[1..maxshadow] of tvarsix ;  { corrections }
{ input tc moment in second from start date 
        xp position of the satellite in true equator system }
function BooShadow( tc  : Extended ;  xp  : TVect3 ) : Boolean ;
implementation
uses
  UnEph405 , { some constants and procedure for the Sun }
  UnRotatM , { procedure ToObtainRotMats for SelTerMatrix }
  UnFotrua , { procedure ToObtainTruEquT }
  UnForFun ; { some mathematical functions }
{ input tc moment in second from start date IntTime.begday julian }
function BooShadow( tc  : Extended ;  xp  : TVect3 ) : Boolean ;
var           { only for satellite xp position in true equator }
  i  : Byte ; { this function is called by }
  xs,xa  : TVect3 ; { the Sun positions in any system }
  xe,vv  : tvect3 ; { the Earth position temporary velosity }
  ps,pe  : TVect3 ; { the Sun the Earth refer to the satellite }
  td,tb  : extended ; { moment TDB and with delay in julian day }
  rs,re  : Extended ; { simple ranges in kilometer }
  cb,sb  : Extended ; { for angle between two directories }
  rperp  : Extended ; { perpendicular }
  sperp  : Extended ; { range to perpendicular }
  rr,qq  : Extended ;
  ze,zs  : Extended ;
begin { xp[1..3] is satellite position refer to the centre of the Earth }
  BooShadow:=False;    { default }
                       { simple matrix from celestial to terrestrial }
  ToObtainRotMats(tc); { UnRotatM tc sec SelTerM from fixed to terra }
  ToObtainTruEquT(tc,TerEquT,TruEquT); { UnFotrua from true to terra }
  tb:=DatTime.TEph;    { moment in TDB global record UnForTyp julian day }
  td:=tb-8.32/1440.0;  { moment for the Sun position earlier 8.32 minute }
  PosVel405(NSun,td,xs,vv); { UnEph405 the Sun refer to barycentre }
  if  not BooExistPos405  then  Exit ; { no ephemeris UnEph405 }
  EarthB405(tb,xe,vv); { UnEph405 the Earth refer to barycentre }
  for i:=1 to 3 do { for three coordinates in celestial system }
    xs[i]:=xs[i]-xe[i]; { the Sun refer to the centre of the Earth }
  MultMatrVec(SelTerM,xs,xa); { from fixed to terra system  UnForFun }
  MultMatrVec(TruEquT,xp,xe); { the satellite to terrestrial system }
  for i:=1 to 3 do      { for three positions in terrestrial system }
    begin               { the Sun the Earth refer to satellite }
      ps[i]:=xa[i]-xe[i]; { the Sun refer to the satellite }
      pe[i]:=-xe[i]; { the centre of the Earth refer to the satellite }
    end;             { in terestrial system }
  rs:=VectorModul(ps); { range from satellite to the Sun }
  re:=VectorModul(pe); { range from satellite to the centre of the Earth }
  cb:=(ps[1]*pe[1]+ps[2]*pe[2]+ps[3]*pe[3])/(rs*re); { cos(beta) angle }
  if  cb < 0.0  then  Exit ; { no shadow BooShadow = False it is light }
  sb:=Sqrt(1-Sqr(cb)); { sin(beta) may be shadow }
  rperp:=re*sb; { length of perpendicular in km }
  sperp:=re*cb; { range from satellite to perpendicular }
  rr:=rs-sperp;  { range from the Sun to perpendicular }
  qq:=sperp/rr;   { the ratio }
  for i:=1 to 3 do { to line between the satellite and the Sun }
    xs[i]:=(xe[i]+qq*xa[i])/(1+qq); { vector perpendicular from the Earth }
  ze:=6402.0*(1-ParmA*Sqr(xs[3]/rperp)); { const UnConTyp }
  zs:=696000.0*sperp/rs; { projection the Sun radius UnEph405 }
  if  ( rperp < ( ze-zs) ) { to compare }
    then  BooShadow:=True; { full shadow case }
end;
end.
