
 { to obtain W(t) matrix = R_3(-s') * R_1(y_p) * R_2(x_p) }

 UNIT UnWM2000 ;

 INTERFACE

 Uses
   UnConTyp ; { TMatr33 }

 Procedure WMatr2000 ( dc , xc , yc   : Extended ;  Var  WMatr  : TMatr33 ) ;

 Procedure WMats2000 ( dc , xc , yc   : Extended ;  Var  WMatr  : TMatr33 ) ;

 IMPLEMENTATION

 Uses
   UnXYPole , { for pole theoretical }
   UnXYPolS , { for ToGetSPrime }
   UnForFun ; { for matrix procedures }

 { dc is current julian date
   xc and yc are current IERS value for pole motion xp yp in arcsec 
   full procedure when theoretical values
        xpole ypole in arcsec are calculated }

 Procedure WMatr2000 ( dc , xc , yc   : Extended ;  Var  WMatr  : TMatr33 ) ;
 Var
   s,x,y,xt,yt  : Extended ;
   sp,xp,yp,zp  : TMatr33 ;
 Begin
   s:=SecRad*ToGetSPrime(dc); { s'(t) from arcsec to radian }
   ForRotMatr(3,-s,sp); { R_3(-s') }
   PolarNutCor(dc,x,y); { from UnXYPole only correction }
   PolarTideCor(dc,xt,yt); { from UnXYPole only correction }
   x:=SecRad*(xc+x+xt); { to radian empiric + theoretic }
   y:=SecRad*(yc+y+yt); { to radian empiric + theoretic }
   ForRotMatr(2,x,xp); { R_2(x_p) }
   ForRotMatr(1,y,yp); { R_1(y_p) }
   ToMultMatr(yp,xp,zp); { R_1(y_p)*R_2(x_p) }
   ToMultMatr(sp,zp,WMatr); { W(t) = R_3(-s') * R_1(y_p) * R_2(x_p) }
 End;

 { dc is current julian date
   xc and yc are current IERS value for pole motion xp yp in arcsec
   more simple procedure when theoretical values
        xpole ypole in arcsec are not calculated }

 Procedure WMats2000 ( dc , xc , yc   : Extended ;  Var  WMatr  : TMatr33 ) ;
 Var
   s,x,y  : Extended ;
   sp,xp  : TMatr33 ;
   yp,zp  : TMatr33 ;
 Begin
   s:=SecRad*ToGetSPrime(dc); { s'(t) from arcsec to radian }
   ForRotMatr(3,-s,sp); { R_3(-s') }
   x:=SecRad*xc; { to radian empiric }
   y:=SecRad*yc; { to radian empiric }
   ForRotMatr(2,x,xp); { R_2(x_p) }
   ForRotMatr(1,y,yp); { R_1(y_p) }
   ToMultMatr(yp,xp,zp); { R_1(y_p)*R_2(x_p) }
   ToMultMatr(sp,zp,WMatr); { W(t) = R_3(-s') * R_1(y_p) * R_2(x_p) }
 End;

 END.
